/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 79 "cfg.y"


#include <stdlib.h>
#include <stdio.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#include "route.h"
#include "dprint.h"
#include "cfg_pp.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "pt_scaling.h"
#include "dset.h"
#include "pvar.h"
#include "blacklists.h"
#include "xlog.h"
#include "db/db_insertq.h"
#include "bin_interface.h"
#include "net/trans.h"
#include "config.h"
#include "mem/rpm_mem.h"
#include "poll_types.h"

#ifdef SHM_EXTRA_STATS
#include "mem/module_info.h"
#endif

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#undef MIN
#undef MAX

extern int yylex();
static void yyerror(char* s);
static void yyerrorf(char* fmt, ...);
static char* tmp;
static int i_tmp, rc;
static struct socket_id* lst_tmp;
static int rt;  /* Type of route block for find_export */
static str s_tmp;
static str tstr;
static struct net* net_tmp;
static pv_spec_t *spec;
static pv_elem_t *elem;
static struct bl_rule *bl_head = 0;
static struct bl_rule *bl_tail = 0;
static struct script_route_ref *rt_ref = NULL;

action_elem_t elems[MAX_ACTION_ELEMS];
static action_elem_t route_elems[MAX_ACTION_ELEMS];
action_elem_t *a_tmp;

struct port_range {
	int min;
	int max;
	struct port_range *next;
} *pr_tmp;

static inline void warn(char* s);
static struct socket_id* mk_listen_id(char*, enum sip_protos, int);
static struct socket_id* mk_listen_id_range(char*, enum sip_protos, struct port_range *);
static struct socket_id* set_listen_id_adv(struct socket_id *, char *, int);
static struct multi_str *new_string(char *s);
static struct port_range* mk_port_range(int, int);
static int parse_ipnet(char *in, int len, struct net **ipnet);

extern int line;
extern int column;
extern int startcolumn;
extern char *finame;

struct listen_param {
	enum si_flags flags;
	int workers;
	struct socket_id *socket;
	char *tag;
	char *auto_scaling_profile;
} p_tmp;
static void fill_socket_id(struct listen_param *param, struct socket_id *s);

union route_name_var {
	int iname;
	struct _pv_spec *sname;
	struct _pv_elem *ename;
	void *data;
} rn_tmp;

#ifndef SHM_EXTRA_STATS
struct multi_str{
	char *s;
	struct multi_str* next;
};
#else
static struct multi_str *tmp_mod;
#endif

#define get_cfg_file_name \
	((finame) ? finame : cfg_file ? cfg_file : "default")



#define mk_action_(_res, _type, _no, _elems) \
	do { \
		_res = mk_action(_type, _no, _elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action0(_res, _type) \
	do { \
		_res = mk_action(_type, 0, 0, line, get_cfg_file_name); \
	} while(0)
#define mk_action1(_res, _type, _p1_type, _p1) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		_res = mk_action(_type, 1, elems, line, get_cfg_file_name); \
	} while(0)
#define	mk_action2(_res, _type, _p1_type, _p2_type, _p1, _p2) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		_res = mk_action(_type, 2, elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action3(_res, _type, _p1_type, _p2_type, _p3_type, _p1, _p2, _p3) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		elems[2].type = _p3_type; \
		elems[2].u.data = _p3; \
		_res = mk_action(_type, 3, elems, line, get_cfg_file_name); \
	} while(0)

extern int cfg_parse_only_routes;
#define IFOR(_instr) \
	if (cfg_parse_only_routes==1) {_instr;break;}


#line 230 "cfg.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "cfg.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_DROP = 3,                       /* DROP  */
  YYSYMBOL_ASSERT = 4,                     /* ASSERT  */
  YYSYMBOL_EXIT = 5,                       /* EXIT  */
  YYSYMBOL_RETURN = 6,                     /* RETURN  */
  YYSYMBOL_LOG_TOK = 7,                    /* LOG_TOK  */
  YYSYMBOL_ERROR = 8,                      /* ERROR  */
  YYSYMBOL_ROUTE = 9,                      /* ROUTE  */
  YYSYMBOL_ROUTE_FAILURE = 10,             /* ROUTE_FAILURE  */
  YYSYMBOL_ROUTE_ONREPLY = 11,             /* ROUTE_ONREPLY  */
  YYSYMBOL_ROUTE_BRANCH = 12,              /* ROUTE_BRANCH  */
  YYSYMBOL_ROUTE_ERROR = 13,               /* ROUTE_ERROR  */
  YYSYMBOL_ROUTE_LOCAL = 14,               /* ROUTE_LOCAL  */
  YYSYMBOL_ROUTE_STARTUP = 15,             /* ROUTE_STARTUP  */
  YYSYMBOL_ROUTE_TIMER = 16,               /* ROUTE_TIMER  */
  YYSYMBOL_ROUTE_EVENT = 17,               /* ROUTE_EVENT  */
  YYSYMBOL_IF = 18,                        /* IF  */
  YYSYMBOL_ELSE = 19,                      /* ELSE  */
  YYSYMBOL_SWITCH = 20,                    /* SWITCH  */
  YYSYMBOL_CASE = 21,                      /* CASE  */
  YYSYMBOL_DEFAULT = 22,                   /* DEFAULT  */
  YYSYMBOL_BREAK = 23,                     /* BREAK  */
  YYSYMBOL_WHILE = 24,                     /* WHILE  */
  YYSYMBOL_FOR = 25,                       /* FOR  */
  YYSYMBOL_IN = 26,                        /* IN  */
  YYSYMBOL_READONLY = 27,                  /* READONLY  */
  YYSYMBOL_EXPIRE = 28,                    /* EXPIRE  */
  YYSYMBOL_NULLV = 29,                     /* NULLV  */
  YYSYMBOL_XDBG = 30,                      /* XDBG  */
  YYSYMBOL_XLOG = 31,                      /* XLOG  */
  YYSYMBOL_XLOG_BUF_SIZE = 32,             /* XLOG_BUF_SIZE  */
  YYSYMBOL_XLOG_FORCE_COLOR = 33,          /* XLOG_FORCE_COLOR  */
  YYSYMBOL_XLOG_PRINT_LEVEL = 34,          /* XLOG_PRINT_LEVEL  */
  YYSYMBOL_XLOG_LEVEL = 35,                /* XLOG_LEVEL  */
  YYSYMBOL_PV_PRINT_BUF_SIZE = 36,         /* PV_PRINT_BUF_SIZE  */
  YYSYMBOL_DEBUG_MODE = 37,                /* DEBUG_MODE  */
  YYSYMBOL_ENABLE_ASSERTS = 38,            /* ENABLE_ASSERTS  */
  YYSYMBOL_ABORT_ON_ASSERT = 39,           /* ABORT_ON_ASSERT  */
  YYSYMBOL_LOGLEVEL = 40,                  /* LOGLEVEL  */
  YYSYMBOL_LOGPREFIX = 41,                 /* LOGPREFIX  */
  YYSYMBOL_LOGSTDOUT = 42,                 /* LOGSTDOUT  */
  YYSYMBOL_LOGSTDERROR = 43,               /* LOGSTDERROR  */
  YYSYMBOL_STDERROR_ENABLED = 44,          /* STDERROR_ENABLED  */
  YYSYMBOL_SYSLOG_ENABLED = 45,            /* SYSLOG_ENABLED  */
  YYSYMBOL_LOG_EVENT_ENABLED = 46,         /* LOG_EVENT_ENABLED  */
  YYSYMBOL_STDERROR_LEVEL_FILTER = 47,     /* STDERROR_LEVEL_FILTER  */
  YYSYMBOL_SYSLOG_LEVEL_FILTER = 48,       /* SYSLOG_LEVEL_FILTER  */
  YYSYMBOL_LOG_EVENT_LEVEL_FILTER = 49,    /* LOG_EVENT_LEVEL_FILTER  */
  YYSYMBOL_STDERROR_FORMAT = 50,           /* STDERROR_FORMAT  */
  YYSYMBOL_SYSLOG_FORMAT = 51,             /* SYSLOG_FORMAT  */
  YYSYMBOL_LOG_JSON_BUF_SIZE = 52,         /* LOG_JSON_BUF_SIZE  */
  YYSYMBOL_LOG_MSG_BUF_SIZE = 53,          /* LOG_MSG_BUF_SIZE  */
  YYSYMBOL_LOGFACILITY = 54,               /* LOGFACILITY  */
  YYSYMBOL_SYSLOG_FACILITY = 55,           /* SYSLOG_FACILITY  */
  YYSYMBOL_LOGNAME = 56,                   /* LOGNAME  */
  YYSYMBOL_SYSLOG_NAME = 57,               /* SYSLOG_NAME  */
  YYSYMBOL_AVP_ALIASES = 58,               /* AVP_ALIASES  */
  YYSYMBOL_LISTEN = 59,                    /* LISTEN  */
  YYSYMBOL_SOCKET = 60,                    /* SOCKET  */
  YYSYMBOL_MEMGROUP = 61,                  /* MEMGROUP  */
  YYSYMBOL_ALIAS = 62,                     /* ALIAS  */
  YYSYMBOL_AUTO_ALIASES = 63,              /* AUTO_ALIASES  */
  YYSYMBOL_TAG = 64,                       /* TAG  */
  YYSYMBOL_DNS = 65,                       /* DNS  */
  YYSYMBOL_REV_DNS = 66,                   /* REV_DNS  */
  YYSYMBOL_DNS_TRY_IPV6 = 67,              /* DNS_TRY_IPV6  */
  YYSYMBOL_DNS_TRY_NAPTR = 68,             /* DNS_TRY_NAPTR  */
  YYSYMBOL_DNS_RETR_TIME = 69,             /* DNS_RETR_TIME  */
  YYSYMBOL_DNS_RETR_NO = 70,               /* DNS_RETR_NO  */
  YYSYMBOL_DNS_SERVERS_NO = 71,            /* DNS_SERVERS_NO  */
  YYSYMBOL_DNS_USE_SEARCH = 72,            /* DNS_USE_SEARCH  */
  YYSYMBOL_MAX_WHILE_LOOPS = 73,           /* MAX_WHILE_LOOPS  */
  YYSYMBOL_UDP_WORKERS = 74,               /* UDP_WORKERS  */
  YYSYMBOL_CHECK_VIA = 75,                 /* CHECK_VIA  */
  YYSYMBOL_SHM_HASH_SPLIT_PERCENTAGE = 76, /* SHM_HASH_SPLIT_PERCENTAGE  */
  YYSYMBOL_SHM_SECONDARY_HASH_SIZE = 77,   /* SHM_SECONDARY_HASH_SIZE  */
  YYSYMBOL_MEM_WARMING_ENABLED = 78,       /* MEM_WARMING_ENABLED  */
  YYSYMBOL_MEM_WARMING_PATTERN_FILE = 79,  /* MEM_WARMING_PATTERN_FILE  */
  YYSYMBOL_MEM_WARMING_PERCENTAGE = 80,    /* MEM_WARMING_PERCENTAGE  */
  YYSYMBOL_RPM_MEM_FILE = 81,              /* RPM_MEM_FILE  */
  YYSYMBOL_RPM_MEM_SIZE = 82,              /* RPM_MEM_SIZE  */
  YYSYMBOL_MEMLOG = 83,                    /* MEMLOG  */
  YYSYMBOL_MEMDUMP = 84,                   /* MEMDUMP  */
  YYSYMBOL_SHM_MEMLOG_SIZE = 85,           /* SHM_MEMLOG_SIZE  */
  YYSYMBOL_EXECMSGTHRESHOLD = 86,          /* EXECMSGTHRESHOLD  */
  YYSYMBOL_EXECDNSTHRESHOLD = 87,          /* EXECDNSTHRESHOLD  */
  YYSYMBOL_TCPTHRESHOLD = 88,              /* TCPTHRESHOLD  */
  YYSYMBOL_EVENT_SHM_THRESHOLD = 89,       /* EVENT_SHM_THRESHOLD  */
  YYSYMBOL_EVENT_PKG_THRESHOLD = 90,       /* EVENT_PKG_THRESHOLD  */
  YYSYMBOL_QUERYBUFFERSIZE = 91,           /* QUERYBUFFERSIZE  */
  YYSYMBOL_QUERYFLUSHTIME = 92,            /* QUERYFLUSHTIME  */
  YYSYMBOL_SIP_WARNING = 93,               /* SIP_WARNING  */
  YYSYMBOL_SERVER_SIGNATURE = 94,          /* SERVER_SIGNATURE  */
  YYSYMBOL_SERVER_HEADER = 95,             /* SERVER_HEADER  */
  YYSYMBOL_USER_AGENT_HEADER = 96,         /* USER_AGENT_HEADER  */
  YYSYMBOL_LOADMODULE = 97,                /* LOADMODULE  */
  YYSYMBOL_MPATH = 98,                     /* MPATH  */
  YYSYMBOL_MODPARAM = 99,                  /* MODPARAM  */
  YYSYMBOL_MAXBUFFER = 100,                /* MAXBUFFER  */
  YYSYMBOL_CHROOT = 101,                   /* CHROOT  */
  YYSYMBOL_WDIR = 102,                     /* WDIR  */
  YYSYMBOL_MHOMED = 103,                   /* MHOMED  */
  YYSYMBOL_POLL_METHOD = 104,              /* POLL_METHOD  */
  YYSYMBOL_TCP_ACCEPT_ALIASES = 105,       /* TCP_ACCEPT_ALIASES  */
  YYSYMBOL_TCP_WORKERS = 106,              /* TCP_WORKERS  */
  YYSYMBOL_TCP_CONNECT_TIMEOUT = 107,      /* TCP_CONNECT_TIMEOUT  */
  YYSYMBOL_TCP_CON_LIFETIME = 108,         /* TCP_CON_LIFETIME  */
  YYSYMBOL_TCP_SOCKET_BACKLOG = 109,       /* TCP_SOCKET_BACKLOG  */
  YYSYMBOL_TCP_MAX_CONNECTIONS = 110,      /* TCP_MAX_CONNECTIONS  */
  YYSYMBOL_TCP_NO_NEW_CONN_BFLAG = 111,    /* TCP_NO_NEW_CONN_BFLAG  */
  YYSYMBOL_TCP_NO_NEW_CONN_RPLFLAG = 112,  /* TCP_NO_NEW_CONN_RPLFLAG  */
  YYSYMBOL_TCP_KEEPALIVE = 113,            /* TCP_KEEPALIVE  */
  YYSYMBOL_TCP_KEEPCOUNT = 114,            /* TCP_KEEPCOUNT  */
  YYSYMBOL_TCP_KEEPIDLE = 115,             /* TCP_KEEPIDLE  */
  YYSYMBOL_TCP_KEEPINTERVAL = 116,         /* TCP_KEEPINTERVAL  */
  YYSYMBOL_TCP_MAX_MSG_TIME = 117,         /* TCP_MAX_MSG_TIME  */
  YYSYMBOL_TCP_PARALLEL_READ_ON_WORKERS = 118, /* TCP_PARALLEL_READ_ON_WORKERS  */
  YYSYMBOL_ADVERTISED_ADDRESS = 119,       /* ADVERTISED_ADDRESS  */
  YYSYMBOL_ADVERTISED_PORT = 120,          /* ADVERTISED_PORT  */
  YYSYMBOL_DISABLE_CORE = 121,             /* DISABLE_CORE  */
  YYSYMBOL_OPEN_FD_LIMIT = 122,            /* OPEN_FD_LIMIT  */
  YYSYMBOL_MCAST_LOOPBACK = 123,           /* MCAST_LOOPBACK  */
  YYSYMBOL_MCAST_TTL = 124,                /* MCAST_TTL  */
  YYSYMBOL_TOS = 125,                      /* TOS  */
  YYSYMBOL_DISABLE_DNS_FAILOVER = 126,     /* DISABLE_DNS_FAILOVER  */
  YYSYMBOL_DISABLE_DNS_BLACKLIST = 127,    /* DISABLE_DNS_BLACKLIST  */
  YYSYMBOL_DST_BLACKLIST = 128,            /* DST_BLACKLIST  */
  YYSYMBOL_DISABLE_STATELESS_FWD = 129,    /* DISABLE_STATELESS_FWD  */
  YYSYMBOL_DB_VERSION_TABLE = 130,         /* DB_VERSION_TABLE  */
  YYSYMBOL_DB_DEFAULT_URL = 131,           /* DB_DEFAULT_URL  */
  YYSYMBOL_DB_MAX_ASYNC_CONNECTIONS = 132, /* DB_MAX_ASYNC_CONNECTIONS  */
  YYSYMBOL_DISABLE_503_TRANSLATION = 133,  /* DISABLE_503_TRANSLATION  */
  YYSYMBOL_SYNC_TOKEN = 134,               /* SYNC_TOKEN  */
  YYSYMBOL_ASYNC_TOKEN = 135,              /* ASYNC_TOKEN  */
  YYSYMBOL_LAUNCH_TOKEN = 136,             /* LAUNCH_TOKEN  */
  YYSYMBOL_AUTO_SCALING_PROFILE = 137,     /* AUTO_SCALING_PROFILE  */
  YYSYMBOL_AUTO_SCALING_CYCLE = 138,       /* AUTO_SCALING_CYCLE  */
  YYSYMBOL_TIMER_WORKERS = 139,            /* TIMER_WORKERS  */
  YYSYMBOL_EQUAL = 140,                    /* EQUAL  */
  YYSYMBOL_EQUAL_T = 141,                  /* EQUAL_T  */
  YYSYMBOL_GT = 142,                       /* GT  */
  YYSYMBOL_LT = 143,                       /* LT  */
  YYSYMBOL_GTE = 144,                      /* GTE  */
  YYSYMBOL_LTE = 145,                      /* LTE  */
  YYSYMBOL_DIFF = 146,                     /* DIFF  */
  YYSYMBOL_MATCH = 147,                    /* MATCH  */
  YYSYMBOL_NOTMATCH = 148,                 /* NOTMATCH  */
  YYSYMBOL_COLONEQ = 149,                  /* COLONEQ  */
  YYSYMBOL_PLUSEQ = 150,                   /* PLUSEQ  */
  YYSYMBOL_MINUSEQ = 151,                  /* MINUSEQ  */
  YYSYMBOL_SLASHEQ = 152,                  /* SLASHEQ  */
  YYSYMBOL_MULTEQ = 153,                   /* MULTEQ  */
  YYSYMBOL_MODULOEQ = 154,                 /* MODULOEQ  */
  YYSYMBOL_BANDEQ = 155,                   /* BANDEQ  */
  YYSYMBOL_BOREQ = 156,                    /* BOREQ  */
  YYSYMBOL_BXOREQ = 157,                   /* BXOREQ  */
  YYSYMBOL_OR = 158,                       /* OR  */
  YYSYMBOL_AND = 159,                      /* AND  */
  YYSYMBOL_BOR = 160,                      /* BOR  */
  YYSYMBOL_BAND = 161,                     /* BAND  */
  YYSYMBOL_BXOR = 162,                     /* BXOR  */
  YYSYMBOL_BLSHIFT = 163,                  /* BLSHIFT  */
  YYSYMBOL_BRSHIFT = 164,                  /* BRSHIFT  */
  YYSYMBOL_PLUS = 165,                     /* PLUS  */
  YYSYMBOL_MINUS = 166,                    /* MINUS  */
  YYSYMBOL_MULT = 167,                     /* MULT  */
  YYSYMBOL_MODULO = 168,                   /* MODULO  */
  YYSYMBOL_NOT = 169,                      /* NOT  */
  YYSYMBOL_BNOT = 170,                     /* BNOT  */
  YYSYMBOL_NUMBER = 171,                   /* NUMBER  */
  YYSYMBOL_ZERO = 172,                     /* ZERO  */
  YYSYMBOL_ID = 173,                       /* ID  */
  YYSYMBOL_STRING = 174,                   /* STRING  */
  YYSYMBOL_SCRIPTVAR = 175,                /* SCRIPTVAR  */
  YYSYMBOL_IPV6ADDR = 176,                 /* IPV6ADDR  */
  YYSYMBOL_IPV4ADDR = 177,                 /* IPV4ADDR  */
  YYSYMBOL_IPNET = 178,                    /* IPNET  */
  YYSYMBOL_COMMA = 179,                    /* COMMA  */
  YYSYMBOL_SEMICOLON = 180,                /* SEMICOLON  */
  YYSYMBOL_RPAREN = 181,                   /* RPAREN  */
  YYSYMBOL_LPAREN = 182,                   /* LPAREN  */
  YYSYMBOL_LBRACE = 183,                   /* LBRACE  */
  YYSYMBOL_RBRACE = 184,                   /* RBRACE  */
  YYSYMBOL_LBRACK = 185,                   /* LBRACK  */
  YYSYMBOL_RBRACK = 186,                   /* RBRACK  */
  YYSYMBOL_SLASH = 187,                    /* SLASH  */
  YYSYMBOL_AS = 188,                       /* AS  */
  YYSYMBOL_USE_WORKERS = 189,              /* USE_WORKERS  */
  YYSYMBOL_USE_AUTO_SCALING_PROFILE = 190, /* USE_AUTO_SCALING_PROFILE  */
  YYSYMBOL_MAX = 191,                      /* MAX  */
  YYSYMBOL_MIN = 192,                      /* MIN  */
  YYSYMBOL_DOT = 193,                      /* DOT  */
  YYSYMBOL_CR = 194,                       /* CR  */
  YYSYMBOL_COLON = 195,                    /* COLON  */
  YYSYMBOL_ANY = 196,                      /* ANY  */
  YYSYMBOL_ANYCAST = 197,                  /* ANYCAST  */
  YYSYMBOL_FRAG = 198,                     /* FRAG  */
  YYSYMBOL_REUSE_PORT = 199,               /* REUSE_PORT  */
  YYSYMBOL_SCRIPTVARERR = 200,             /* SCRIPTVARERR  */
  YYSYMBOL_SCALE_UP_TO = 201,              /* SCALE_UP_TO  */
  YYSYMBOL_SCALE_DOWN_TO = 202,            /* SCALE_DOWN_TO  */
  YYSYMBOL_ON = 203,                       /* ON  */
  YYSYMBOL_CYCLES = 204,                   /* CYCLES  */
  YYSYMBOL_CYCLES_WITHIN = 205,            /* CYCLES_WITHIN  */
  YYSYMBOL_PERCENTAGE = 206,               /* PERCENTAGE  */
  YYSYMBOL_YYACCEPT = 207,                 /* $accept  */
  YYSYMBOL_cfg = 208,                      /* cfg  */
  YYSYMBOL_statements = 209,               /* statements  */
  YYSYMBOL_statement = 210,                /* statement  */
  YYSYMBOL_211_1 = 211,                    /* $@1  */
  YYSYMBOL_212_2 = 212,                    /* $@2  */
  YYSYMBOL_213_3 = 213,                    /* $@3  */
  YYSYMBOL_214_4 = 214,                    /* $@4  */
  YYSYMBOL_215_5 = 215,                    /* $@5  */
  YYSYMBOL_216_6 = 216,                    /* $@6  */
  YYSYMBOL_217_7 = 217,                    /* $@7  */
  YYSYMBOL_218_8 = 218,                    /* $@8  */
  YYSYMBOL_219_9 = 219,                    /* $@9  */
  YYSYMBOL_listen_id = 220,                /* listen_id  */
  YYSYMBOL_host_sep = 221,                 /* host_sep  */
  YYSYMBOL_host = 222,                     /* host  */
  YYSYMBOL_proto = 223,                    /* proto  */
  YYSYMBOL_port = 224,                     /* port  */
  YYSYMBOL_portrange = 225,                /* portrange  */
  YYSYMBOL_snumber = 226,                  /* snumber  */
  YYSYMBOL_phostport = 227,                /* phostport  */
  YYSYMBOL_phostportrange = 228,           /* phostportrange  */
  YYSYMBOL_alias_def = 229,                /* alias_def  */
  YYSYMBOL_id_lst = 230,                   /* id_lst  */
  YYSYMBOL_listen_id_def = 231,            /* listen_id_def  */
  YYSYMBOL_socket_def_param = 232,         /* socket_def_param  */
  YYSYMBOL_socket_def_params = 233,        /* socket_def_params  */
  YYSYMBOL_socket_def = 234,               /* socket_def  */
  YYSYMBOL_235_10 = 235,                   /* $@10  */
  YYSYMBOL_any_proto = 236,                /* any_proto  */
  YYSYMBOL_multi_string = 237,             /* multi_string  */
  YYSYMBOL_blst_elem = 238,                /* blst_elem  */
  YYSYMBOL_blst_def = 239,                 /* blst_def  */
  YYSYMBOL_blst_flag = 240,                /* blst_flag  */
  YYSYMBOL_blst_flags = 241,               /* blst_flags  */
  YYSYMBOL_blst_elem_list = 242,           /* blst_elem_list  */
  YYSYMBOL_auto_scale_profile_def = 243,   /* auto_scale_profile_def  */
  YYSYMBOL_assign_stm = 244,               /* assign_stm  */
  YYSYMBOL_module_stm = 245,               /* module_stm  */
  YYSYMBOL_ip = 246,                       /* ip  */
  YYSYMBOL_ipv4 = 247,                     /* ipv4  */
  YYSYMBOL_ipv6addr = 248,                 /* ipv6addr  */
  YYSYMBOL_ipv6 = 249,                     /* ipv6  */
  YYSYMBOL_ipnet = 250,                    /* ipnet  */
  YYSYMBOL_folded_string = 251,            /* folded_string  */
  YYSYMBOL_route_name = 252,               /* route_name  */
  YYSYMBOL_route_name_var = 253,           /* route_name_var  */
  YYSYMBOL_route_stm = 254,                /* route_stm  */
  YYSYMBOL_failure_route_stm = 255,        /* failure_route_stm  */
  YYSYMBOL_onreply_route_stm = 256,        /* onreply_route_stm  */
  YYSYMBOL_branch_route_stm = 257,         /* branch_route_stm  */
  YYSYMBOL_error_route_stm = 258,          /* error_route_stm  */
  YYSYMBOL_local_route_stm = 259,          /* local_route_stm  */
  YYSYMBOL_startup_route_stm = 260,        /* startup_route_stm  */
  YYSYMBOL_timer_route_stm = 261,          /* timer_route_stm  */
  YYSYMBOL_event_route_stm = 262,          /* event_route_stm  */
  YYSYMBOL_exp = 263,                      /* exp  */
  YYSYMBOL_equalop = 264,                  /* equalop  */
  YYSYMBOL_compop = 265,                   /* compop  */
  YYSYMBOL_matchop = 266,                  /* matchop  */
  YYSYMBOL_intop = 267,                    /* intop  */
  YYSYMBOL_strop = 268,                    /* strop  */
  YYSYMBOL_script_var = 269,               /* script_var  */
  YYSYMBOL_exp_elem = 270,                 /* exp_elem  */
  YYSYMBOL_exp_cond = 271,                 /* exp_cond  */
  YYSYMBOL_assignop = 272,                 /* assignop  */
  YYSYMBOL_assignexp = 273,                /* assignexp  */
  YYSYMBOL_assign_cmd = 274,               /* assign_cmd  */
  YYSYMBOL_exp_stm = 275,                  /* exp_stm  */
  YYSYMBOL_brk_stm = 276,                  /* brk_stm  */
  YYSYMBOL_stm = 277,                      /* stm  */
  YYSYMBOL_actions = 278,                  /* actions  */
  YYSYMBOL_brk_actions = 279,              /* brk_actions  */
  YYSYMBOL_action = 280,                   /* action  */
  YYSYMBOL_brk_action = 281,               /* brk_action  */
  YYSYMBOL_brk_if_cmd = 282,               /* brk_if_cmd  */
  YYSYMBOL_if_cmd = 283,                   /* if_cmd  */
  YYSYMBOL_while_cmd = 284,                /* while_cmd  */
  YYSYMBOL_foreach_cmd = 285,              /* foreach_cmd  */
  YYSYMBOL_switch_cmd = 286,               /* switch_cmd  */
  YYSYMBOL_switch_stm = 287,               /* switch_stm  */
  YYSYMBOL_case_stms = 288,                /* case_stms  */
  YYSYMBOL_case_stm = 289,                 /* case_stm  */
  YYSYMBOL_default_stm = 290,              /* default_stm  */
  YYSYMBOL_func_param = 291,               /* func_param  */
  YYSYMBOL_route_param = 292,              /* route_param  */
  YYSYMBOL_async_func = 293,               /* async_func  */
  YYSYMBOL_cmd = 294                       /* cmd  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  234
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2242

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  207
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  88
/* YYNRULES -- Number of rules.  */
#define YYNRULES  524
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  999

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   461


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   510,   510,   513,   514,   515,   518,   519,   520,   520,
     521,   521,   522,   522,   523,   523,   524,   524,   525,   525,
     526,   526,   527,   527,   528,   528,   530,   533,   548,   557,
     572,   573,   576,   577,   591,   596,   606,   607,   610,   623,
     632,   639,   641,   642,   643,   647,   649,   651,   656,   664,
     666,   668,   670,   672,   677,   684,   686,   688,   690,   694,
     697,   698,   701,   703,   705,   711,   714,   717,   720,   723,
     726,   729,   734,   735,   738,   739,   739,   746,   747,   749,
     750,   753,   761,   770,   776,   783,   789,   796,   802,   809,
     815,   822,   828,   837,   838,   839,   842,   843,   844,   847,
     848,   851,   852,   853,   857,   865,   873,   879,   887,   891,
     903,   904,   905,   906,   907,   908,   923,   925,   928,   929,
     950,   951,   962,   963,   974,   975,   984,   985,   991,   992,
     998,   999,  1001,  1002,  1027,  1052,  1060,  1061,  1069,  1070,
    1077,  1078,  1084,  1085,  1088,  1089,  1090,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,
    1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,  1116,
    1117,  1120,  1124,  1125,  1126,  1134,  1142,  1150,  1158,  1166,
    1174,  1182,  1190,  1198,  1206,  1209,  1210,  1213,  1214,  1215,
    1216,  1217,  1218,  1219,  1220,  1221,  1222,  1223,  1224,  1225,
    1226,  1236,  1237,  1251,  1252,  1253,  1254,  1255,  1256,  1257,
    1258,  1259,  1260,  1261,  1262,  1263,  1264,  1265,  1266,  1276,
    1286,  1287,  1292,  1293,  1296,  1300,  1301,  1306,  1307,  1310,
    1311,  1314,  1315,  1318,  1319,  1326,  1327,  1334,  1336,  1339,
    1340,  1343,  1344,  1347,  1350,  1357,  1358,  1365,  1366,  1373,
    1374,  1376,  1377,  1381,  1382,  1385,  1386,  1388,  1389,  1391,
    1393,  1395,  1396,  1397,  1398,  1400,  1401,  1410,  1413,  1423,
    1426,  1470,  1471,  1476,  1478,  1480,  1481,  1487,  1489,  1503,
    1505,  1508,  1509,  1512,  1513,  1520,  1521,  1528,  1529,  1533,
    1561,  1562,  1564,  1565,  1568,  1569,  1572,  1573,  1583,  1593,
    1595,  1597,  1598,  1600,  1601,  1603,  1606,  1608,  1611,  1612,
    1615,  1617,  1620,  1623,  1627,  1628,  1634,  1640,  1646,  1650,
    1651,  1654,  1670,  1686,  1687,  1690,  1696,  1706,  1716,  1727,
    1730,  1739,  1744,  1767,  1772,  1780,  1796,  1799,  1805,  1808,
    1816,  1822,  1825,  1831,  1834,  1842,  1845,  1853,  1856,  1864,
    1867,  1880,  1883,  1889,  1894,  1895,  1896,  1897,  1898,  1899,
    1902,  1903,  1906,  1907,  1908,  1909,  1911,  1912,  1915,  1916,
    1919,  1920,  1921,  1924,  1940,  1945,  1946,  1947,  1949,  1954,
    1957,  1960,  1963,  1966,  1972,  1973,  1974,  1975,  1976,  1977,
    1978,  1979,  1980,  1981,  1985,  1986,  1987,  1988,  1989,  1990,
    1993,  1996,  1999,  2002,  2005,  2008,  2011,  2014,  2017,  2020,
    2023,  2026,  2039,  2052,  2067,  2068,  2069,  2070,  2071,  2074,
    2075,  2076,  2079,  2080,  2081,  2084,  2085,  2086,  2090,  2091,
    2092,  2095,  2096,  2097,  2098,  2099,  2100,  2101,  2102,  2105,
    2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,  2116,  2124,
    2134,  2142,  2152,  2160,  2178,  2187,  2188,  2190,  2191,  2194,
    2200,  2206,  2212,  2220,  2223,  2226,  2231,  2241,  2248,  2255,
    2265,  2270,  2277,  2287,  2292,  2299,  2311,  2316,  2321,  2326,
    2331,  2341,  2351,  2361,  2373,  2391,  2422,  2426,  2432,  2435,
    2436,  2437,  2438,  2439,  2441,  2443,  2445,  2447,  2449,  2450,
    2453,  2459,  2460,  2462,  2468,  2469,  2471,  2475,  2494,  2495,
    2497,  2520,  2556,  2558,  2561,  2563,  2565,  2567,  2569,  2571,
    2573,  2580,  2587,  2594,  2601
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "DROP", "ASSERT",
  "EXIT", "RETURN", "LOG_TOK", "ERROR", "ROUTE", "ROUTE_FAILURE",
  "ROUTE_ONREPLY", "ROUTE_BRANCH", "ROUTE_ERROR", "ROUTE_LOCAL",
  "ROUTE_STARTUP", "ROUTE_TIMER", "ROUTE_EVENT", "IF", "ELSE", "SWITCH",
  "CASE", "DEFAULT", "BREAK", "WHILE", "FOR", "IN", "READONLY", "EXPIRE",
  "NULLV", "XDBG", "XLOG", "XLOG_BUF_SIZE", "XLOG_FORCE_COLOR",
  "XLOG_PRINT_LEVEL", "XLOG_LEVEL", "PV_PRINT_BUF_SIZE", "DEBUG_MODE",
  "ENABLE_ASSERTS", "ABORT_ON_ASSERT", "LOGLEVEL", "LOGPREFIX",
  "LOGSTDOUT", "LOGSTDERROR", "STDERROR_ENABLED", "SYSLOG_ENABLED",
  "LOG_EVENT_ENABLED", "STDERROR_LEVEL_FILTER", "SYSLOG_LEVEL_FILTER",
  "LOG_EVENT_LEVEL_FILTER", "STDERROR_FORMAT", "SYSLOG_FORMAT",
  "LOG_JSON_BUF_SIZE", "LOG_MSG_BUF_SIZE", "LOGFACILITY",
  "SYSLOG_FACILITY", "LOGNAME", "SYSLOG_NAME", "AVP_ALIASES", "LISTEN",
  "SOCKET", "MEMGROUP", "ALIAS", "AUTO_ALIASES", "TAG", "DNS", "REV_DNS",
  "DNS_TRY_IPV6", "DNS_TRY_NAPTR", "DNS_RETR_TIME", "DNS_RETR_NO",
  "DNS_SERVERS_NO", "DNS_USE_SEARCH", "MAX_WHILE_LOOPS", "UDP_WORKERS",
  "CHECK_VIA", "SHM_HASH_SPLIT_PERCENTAGE", "SHM_SECONDARY_HASH_SIZE",
  "MEM_WARMING_ENABLED", "MEM_WARMING_PATTERN_FILE",
  "MEM_WARMING_PERCENTAGE", "RPM_MEM_FILE", "RPM_MEM_SIZE", "MEMLOG",
  "MEMDUMP", "SHM_MEMLOG_SIZE", "EXECMSGTHRESHOLD", "EXECDNSTHRESHOLD",
  "TCPTHRESHOLD", "EVENT_SHM_THRESHOLD", "EVENT_PKG_THRESHOLD",
  "QUERYBUFFERSIZE", "QUERYFLUSHTIME", "SIP_WARNING", "SERVER_SIGNATURE",
  "SERVER_HEADER", "USER_AGENT_HEADER", "LOADMODULE", "MPATH", "MODPARAM",
  "MAXBUFFER", "CHROOT", "WDIR", "MHOMED", "POLL_METHOD",
  "TCP_ACCEPT_ALIASES", "TCP_WORKERS", "TCP_CONNECT_TIMEOUT",
  "TCP_CON_LIFETIME", "TCP_SOCKET_BACKLOG", "TCP_MAX_CONNECTIONS",
  "TCP_NO_NEW_CONN_BFLAG", "TCP_NO_NEW_CONN_RPLFLAG", "TCP_KEEPALIVE",
  "TCP_KEEPCOUNT", "TCP_KEEPIDLE", "TCP_KEEPINTERVAL", "TCP_MAX_MSG_TIME",
  "TCP_PARALLEL_READ_ON_WORKERS", "ADVERTISED_ADDRESS", "ADVERTISED_PORT",
  "DISABLE_CORE", "OPEN_FD_LIMIT", "MCAST_LOOPBACK", "MCAST_TTL", "TOS",
  "DISABLE_DNS_FAILOVER", "DISABLE_DNS_BLACKLIST", "DST_BLACKLIST",
  "DISABLE_STATELESS_FWD", "DB_VERSION_TABLE", "DB_DEFAULT_URL",
  "DB_MAX_ASYNC_CONNECTIONS", "DISABLE_503_TRANSLATION", "SYNC_TOKEN",
  "ASYNC_TOKEN", "LAUNCH_TOKEN", "AUTO_SCALING_PROFILE",
  "AUTO_SCALING_CYCLE", "TIMER_WORKERS", "EQUAL", "EQUAL_T", "GT", "LT",
  "GTE", "LTE", "DIFF", "MATCH", "NOTMATCH", "COLONEQ", "PLUSEQ",
  "MINUSEQ", "SLASHEQ", "MULTEQ", "MODULOEQ", "BANDEQ", "BOREQ", "BXOREQ",
  "OR", "AND", "BOR", "BAND", "BXOR", "BLSHIFT", "BRSHIFT", "PLUS",
  "MINUS", "MULT", "MODULO", "NOT", "BNOT", "NUMBER", "ZERO", "ID",
  "STRING", "SCRIPTVAR", "IPV6ADDR", "IPV4ADDR", "IPNET", "COMMA",
  "SEMICOLON", "RPAREN", "LPAREN", "LBRACE", "RBRACE", "LBRACK", "RBRACK",
  "SLASH", "AS", "USE_WORKERS", "USE_AUTO_SCALING_PROFILE", "MAX", "MIN",
  "DOT", "CR", "COLON", "ANY", "ANYCAST", "FRAG", "REUSE_PORT",
  "SCRIPTVARERR", "SCALE_UP_TO", "SCALE_DOWN_TO", "ON", "CYCLES",
  "CYCLES_WITHIN", "PERCENTAGE", "$accept", "cfg", "statements",
  "statement", "$@1", "$@2", "$@3", "$@4", "$@5", "$@6", "$@7", "$@8",
  "$@9", "listen_id", "host_sep", "host", "proto", "port", "portrange",
  "snumber", "phostport", "phostportrange", "alias_def", "id_lst",
  "listen_id_def", "socket_def_param", "socket_def_params", "socket_def",
  "$@10", "any_proto", "multi_string", "blst_elem", "blst_def",
  "blst_flag", "blst_flags", "blst_elem_list", "auto_scale_profile_def",
  "assign_stm", "module_stm", "ip", "ipv4", "ipv6addr", "ipv6", "ipnet",
  "folded_string", "route_name", "route_name_var", "route_stm",
  "failure_route_stm", "onreply_route_stm", "branch_route_stm",
  "error_route_stm", "local_route_stm", "startup_route_stm",
  "timer_route_stm", "event_route_stm", "exp", "equalop", "compop",
  "matchop", "intop", "strop", "script_var", "exp_elem", "exp_cond",
  "assignop", "assignexp", "assign_cmd", "exp_stm", "brk_stm", "stm",
  "actions", "brk_actions", "action", "brk_action", "brk_if_cmd", "if_cmd",
  "while_cmd", "foreach_cmd", "switch_cmd", "switch_stm", "case_stms",
  "case_stm", "default_stm", "func_param", "route_param", "async_func",
  "cmd", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-862)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-464)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2048,   -89,   -85,   -74,   -68,   -51,   -47,   -32,   -14,     6,
      34,    35,    47,    53,   212,   234,   235,   237,   250,   267,
     281,   302,   308,   313,   323,   332,   366,   400,   402,   486,
     490,   522,   524,   540,   575,   184,   361,   401,   519,   530,
     624,   584,   586,   603,   622,   623,   638,   652,   698,   699,
     720,   724,   728,   743,   746,   751,   759,   772,   778,   782,
     803,   808,   812,   815,   816,    39,   819,    33,   822,   832,
     833,   834,   840,   842,   853,   854,   857,   862,   866,   867,
     869,   882,   886,   887,   891,   893,   894,   895,   898,   901,
     904,   906,   907,   910,   627,   649,   911,   913,   914,   930,
     931,   932,   935,   936,   937,  -862,   248,  1885,  -862,   546,
     645,   726,   644,   721,   810,   848,   841,   852,  -862,  -862,
    -862,   142,   163,   169,   372,   197,   352,   353,   378,   657,
      70,   388,   413,   414,   435,   437,   415,   432,   436,   697,
     737,   438,   440,   132,   172,   103,   108,   183,   191,   849,
     258,   450,   451,   467,  -862,   843,  -862,   858,  -862,   909,
    -862,   917,  -862,   919,  -862,   923,   468,   469,   477,   481,
     482,   483,   117,   487,   128,   494,   439,   478,   480,   495,
     496,   497,   513,   515,   516,   525,   526,   527,   129,   141,
    -862,  -862,   151,  -862,   925,   528,   113,   122,   545,   127,
     550,   551,   556,   581,   587,   594,   193,   196,   595,   612,
     626,   656,   659,   680,   143,   684,   690,   691,   701,   702,
      83,  -862,   926,  -862,   939,   727,   940,   152,   165,   706,
     716,   207,   717,   941,  -862,   -89,  -862,    27,  -862,    42,
    -862,    31,  -862,    43,  -862,    22,  -862,    26,  -862,    58,
    -862,    45,  -862,    46,  -862,  -862,  -862,  -862,  -862,  -862,
    -862,  -862,   942,   946,  -862,  -862,  -862,  -862,  -862,  -862,
    -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,
    -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,
    -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,
    -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,   896,
     619,  -862,  -862,  -862,   924,  -862,  1077,   927,  -862,  -862,
    -862,   963,   947,  -862,  -125,   948,  -862,   583,  -862,  -862,
    -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,
    -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,   928,  -862,
    -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,
    -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,
    -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,
    -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,
    -862,  -862,  -862,  -862,  -862,   922,  -862,  -862,  -862,  -862,
    -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,
    -862,  -862,   951,  -862,  -862,  -862,  -862,  -862,  -862,  -862,
    -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,
    -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,
    -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,
    -862,  -862,  -862,  -862,  -862,   -82,  -862,  -862,  -862,  -862,
    -862,  -862,  -862,  -862,  -862,  -862,   945,  -862,  -862,  -862,
     959,  -862,  1709,   -26,  -862,   -26,  -862,  1709,   -26,  -862,
     -26,  -862,  1709,  -862,  1709,  -862,  1709,  -862,   -26,  -862,
     -26,  -862,  -862,   985,   677,   168,  -862,   968,   784,  -862,
     245,   983,   784,  -862,   984,   991,   990,   723,   986,  -862,
     995,   994,   999,  1000,  1001,   771,    82,    87,    93,  1002,
    1004,  1007,  1009,  1011,  1015,  1016,  1017,    98,  -862,  -862,
    -862,  1395,   988,   795,  -862,  -862,  -862,  -862,  -862,    77,
    -862,  -862,  -862,  1025,  1029,   828,  1030,  1031,   889,   920,
     980,   993,  1032,  1008,  1027,  1047,   784,  1052,  1051,  -862,
    -862,  -862,   677,  -862,  -862,  1053,  -862,  -862,  1033,  -862,
    -862,  1034,  -862,  1075,  -862,  -862,  -862,  -862,  -862,  -137,
    1171,  1049,  -862,  1076,  1389,  1080,   -50,  -862,  -862,  -862,
     156,  -862,   189,  -862,    29,  1389,  -118,  1389,  -118,  1056,
    1090,  1092,  1092,  -862,    68,  1237,  1238,  -862,  -862,  -862,
    -862,  -862,  -862,  -862,  -862,  1449,  -862,  -862,  -862,  -862,
    -862,  -862,  1094,  1096,  -862,  1097,  1098,  -862,  -862,  -862,
    1111,  1100,   730,   731,  -862,  1089,  -862,  -862,  -862,  -862,
    -862,    15,    36,   -64,   723,  -862,   814,  -862,   597,  -862,
    -862,    95,  -862,  -862,  1115,  -862,  1389,  1389,  1466,  1449,
    -862,   561,  1616,  -862,  -862,  -862,  -862,  -862,  -862,  -862,
    -862,  1107,  1108,  1109,  1113,  1117,  1118,  1122,  1121,  -862,
     232,  -862,   269,  1126,   349,  1277,   225,   236,   -16,   328,
      99,  1129,   280,  1137,  -862,   874,  -862,  -862,  -862,   609,
    -862,  -862,  1449,  -862,  1449,  -862,   989,  -862,  1431,  -862,
    1709,  1709,  1709,  1709,  1124,  1709,  -862,  1153,  1142,  -862,
    1142,   732,  -862,  -862,  -862,  -862,  -862,  -862,   508,  1141,
     574,  -862,   597,  -862,  -862,  -862,  1144,   631,  -862,   883,
    -862,  1156,  -862,   377,  -862,  1012,  1073,  1389,  1389,  1151,
    -862,  -862,  -862,  -862,  -862,  -862,  -862,  -862,   315,  -113,
    -862,   657,   249,  -862,  -862,  -862,  -862,  1155,  -862,  1157,
    -862,   347,  -862,  1497,  1147,   131,  -118,  -862,  -862,  -862,
    -862,  1160,  -862,  -862,  -862,   118,   -26,   -26,  -862,  -862,
    -862,  -862,  -862,   892,  -862,  -862,  1082,  1449,  1449,  1449,
    1449,  1449,  1449,  1449,  1449,  1449,  1449,  1078,  1120,  1170,
    1201,  1152,  1267,  1173,  1175,  -862,  1142,  -862,  -862,  -862,
    1148,   663,   929,  -101,  -862,  -862,  1316,  -862,  -862,  -862,
    -862,  -862,  1161,  -862,  -862,  -862,  -862,  -862,  1176,  1177,
    -862,  -862,  -862,  -862,   668,  1651,  1332,  -862,  1331,  1179,
    1189,  -862,  1406,  1191,  -862,  -862,  -862,  -862,  -862,  -862,
      91,  1178,   613,   640,  1192,  -862,   700,   703,   725,  -862,
    -862,  -862,  -862,   767,   767,   767,   767,   767,  -862,  -862,
    -862,  -862,  -862,  -862,  -862,  -862,  -862,  1709,  -862,  -862,
    1206,   929,  -101,  -862,   729,  1194,  1207,  -862,  -862,  -862,
     379,  -862,  -862,  1308,  1497,   606,  1196,    90,  -862,  1389,
    -862,  -862,   670,  -862,  -862,  -862,  -862,   131,  -862,  -862,
    -862,  -862,  1211,  -862,  1212,  -862,  1359,  1216,   736,  1210,
    -101,  -862,  -862,   -45,  -862,  -862,  -862,  -862,  -862,  -862,
    1193,  1204,  -862,  1205,  -862,  -862,   580,  -862,  -862,  -862,
    -862,  1223,  1224,  -862,  -862,  -101,  -862,  -862,   760,  1214,
    1235,  1680,  1680,  1680,   131,  -862,  -862,   768,  1234,  -862,
    1246,  1219,   569,   611,   705,  1399,  1248,  -862,  1242,  1222,
    1256,   131,  1247,  -862,  1261,  1230,  -862,  -862,  1266,  1264,
    1413,  1271,  1270,  1420,  1244,  1275,  -862,  1245,  -862
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    26,     0,     0,     4,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     6,     7,
     312,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   152,     0,   154,     0,   156,     0,
     158,     0,   160,     0,   162,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     314,   313,     0,   318,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   294,     0,   296,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     1,     5,     3,     0,     9,     0,
      11,     0,    13,     0,    15,     0,    17,     0,    19,     0,
      21,     0,    23,     0,    25,   261,   258,   262,   259,   263,
     260,   265,     0,     0,    42,   264,   257,   256,   116,   115,
     112,   111,   114,   113,   108,   110,   109,   118,   117,   120,
     119,   122,   121,   124,   123,   126,   125,   128,   127,   130,
     129,   132,   131,   133,   134,   136,   135,   138,   137,   140,
     139,   142,   141,   144,   143,   146,   145,   269,    35,     0,
      74,   268,   267,   266,     0,   273,     0,    32,    28,   322,
     321,     0,     0,    55,    29,     0,    59,    60,   272,    27,
     319,   323,   320,   275,   274,   148,   147,   150,   149,   151,
     153,   155,   157,   159,   161,   164,   163,   169,   167,   173,
     172,   175,   174,   177,   176,   179,   178,   181,   180,   183,
     182,   185,   184,   187,   186,   189,   188,   193,   192,   191,
     190,   195,   194,   197,   196,   199,   198,   201,   200,   203,
     202,   205,   204,   207,   206,   209,   208,   251,   250,   253,
     252,   255,   254,   292,   291,     0,   166,   165,   212,   211,
     210,   215,   214,   213,   217,   216,   220,   218,   219,   222,
     221,   225,   223,   227,   226,   229,   228,   231,   230,   233,
     232,   235,   234,   237,   236,   239,   238,   245,   244,   247,
     246,   249,   248,   241,   240,   243,   242,   277,    32,   276,
     279,   278,   281,   280,   283,   282,   285,   284,   287,   286,
     290,   288,   289,   293,   295,    95,   299,   301,   300,   303,
     302,   305,   304,   307,   306,   309,     0,   308,   311,   310,
     170,   336,     0,     0,   338,     0,   341,     0,     0,   343,
       0,   345,     0,   347,     0,   349,     0,   351,     0,   353,
       0,    43,    44,     0,     0,     0,    48,     0,     0,    31,
       0,     0,     0,    61,     0,     0,     0,     0,     0,   298,
       0,     0,   489,     0,   491,   498,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   373,   437,
     374,     0,     0,     0,   426,   432,   433,   434,   435,     0,
     330,   329,   331,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    49,    50,     0,     0,     0,     0,    65,
      66,    67,    72,    76,   271,    79,   270,   324,    56,    34,
      33,    45,   168,     0,   224,    98,    96,    97,   100,    95,
       0,     0,   171,     0,     0,     0,     0,   495,   493,   501,
       0,   504,     0,   508,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   513,     0,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   436,   427,   334,   425,
     438,   431,     0,     0,   339,     0,     0,   344,   346,   348,
       0,     0,     0,     0,    70,    62,    69,    68,    71,    73,
      80,     0,     0,     0,     0,   297,     0,   325,     0,    94,
     102,     0,   326,    91,     0,   490,     0,     0,     0,     0,
     377,     0,   378,   359,   375,   416,   376,   415,   414,   492,
     497,     0,     0,     0,     0,     0,     0,     0,     0,   332,
       0,   333,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   465,   467,   510,   470,   473,     0,
     412,   413,     0,   395,     0,   394,   396,   397,   411,   398,
       0,     0,     0,     0,     0,     0,    53,    41,    51,    54,
      52,     0,    58,    36,    37,    57,    47,    46,     0,     0,
       0,    99,     0,    92,    77,    78,     0,     0,   103,     0,
      93,     0,   356,     0,   418,     0,     0,     0,     0,     0,
     360,   362,   363,   364,   365,   361,   366,   367,   368,   369,
     372,     0,     0,   496,   494,   502,   499,     0,   505,     0,
     509,     0,   506,     0,     0,     0,     0,   327,   514,   328,
     515,     0,   516,   517,   487,     0,     0,     0,   524,   512,
     468,   471,   474,   469,   511,   409,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    64,    63,   315,   317,   316,
       0,     0,     0,     0,    89,   101,     0,   357,   417,   358,
     355,   354,     0,   382,   383,   381,   380,   379,     0,     0,
     478,   476,   477,   479,     0,     0,   450,   422,     0,     0,
       0,   446,     0,     0,   452,   419,   441,   442,   443,   444,
       0,     0,     0,     0,     0,   484,     0,     0,     0,   466,
     472,   475,   410,   405,   404,   406,   407,   408,   399,   400,
     401,   403,   402,   335,   337,   340,   342,     0,   352,    40,
      39,     0,     0,    90,     0,     0,     0,   488,   500,   503,
       0,   507,   424,     0,     0,     0,     0,   456,   458,     0,
     439,   421,     0,   429,   445,   447,   440,     0,   518,   519,
     486,   485,     0,   520,     0,   523,     0,     0,     0,     0,
       0,    85,    87,     0,   483,   480,   481,   482,   423,   451,
       0,     0,   454,     0,   457,   455,     0,   430,   420,   428,
     453,     0,     0,   350,    38,     0,    86,    88,     0,   107,
       0,   462,   460,   464,     0,   521,   522,     0,     0,    83,
       0,   106,     0,     0,     0,   448,     0,    84,     0,     0,
       0,     0,     0,    81,     0,     0,   449,    82,     0,     0,
       0,     0,     0,     0,     0,     0,   105,     0,   104
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -862,  -862,  -862,  1343,  -862,  -862,  -862,  -862,  -862,  -862,
    -862,  -862,  -862,  -208,  -862,  -862,  -149,  -632,  -594,  -124,
    -862,  -862,  -862,  1132,  -862,  -862,   899,  1312,  -862,   733,
     897,   738,   884,   820,  -862,  -862,  -862,  -862,  -862,  -147,
    -862,  1145,  -862,  -626,  -526,  -415,  -862,  -862,  -862,  -862,
    -862,  -862,  -862,  -862,  -862,  -862,  -571,  -862,  -862,  -862,
    -862,  -862,  -237,  -862,  -566,  -862,   949,  -576,  -862,  -861,
     564,  -475,  -458,  -500,     4,  -862,  -559,  -711,  -517,  -487,
    -862,  -862,   571,  -862,   704,  -862,   880,  -580
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   323,   501,   324,   309,   725,   718,   705,
     326,   310,   327,   328,   636,   562,   563,   311,   494,   736,
     566,   650,   509,   578,   579,   651,   467,   118,   119,   652,
     330,   331,   332,   653,   687,   543,   680,   238,   240,   242,
     244,   246,   248,   250,   252,   254,   661,   758,   759,   760,
     761,   762,   531,   663,   707,   615,   708,   532,   666,   854,
     846,   533,   912,   534,   855,   856,   535,   536,   537,   538,
     906,   907,   908,   945,   699,   844,   691,   539
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     265,   325,   545,   329,   668,   274,   439,   548,   665,   549,
     727,   550,   288,   290,   292,   668,   722,   668,   664,   665,
     733,   665,   737,   481,   682,   667,   684,   483,   471,   664,
     678,   664,   476,   619,   193,   709,   667,   726,   667,   720,
     190,   499,   644,   474,   479,   619,   487,   489,   619,   619,
     619,   120,   366,   368,   370,   121,   950,   528,   508,   485,
     544,  -371,  -371,   546,   857,   547,   122,   329,   500,   693,
     723,   275,   123,   551,   689,   552,   668,   668,   620,   709,
     665,   665,   530,   589,   450,   742,   743,  -371,   591,   124,
     664,   664,   915,   125,   593,   724,   738,   667,   667,   603,
     784,   262,   263,   975,   303,   507,   821,   264,   126,   305,
     728,   905,   943,   508,   398,   262,   263,   730,   357,   864,
     986,   264,   709,   401,   709,   528,   127,   816,   406,   361,
     389,   670,   834,   299,   512,   513,   514,   515,   516,   517,
     518,   857,   391,   255,   437,   540,   128,   541,   542,   849,
     530,   520,   393,   457,   850,   521,   522,   673,   777,   959,
     960,   523,   524,   781,   257,   782,   459,   668,   668,   564,
     259,   665,   665,   301,   129,   130,   830,   831,   325,   679,
     329,   664,   664,   745,   307,   154,   723,   131,   667,   667,
     676,   895,   312,   132,   421,   860,   894,   423,   266,   853,
     540,   857,   541,   542,   528,   482,   857,   723,   465,   484,
     472,   724,   473,   191,   477,   194,   478,   709,   709,   709,
     709,   709,   709,   709,   709,   709,   709,   475,   480,   530,
     488,   490,   724,   262,   263,   807,   808,   809,   810,   264,
     812,   486,   694,   528,   276,   619,   569,   695,   234,   696,
     857,   857,   857,   857,   451,   863,   452,   621,   858,   315,
     929,   857,   857,   857,   590,   928,   525,   526,   530,   592,
     857,   916,   860,   847,   739,   594,   853,   304,   588,   740,
     604,   785,   306,   262,   263,   554,   399,   400,   859,   264,
     568,   358,   694,   528,   571,   402,   403,   695,   958,   865,
     407,   408,   362,   390,   527,   300,   528,   619,   619,   619,
     619,   851,   619,   256,   852,   392,   438,   318,   530,   319,
     320,   262,   263,   967,   155,   394,   458,   264,   321,   668,
     674,   530,   860,   665,   258,   858,   853,   860,   946,   460,
     260,   853,   565,   664,   833,   302,   329,   662,   635,   672,
     667,   329,   133,   268,   270,   329,   308,   681,   662,   683,
     662,   685,   156,   677,   308,   859,   422,   698,   267,   424,
     903,   867,   868,   261,   134,   135,   840,   136,   706,   272,
     466,   860,   860,   860,   860,   853,   853,   853,   853,   277,
     137,   587,   860,   860,   860,   858,   853,   853,   853,   777,
     858,   860,   158,   619,   847,   853,   778,   138,   934,   329,
     779,   771,   926,   772,   279,   281,   287,   780,   -30,   662,
     662,   139,   706,   836,   528,   859,   619,   747,   748,   316,
     859,   317,   318,   289,   319,   320,   283,   291,   285,   295,
     365,   297,   140,   321,   858,   858,   858,   858,   141,   530,
     773,   333,   335,   142,   322,   858,   858,   858,   792,   787,
     660,   788,   671,   143,   858,   706,   675,   706,   337,   345,
     347,   660,   144,   660,   859,   859,   859,   859,   349,   367,
     697,   369,   351,   353,   355,   859,   859,   859,   359,  -370,
    -370,   319,   320,   647,   859,   363,   371,   373,   375,   735,
     321,   157,   779,   972,   973,   974,   145,   747,   748,   783,
     662,   662,   262,   263,   377,  -370,   379,   381,   264,   729,
     160,   841,   528,   269,   271,   837,   383,   385,   387,   396,
     775,   162,   660,   660,   843,   747,   748,   262,   263,   861,
     146,   159,   147,   264,   262,   263,   404,   530,   698,   273,
     264,   409,   411,   935,   528,   237,   871,   413,   827,   278,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     947,   791,   512,   513,   514,   515,   516,   517,   518,   530,
     262,   263,   415,   735,   280,   282,   264,   849,   417,   520,
    -461,  -461,   850,   521,   522,   419,   425,   262,   263,   523,
     524,   262,   263,   264,   262,   263,   284,   264,   286,   296,
     264,   298,   947,   427,   512,   513,   514,   515,   516,   517,
     518,   334,   336,   660,   660,   164,   148,   429,   221,   849,
     149,   520,  -459,  -459,   850,   521,   522,   835,   338,   346,
     348,   523,   524,   262,   263,   262,   263,   842,   350,   264,
     223,   264,   352,   354,   356,   239,   243,   431,   360,   161,
     433,   697,   150,   937,   151,   364,   372,   374,   376,   870,
     163,   947,   662,   512,   513,   514,   515,   516,   517,   518,
     152,   435,   777,   -75,   378,   440,   380,   382,   849,   817,
     520,   442,   444,   850,   521,   522,   384,   386,   388,   397,
     523,   524,   446,   448,   525,   526,   947,   461,   512,   513,
     514,   515,   516,   517,   518,   153,   405,   463,   468,   747,
     748,   410,   412,   849,   166,   520,   167,   414,   850,   521,
     522,   716,   719,   815,   245,   523,   524,   241,   747,   748,
     749,   555,   527,   168,   528,   575,   525,   526,   779,   851,
     576,   577,   416,  -461,   316,   819,   317,   318,   418,   319,
     320,   964,   169,   170,   165,   420,   426,   222,   321,   530,
     308,   262,   263,   319,   320,   647,   936,   264,   171,   322,
     940,   941,   321,   428,   527,   660,   528,   777,   793,   224,
     794,   851,   172,   734,   918,  -459,   617,   430,   512,   513,
     514,   515,   516,   517,   518,   525,   526,   -75,   -75,   -75,
     823,   530,   824,   519,   779,   520,   -75,   -75,   -75,   521,
     522,   919,   262,   263,   247,   523,   524,   432,   264,   617,
     434,   512,   513,   514,   515,   516,   517,   518,   173,   174,
     525,   526,   892,   527,   893,   528,   519,   900,   520,   901,
     851,   436,   521,   522,   948,   441,   913,   251,   523,   524,
     175,   443,   445,   249,   176,   556,   557,   558,   177,   253,
     530,   293,   447,   449,   559,   560,   561,   462,   527,   793,
     528,   921,   922,   178,   923,   851,   179,   464,   469,  -463,
     617,   180,   512,   513,   514,   515,   516,   517,   518,   181,
     455,   717,   717,   717,   924,   530,   925,   519,   930,   520,
     931,   294,   182,   521,   522,   955,   949,   956,   183,   523,
     524,   617,   184,   512,   513,   514,   515,   516,   517,   518,
     525,   526,   802,   803,   804,   805,   262,   263,   519,   968,
     520,   969,   264,   185,   521,   522,   528,   976,   186,   977,
     523,   524,   187,   586,   806,   188,   189,   438,   318,   192,
     319,   320,   195,   525,   526,   913,   913,   913,   527,   321,
     528,   530,   196,   197,   198,   529,   949,   949,   949,   618,
     199,   617,   200,   512,   513,   514,   515,   516,   517,   518,
     319,   320,   647,   201,   202,   530,   732,   203,   519,   321,
     520,   527,   204,   528,   521,   522,   205,   206,   529,   207,
     523,   524,   624,   617,   339,   512,   513,   514,   515,   516,
     517,   518,   208,   314,   525,   526,   209,   210,   530,   340,
     519,   211,   520,   212,   213,   214,   521,   522,   215,   262,
     263,   216,   523,   524,   217,   264,   218,   219,   790,   528,
     220,   225,   646,   226,   227,   525,   526,   262,   263,   319,
     320,   647,   527,   264,   528,   648,   869,   528,   321,   529,
     228,   229,   230,   627,   530,   231,   232,   233,   496,   617,
     341,   512,   513,   514,   515,   516,   517,   518,   342,   530,
     343,   493,   530,   527,   344,   528,   519,   453,   520,   395,
     529,   505,   521,   522,   628,   319,   320,   647,   523,   524,
     454,   456,   470,   491,   321,   525,   526,   492,   504,   495,
     530,   617,   -35,   512,   513,   514,   515,   516,   517,   518,
     750,   751,   752,   753,   754,   755,   756,   757,   519,   319,
     520,   506,   498,   502,   521,   522,   510,   525,   526,   511,
     523,   524,   553,   527,   567,   528,   570,   572,   438,   318,
     529,   319,   320,   574,   629,   573,   581,   582,   616,   580,
     321,   617,   630,   512,   513,   514,   515,   516,   517,   518,
     530,   583,   584,   585,   595,   527,   596,   528,   519,   597,
     520,   598,   529,   599,   521,   522,   828,   600,   601,   602,
     523,   524,   617,   632,   512,   513,   514,   515,   516,   517,
     518,   622,   530,   525,   526,   623,   625,   626,   631,   519,
     634,   520,   633,   637,   638,   521,   522,   565,   641,   642,
     686,   523,   524,   797,   798,   799,   800,   801,   802,   803,
     804,   805,   797,   798,   799,   800,   801,   802,   803,   804,
     805,   527,   654,   528,   643,   525,   526,   655,   529,   829,
     806,   669,   883,   872,   688,   690,   700,   701,   617,   806,
     512,   513,   514,   515,   516,   517,   518,   710,   530,   711,
     712,   713,   714,   715,   721,   519,   741,   520,   763,   764,
     765,   521,   522,   527,   766,   528,   767,   523,   524,   768,
     529,   769,   770,   776,   884,   525,   526,   774,   786,   617,
     811,   512,   513,   514,   515,   516,   517,   518,   789,   813,
     530,   814,   818,   822,   826,   832,   519,   891,   520,   838,
     848,   839,   521,   522,   862,   887,   525,   526,   523,   524,
     646,   896,   897,   527,   889,   528,   890,   319,   320,   647,
     529,   904,   905,   648,   885,   649,   321,   898,   899,   917,
     617,   909,   512,   513,   514,   515,   516,   517,   518,   910,
     530,   914,   927,   920,   527,   932,   528,   519,   933,   520,
     942,   529,   951,   521,   522,   886,   952,   954,   961,   523,
     524,   957,   512,   513,   514,   515,   516,   517,   518,   962,
     963,   530,   525,   526,   965,   966,   971,   519,   978,   512,
     513,   514,   515,   516,   517,   518,   970,   979,   981,   523,
     524,   980,   982,   983,   849,   984,   520,   985,   987,   850,
     521,   522,   988,   989,   990,   991,   523,   524,   992,   993,
     527,   994,   528,   525,   526,   995,   997,   529,   996,   998,
     236,   888,   512,   513,   514,   515,   516,   517,   518,   503,
     313,   639,   640,   645,   731,   820,   497,   530,   939,   512,
     513,   514,   515,   516,   517,   518,     0,   825,   944,   523,
     524,   527,   692,   528,   519,     0,   520,     0,   529,   866,
     521,   522,   938,     0,   525,   526,   523,   524,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   530,     0,
       0,     0,     0,     0,     0,   519,     0,   520,     0,     0,
       0,   521,   522,     0,   525,   526,     0,   523,   524,     0,
       0,     0,   527,     0,   528,   605,     0,     0,     0,   529,
       0,   525,   526,   953,   606,   607,   608,   609,   610,   611,
     612,   613,   614,     0,   262,   263,     0,     0,   656,   530,
     264,     0,   527,     0,   528,     0,     0,     0,     0,     0,
       0,   657,   658,     0,   659,     0,     0,     0,     0,   527,
       0,   528,     0,     0,   525,   526,   851,     0,     0,   530,
     911,   797,   798,   799,   800,   801,   802,   803,   804,   805,
       0,   525,   526,     0,     0,     0,   530,     0,   746,     0,
       0,     0,     0,     0,   262,   263,     0,     0,   806,   702,
     264,     0,   527,   703,   528,     0,     0,     0,     0,     0,
       0,   704,   525,   526,     0,     0,     0,     0,     0,   527,
       0,   528,     0,     0,     0,     0,   529,     0,     0,   530,
     744,   795,     0,   796,   512,   513,   514,   515,   516,   517,
     518,     0,     0,     0,     0,     0,   530,     0,     0,   519,
     527,   520,   528,     0,     0,   521,   522,   529,     0,     0,
     845,   523,   524,   512,   513,   514,   515,   516,   517,   518,
       0,     0,     0,     0,     0,     0,     0,   530,   849,     0,
     520,     0,     0,   850,   521,   522,     0,     0,     0,     0,
     523,   524,   512,   513,   514,   515,   516,   517,   518,     0,
       0,     0,     0,     0,     0,     0,     0,   519,     0,   520,
       0,     0,     0,   521,   522,     0,     0,     0,     0,   523,
     524,     0,     0,     0,     0,     0,   873,   874,   875,   876,
     877,   878,   879,   880,   881,   882,   605,   750,   751,   752,
     753,   754,   755,   756,   757,   606,   607,   608,   609,   610,
     611,   612,   613,   614,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   525,   526,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   525,   526,     0,     0,     0,
       0,     0,     0,     0,   527,     0,   528,     0,     0,     0,
       0,   529,     0,     0,     0,   902,     0,     0,     0,     0,
       0,     0,     0,     0,   525,   526,     0,     0,     0,     0,
       0,   530,     0,   527,     0,   528,     0,     0,     0,     0,
     851,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     530,     0,   527,     0,   528,    -2,   235,     0,     0,   529,
       0,     0,     0,     0,    -8,   -10,   -12,   -14,   -16,   -18,
     -20,   -22,   -24,     0,     0,     0,     0,     0,     0,   530,
       0,     0,     0,     0,     0,     0,     0,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,     0,    28,    29,    30,    31,    32,     0,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,     0,
       0,     0,   102,   103,   104,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     1,
       0,     0,     0,     0,     0,     0,     0,    -8,   -10,   -12,
     -14,   -16,   -18,   -20,   -22,   -24,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   105,
       2,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,     0,    28,    29,    30,
      31,    32,     0,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,     0,     0,     0,   102,   103,   104,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   105
};

static const yytype_int16 yycheck[] =
{
     124,   150,   477,   150,   584,   129,   214,   482,   584,   484,
     642,   486,   136,   137,   138,   595,     1,   597,   584,   595,
     646,   597,   648,     1,   595,   584,   597,     1,     1,   595,
       1,   597,     1,   533,     1,   615,   595,     1,   597,   633,
       1,   166,   179,     1,     1,   545,     1,     1,   548,   549,
     550,   140,   176,   177,   178,   140,   917,   175,   195,     1,
     475,   174,   175,   478,   775,   480,   140,   214,   193,     1,
     171,     1,   140,   488,   600,   490,   656,   657,     1,   659,
     656,   657,   200,     1,     1,   656,   657,   200,     1,   140,
     656,   657,     1,   140,     1,   196,     1,   656,   657,     1,
       1,   165,   166,   964,     1,   187,   732,   171,   140,     1,
     174,    21,    22,   195,     1,   165,   166,   643,     1,     1,
     981,   171,   702,     1,   704,   175,   140,   721,     1,     1,
       1,   181,   758,     1,     3,     4,     5,     6,     7,     8,
       9,   852,     1,     1,     1,   171,   140,   173,   174,    18,
     200,    20,     1,     1,    23,    24,    25,     1,   174,   204,
     205,    30,    31,   179,     1,   181,     1,   747,   748,     1,
       1,   747,   748,     1,   140,   140,   747,   748,   327,   594,
     327,   747,   748,   658,     1,     1,   171,   140,   747,   748,
       1,   823,     1,   140,     1,   775,   822,     1,     1,   775,
     171,   912,   173,   174,   175,   183,   917,   171,     1,   183,
     183,   196,   185,   174,   183,   182,   185,   797,   798,   799,
     800,   801,   802,   803,   804,   805,   806,   185,   185,   200,
     185,   185,   196,   165,   166,   710,   711,   712,   713,   171,
     715,   183,   174,   175,   174,   745,     1,   179,     0,   181,
     961,   962,   963,   964,   171,   781,   173,   180,   775,     1,
     892,   972,   973,   974,   182,   891,   135,   136,   200,   182,
     981,   180,   852,   773,   179,   182,   852,   174,   515,   184,
     182,   182,   174,   165,   166,   493,   173,   174,   775,   171,
     498,   174,   174,   175,   502,   173,   174,   179,   930,   181,
     173,   174,   174,   174,   173,   173,   175,   807,   808,   809,
     810,   180,   812,   171,   183,   174,   173,   174,   200,   176,
     177,   165,   166,   955,   140,   174,   174,   171,   185,   909,
     174,   200,   912,   909,   171,   852,   912,   917,   909,   174,
     171,   917,   174,   909,    29,   173,   493,   584,   556,   586,
     909,   498,   140,     1,     1,   502,   173,   594,   595,   596,
     597,   598,     1,   174,   173,   852,   173,   604,   171,   173,
     845,   786,   787,     1,   140,   140,    29,   140,   615,     1,
     173,   961,   962,   963,   964,   961,   962,   963,   964,     1,
     140,   515,   972,   973,   974,   912,   972,   973,   974,   174,
     917,   981,     1,   903,   904,   981,   181,   140,    29,   556,
     174,   179,   887,   181,     1,     1,     1,   181,   173,   656,
     657,   140,   659,   174,   175,   912,   926,   158,   159,   171,
     917,   173,   174,     1,   176,   177,     1,     1,     1,     1,
       1,     1,   140,   185,   961,   962,   963,   964,   140,   200,
     181,     1,     1,   140,   196,   972,   973,   974,   695,   179,
     584,   181,   586,   140,   981,   702,   590,   704,     1,     1,
       1,   595,   140,   597,   961,   962,   963,   964,     1,     1,
     604,     1,     1,     1,     1,   972,   973,   974,     1,   174,
     175,   176,   177,   178,   981,     1,     1,     1,     1,   648,
     185,   140,   174,   961,   962,   963,   140,   158,   159,   181,
     747,   748,   165,   166,     1,   200,     1,     1,   171,   643,
       1,   174,   175,   171,   171,   762,     1,     1,     1,     1,
     181,     1,   656,   657,   771,   158,   159,   165,   166,   776,
     140,   140,   140,   171,   165,   166,     1,   200,   785,   171,
     171,     1,     1,   174,   175,     9,   793,     1,   181,   171,
     797,   798,   799,   800,   801,   802,   803,   804,   805,   806,
       1,   695,     3,     4,     5,     6,     7,     8,     9,   200,
     165,   166,     1,   732,   171,   171,   171,    18,     1,    20,
      21,    22,    23,    24,    25,     1,     1,   165,   166,    30,
      31,   165,   166,   171,   165,   166,   171,   171,   171,   171,
     171,   171,     1,     1,     3,     4,     5,     6,     7,     8,
       9,   171,   171,   747,   748,     1,   140,     1,     1,    18,
     140,    20,    21,    22,    23,    24,    25,   761,   171,   171,
     171,    30,    31,   165,   166,   165,   166,   771,   171,   171,
       1,   171,   171,   171,   171,    10,    12,     1,   171,   140,
       1,   785,   140,   900,   140,   171,   171,   171,   171,   793,
     140,     1,   909,     3,     4,     5,     6,     7,     8,     9,
     140,     1,   174,    64,   171,     1,   171,   171,    18,   181,
      20,     1,     1,    23,    24,    25,   171,   171,   171,   171,
      30,    31,     1,     1,   135,   136,     1,     1,     3,     4,
       5,     6,     7,     8,     9,   140,   171,     1,     1,   158,
     159,   171,   171,    18,   140,    20,   140,   171,    23,    24,
      25,     1,     1,     1,    13,    30,    31,    11,   158,   159,
     179,    64,   173,   140,   175,    22,   135,   136,   174,   180,
      27,    28,   171,   184,   171,   181,   173,   174,   171,   176,
     177,   181,   140,   140,   140,   171,   171,   140,   185,   200,
     173,   165,   166,   176,   177,   178,   900,   171,   140,   196,
     174,   905,   185,   171,   173,   909,   175,   174,   179,   140,
     181,   180,   140,   196,   181,   184,     1,   171,     3,     4,
       5,     6,     7,     8,     9,   135,   136,   188,   189,   190,
     179,   200,   181,    18,   174,    20,   197,   198,   199,    24,
      25,   181,   165,   166,    14,    30,    31,   171,   171,     1,
     171,     3,     4,     5,     6,     7,     8,     9,   140,   140,
     135,   136,   179,   173,   181,   175,    18,   179,    20,   181,
     180,   171,    24,    25,   184,   171,   852,    16,    30,    31,
     140,   171,   171,    15,   140,   188,   189,   190,   140,    17,
     200,   174,   171,   171,   197,   198,   199,   171,   173,   179,
     175,   181,   179,   140,   181,   180,   140,   171,   171,   184,
       1,   140,     3,     4,     5,     6,     7,     8,     9,   140,
     173,   171,   171,   171,   179,   200,   181,    18,   179,    20,
     181,   174,   140,    24,    25,   179,   912,   181,   140,    30,
      31,     1,   140,     3,     4,     5,     6,     7,     8,     9,
     135,   136,   165,   166,   167,   168,   165,   166,    18,   179,
      20,   181,   171,   140,    24,    25,   175,   179,   140,   181,
      30,    31,   140,   182,   187,   140,   140,   173,   174,   140,
     176,   177,   140,   135,   136,   961,   962,   963,   173,   185,
     175,   200,   140,   140,   140,   180,   972,   973,   974,   184,
     140,     1,   140,     3,     4,     5,     6,     7,     8,     9,
     176,   177,   178,   140,   140,   200,   182,   140,    18,   185,
      20,   173,   140,   175,    24,    25,   140,   140,   180,   140,
      30,    31,   184,     1,   171,     3,     4,     5,     6,     7,
       8,     9,   140,   174,   135,   136,   140,   140,   200,   171,
      18,   140,    20,   140,   140,   140,    24,    25,   140,   165,
     166,   140,    30,    31,   140,   171,   140,   140,   174,   175,
     140,   140,   169,   140,   140,   135,   136,   165,   166,   176,
     177,   178,   173,   171,   175,   182,   174,   175,   185,   180,
     140,   140,   140,   184,   200,   140,   140,   140,     1,     1,
     171,     3,     4,     5,     6,     7,     8,     9,   171,   200,
     171,   195,   200,   173,   171,   175,    18,   171,    20,   174,
     180,   179,    24,    25,   184,   176,   177,   178,    30,    31,
     171,   171,   171,   171,   185,   135,   136,   171,   190,   195,
     200,     1,   195,     3,     4,     5,     6,     7,     8,     9,
     141,   142,   143,   144,   145,   146,   147,   148,    18,   176,
      20,   190,   195,   195,    24,    25,   201,   135,   136,   190,
      30,    31,   167,   173,   186,   175,   173,   173,   173,   174,
     180,   176,   177,   173,   184,   174,   171,   173,   180,   183,
     185,     1,   179,     3,     4,     5,     6,     7,     8,     9,
     200,   182,   182,   182,   182,   173,   182,   175,    18,   182,
      20,   182,   180,   182,    24,    25,   184,   182,   182,   182,
      30,    31,     1,   195,     3,     4,     5,     6,     7,     8,
       9,   186,   200,   135,   136,   186,   186,   186,   186,    18,
     173,    20,   195,   171,   173,    24,    25,   174,   195,   195,
     174,    30,    31,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   173,   203,   175,   179,   135,   136,   181,   180,   186,
     187,   181,   184,   181,   174,   173,    29,    29,     1,   187,
       3,     4,     5,     6,     7,     8,     9,   183,   200,   183,
     183,   183,   171,   183,   195,    18,   171,    20,   181,   181,
     181,    24,    25,   173,   181,   175,   179,    30,    31,   181,
     180,   179,   181,    26,   184,   135,   136,   181,   179,     1,
     186,     3,     4,     5,     6,     7,     8,     9,   181,   166,
     200,   179,   181,   179,   168,   174,    18,   179,    20,   174,
     183,   174,    24,    25,   174,   183,   135,   136,    30,    31,
     169,    25,   181,   173,   171,   175,   171,   176,   177,   178,
     180,    19,    21,   182,   184,   184,   185,   181,   181,   181,
       1,   182,     3,     4,     5,     6,     7,     8,     9,   180,
     200,   180,   166,   181,   173,   181,   175,    18,   171,    20,
     184,   180,   171,    24,    25,   184,   174,   171,   195,    30,
      31,   181,     3,     4,     5,     6,     7,     8,     9,   195,
     195,   200,   135,   136,   181,   181,   171,    18,   174,     3,
       4,     5,     6,     7,     8,     9,   202,   171,    19,    30,
      31,   202,   174,   181,    18,   203,    20,   171,   181,    23,
      24,    25,   171,   203,   168,   171,    30,    31,    25,   168,
     173,   171,   175,   135,   136,    25,   171,   180,   204,   204,
     107,   184,     3,     4,     5,     6,     7,     8,     9,   327,
     148,   562,   565,   579,   644,   732,   321,   200,   904,     3,
       4,     5,     6,     7,     8,     9,    -1,   739,   907,    30,
      31,   173,   602,   175,    18,    -1,    20,    -1,   180,   785,
      24,    25,   184,    -1,   135,   136,    30,    31,    -1,    -1,
       3,     4,     5,     6,     7,     8,     9,    -1,   200,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    -1,    20,    -1,    -1,
      -1,    24,    25,    -1,   135,   136,    -1,    30,    31,    -1,
      -1,    -1,   173,    -1,   175,   140,    -1,    -1,    -1,   180,
      -1,   135,   136,   184,   149,   150,   151,   152,   153,   154,
     155,   156,   157,    -1,   165,   166,    -1,    -1,   169,   200,
     171,    -1,   173,    -1,   175,    -1,    -1,    -1,    -1,    -1,
      -1,   182,   183,    -1,   185,    -1,    -1,    -1,    -1,   173,
      -1,   175,    -1,    -1,   135,   136,   180,    -1,    -1,   200,
     184,   160,   161,   162,   163,   164,   165,   166,   167,   168,
      -1,   135,   136,    -1,    -1,    -1,   200,    -1,   659,    -1,
      -1,    -1,    -1,    -1,   165,   166,    -1,    -1,   187,   170,
     171,    -1,   173,   174,   175,    -1,    -1,    -1,    -1,    -1,
      -1,   182,   135,   136,    -1,    -1,    -1,    -1,    -1,   173,
      -1,   175,    -1,    -1,    -1,    -1,   180,    -1,    -1,   200,
     184,   702,    -1,   704,     3,     4,     5,     6,     7,     8,
       9,    -1,    -1,    -1,    -1,    -1,   200,    -1,    -1,    18,
     173,    20,   175,    -1,    -1,    24,    25,   180,    -1,    -1,
     183,    30,    31,     3,     4,     5,     6,     7,     8,     9,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   200,    18,    -1,
      20,    -1,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    31,     3,     4,     5,     6,     7,     8,     9,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    -1,    20,
      -1,    -1,    -1,    24,    25,    -1,    -1,    -1,    -1,    30,
      31,    -1,    -1,    -1,    -1,    -1,   797,   798,   799,   800,
     801,   802,   803,   804,   805,   806,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   135,   136,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   135,   136,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   173,    -1,   175,    -1,    -1,    -1,
      -1,   180,    -1,    -1,    -1,   184,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   135,   136,    -1,    -1,    -1,    -1,
      -1,   200,    -1,   173,    -1,   175,    -1,    -1,    -1,    -1,
     180,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     200,    -1,   173,    -1,   175,     0,     1,    -1,    -1,   180,
      -1,    -1,    -1,    -1,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    -1,    -1,    -1,    -1,    -1,    -1,   200,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    -1,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,    -1,
      -1,    -1,   137,   138,   139,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,    -1,    -1,    -1,   137,   138,   139,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   194
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     1,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    59,    60,
      61,    62,    63,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   137,   138,   139,   194,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   244,   245,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,     1,   140,     1,   140,     1,   140,
       1,   140,     1,   140,     1,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
       1,   174,   140,     1,   182,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,     1,   140,     1,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,     0,     1,   210,     9,   254,    10,
     255,    11,   256,    12,   257,    13,   258,    14,   259,    15,
     260,    16,   261,    17,   262,     1,   171,     1,   171,     1,
     171,     1,   165,   166,   171,   226,     1,   171,     1,   171,
       1,   171,     1,   171,   226,     1,   174,     1,   171,     1,
     171,     1,   171,     1,   171,     1,   171,     1,   226,     1,
     226,     1,   226,   174,   174,     1,   171,     1,   171,     1,
     173,     1,   173,     1,   174,     1,   174,     1,   173,   223,
     228,   234,     1,   234,   174,     1,   171,   173,   174,   176,
     177,   185,   196,   220,   222,   223,   227,   229,   230,   246,
     247,   248,   249,     1,   171,     1,   171,     1,   171,   171,
     171,   171,   171,   171,   171,     1,   171,     1,   171,     1,
     171,     1,   171,     1,   171,     1,   171,     1,   174,     1,
     171,     1,   174,     1,   171,     1,   226,     1,   226,     1,
     226,     1,   171,     1,   171,     1,   171,     1,   171,     1,
     171,     1,   171,     1,   171,     1,   171,     1,   171,     1,
     174,     1,   174,     1,   174,   174,     1,   171,     1,   173,
     174,     1,   173,   174,     1,   171,     1,   173,   174,     1,
     171,     1,   171,     1,   171,     1,   171,     1,   171,     1,
     171,     1,   173,     1,   173,     1,   171,     1,   171,     1,
     171,     1,   171,     1,   171,     1,   171,     1,   173,   220,
       1,   171,     1,   171,     1,   171,     1,   171,     1,   171,
       1,   171,   173,   171,   171,   173,   171,     1,   174,     1,
     174,     1,   171,     1,   171,     1,   173,   243,     1,   171,
     171,     1,   183,   185,     1,   185,     1,   183,   185,     1,
     185,     1,   183,     1,   183,     1,   183,     1,   185,     1,
     185,   171,   171,   195,   235,   195,     1,   248,   195,   166,
     193,   221,   195,   230,   190,   179,   190,   187,   195,   239,
     201,   190,     3,     4,     5,     6,     7,     8,     9,    18,
      20,    24,    25,    30,    31,   135,   136,   173,   175,   180,
     200,   269,   274,   278,   280,   283,   284,   285,   286,   294,
     171,   173,   174,   252,   252,   278,   252,   252,   278,   278,
     278,   252,   252,   167,   220,    64,   188,   189,   190,   197,
     198,   199,   232,   233,     1,   174,   237,   186,   220,     1,
     173,   220,   173,   174,   173,    22,    27,    28,   240,   241,
     183,   171,   173,   182,   182,   182,   182,   226,   269,     1,
     182,     1,   182,     1,   182,   182,   182,   182,   182,   182,
     182,   182,   182,     1,   182,   140,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   272,   180,     1,   184,   280,
       1,   180,   186,   186,   184,   186,   186,   184,   184,   184,
     179,   186,   195,   195,   173,   220,   231,   171,   173,   233,
     237,   195,   195,   179,   179,   239,   169,   178,   182,   184,
     238,   242,   246,   250,   203,   181,   169,   182,   183,   185,
     226,   263,   269,   270,   271,   274,   275,   283,   294,   181,
     181,   226,   269,     1,   174,   226,     1,   174,     1,   252,
     253,   269,   263,   269,   263,   269,   174,   251,   174,   251,
     173,   293,   293,     1,   174,   179,   181,   226,   269,   291,
      29,    29,   170,   174,   182,   226,   269,   271,   273,   294,
     183,   183,   183,   183,   171,   183,     1,   171,   225,     1,
     225,   195,     1,   171,   196,   224,     1,   224,   174,   226,
     251,   240,   182,   250,   196,   223,   236,   250,     1,   179,
     184,   171,   263,   263,   184,   278,   273,   158,   159,   179,
     141,   142,   143,   144,   145,   146,   147,   148,   264,   265,
     266,   267,   268,   181,   181,   181,   181,   179,   181,   179,
     181,   179,   181,   181,   181,   181,    26,   174,   181,   174,
     181,   179,   181,   181,     1,   182,   179,   179,   181,   181,
     174,   226,   269,   179,   181,   273,   273,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   187,   278,   278,   278,
     278,   186,   278,   166,   179,     1,   225,   181,   181,   181,
     236,   250,   179,   179,   181,   238,   168,   181,   184,   186,
     263,   263,   174,    29,   250,   226,   174,   269,   174,   174,
      29,   174,   226,   269,   292,   183,   277,   280,   183,    18,
      23,   180,   183,   274,   276,   281,   282,   284,   285,   286,
     294,   269,   174,   251,     1,   181,   291,   252,   252,   174,
     226,   269,   181,   273,   273,   273,   273,   273,   273,   273,
     273,   273,   273,   184,   184,   184,   184,   183,   184,   171,
     171,   179,   179,   181,   250,   224,    25,   181,   181,   181,
     179,   181,   184,   278,    19,    21,   287,   288,   289,   182,
     180,   184,   279,   281,   180,     1,   180,   181,   181,   181,
     181,   181,   179,   181,   179,   181,   278,   166,   250,   224,
     179,   181,   181,   171,    29,   174,   226,   269,   184,   277,
     174,   226,   184,    22,   289,   290,   263,     1,   184,   281,
     276,   171,   174,   184,   171,   179,   181,   181,   224,   204,
     205,   195,   195,   195,   181,   181,   181,   224,   179,   181,
     202,   171,   279,   279,   279,   276,   179,   181,   174,   171,
     202,    19,   174,   181,   203,   171,   276,   181,   171,   203,
     168,   171,    25,   168,   171,    25,   204,   171,   204
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   207,   208,   209,   209,   209,   210,   210,   211,   210,
     212,   210,   213,   210,   214,   210,   215,   210,   216,   210,
     217,   210,   218,   210,   219,   210,   210,   220,   220,   220,
     221,   221,   222,   222,   222,   223,   224,   224,   225,   225,
     225,   225,   226,   226,   226,   227,   227,   227,   227,   228,
     228,   228,   228,   228,   228,   229,   229,   229,   229,   229,
     230,   230,   231,   231,   231,   232,   232,   232,   232,   232,
     232,   232,   233,   233,   234,   235,   234,   236,   236,   237,
     237,   238,   238,   238,   238,   238,   238,   238,   238,   238,
     238,   238,   238,   239,   239,   239,   240,   240,   240,   241,
     241,   242,   242,   242,   243,   243,   243,   243,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   245,   245,   245,   245,   245,   245,   246,
     246,   247,   248,   249,   249,   250,   250,   251,   251,   252,
     252,   252,   253,   253,   254,   254,   254,   255,   255,   256,
     256,   256,   257,   257,   258,   258,   259,   259,   260,   260,
     261,   261,   262,   262,   263,   263,   263,   263,   263,   263,
     264,   264,   265,   265,   265,   265,   266,   266,   267,   267,
     268,   268,   268,   269,   269,   270,   270,   270,   270,   271,
     271,   271,   271,   271,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   273,   273,   273,   273,   273,   273,
     273,   273,   273,   273,   273,   273,   273,   273,   273,   273,
     273,   274,   274,   274,   275,   275,   275,   275,   275,   276,
     276,   276,   277,   277,   277,   278,   278,   278,   279,   279,
     279,   280,   280,   280,   280,   280,   280,   280,   280,   281,
     281,   281,   281,   281,   281,   281,   281,   281,   282,   282,
     283,   283,   284,   285,   286,   287,   287,   288,   288,   289,
     289,   289,   289,   290,   290,   291,   291,   291,   291,   291,
     291,   291,   291,   291,   291,   291,   292,   292,   292,   292,
     292,   292,   292,   292,   293,   293,   293,   293,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   294,   294
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     0,     2,
       0,     2,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     1,     1,     1,     5,     3,
       3,     1,     1,     2,     2,     3,     5,     5,     2,     3,
       3,     5,     5,     5,     5,     1,     3,     5,     5,     1,
       1,     2,     1,     3,     3,     1,     1,     1,     2,     2,
       2,     2,     1,     2,     1,     0,     3,     1,     1,     1,
       2,     9,    10,     7,     8,     5,     6,     5,     6,     3,
       4,     1,     2,     4,     3,     0,     1,     1,     1,     3,
       1,     3,     1,     2,    18,    17,    10,     9,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     3,     3,     3,     3,     5,     3,
       3,     5,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     5,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       5,     5,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     3,     2,     6,     4,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     2,     2,     8,     8,     8,     2,     1,
       1,     1,     1,     1,     3,     1,     1,     2,     2,     1,
       1,     1,     1,     1,     4,     7,     2,     7,     2,     4,
       7,     2,     7,     2,     4,     2,     4,     2,     4,     2,
       9,     2,     7,     2,     3,     3,     2,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       3,     3,     3,     3,     1,     1,     1,     3,     2,     1,
       3,     2,     1,     3,     2,     2,     1,     2,     2,     1,
       2,     2,     1,     1,     1,     1,     2,     1,     2,     2,
       2,     1,     1,     1,     1,     2,     1,     2,     5,     7,
       5,     7,     5,     7,     7,     2,     1,     2,     1,     4,
       3,     4,     3,     3,     2,     1,     3,     1,     2,     2,
       1,     2,     3,     1,     2,     3,     1,     1,     1,     1,
       3,     3,     3,     3,     3,     4,     4,     2,     6,     1,
       3,     1,     3,     2,     4,     2,     4,     3,     1,     4,
       6,     2,     4,     6,     2,     4,     4,     6,     2,     4,
       3,     4,     4,     2,     4,     4,     4,     4,     6,     6,
       6,     8,     8,     6,     4
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* statements: statements statement  */
#line 513 "cfg.y"
                                     {}
#line 2495 "cfg.tab.c"
    break;

  case 4: /* statements: statement  */
#line 514 "cfg.y"
                            {}
#line 2501 "cfg.tab.c"
    break;

  case 5: /* statements: statements error  */
#line 515 "cfg.y"
                                   { yyerror(""); YYABORT;}
#line 2507 "cfg.tab.c"
    break;

  case 8: /* $@1: %empty  */
#line 520 "cfg.y"
                  {rt=REQUEST_ROUTE;}
#line 2513 "cfg.tab.c"
    break;

  case 10: /* $@2: %empty  */
#line 521 "cfg.y"
                  {rt=FAILURE_ROUTE;}
#line 2519 "cfg.tab.c"
    break;

  case 12: /* $@3: %empty  */
#line 522 "cfg.y"
                  {rt=ONREPLY_ROUTE;}
#line 2525 "cfg.tab.c"
    break;

  case 14: /* $@4: %empty  */
#line 523 "cfg.y"
                  {rt=BRANCH_ROUTE;}
#line 2531 "cfg.tab.c"
    break;

  case 16: /* $@5: %empty  */
#line 524 "cfg.y"
                  {rt=ERROR_ROUTE;}
#line 2537 "cfg.tab.c"
    break;

  case 18: /* $@6: %empty  */
#line 525 "cfg.y"
                  {rt=LOCAL_ROUTE;}
#line 2543 "cfg.tab.c"
    break;

  case 20: /* $@7: %empty  */
#line 526 "cfg.y"
                  {rt=STARTUP_ROUTE;}
#line 2549 "cfg.tab.c"
    break;

  case 22: /* $@8: %empty  */
#line 527 "cfg.y"
                  {rt=TIMER_ROUTE;}
#line 2555 "cfg.tab.c"
    break;

  case 24: /* $@9: %empty  */
#line 528 "cfg.y"
                  {rt=EVENT_ROUTE;}
#line 2561 "cfg.tab.c"
    break;

  case 27: /* listen_id: ip  */
#line 533 "cfg.y"
                                        { IFOR();
							tmp=ip_addr2a((yyvsp[0].ipaddr));
							if(tmp==0){
								LM_CRIT("cfg. parser: bad ip address.\n");
								(yyval.strval)=0;
							}else{
								(yyval.strval)=pkg_malloc(strlen(tmp)+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), tmp, strlen(tmp)+1);
								}
							}
						}
#line 2581 "cfg.tab.c"
    break;

  case 28: /* listen_id: STRING  */
#line 548 "cfg.y"
                                        { IFOR();
							(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
							if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
							}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
							}
						}
#line 2595 "cfg.tab.c"
    break;

  case 29: /* listen_id: host  */
#line 557 "cfg.y"
                                        { IFOR();
							if ((yyvsp[0].strval)==0) {
								(yyval.strval) = 0;
							} else {
								(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
								}
							}
						}
#line 2613 "cfg.tab.c"
    break;

  case 30: /* host_sep: DOT  */
#line 572 "cfg.y"
                    {(yyval.strval)=".";}
#line 2619 "cfg.tab.c"
    break;

  case 31: /* host_sep: MINUS  */
#line 573 "cfg.y"
                              {(yyval.strval)="-"; }
#line 2625 "cfg.tab.c"
    break;

  case 32: /* host: ID  */
#line 576 "cfg.y"
                                        { (yyval.strval)=(yyvsp[0].strval); }
#line 2631 "cfg.tab.c"
    break;

  case 33: /* host: host host_sep ID  */
#line 577 "cfg.y"
                                { IFOR();
						(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
						if ((yyval.strval)==0){
							LM_CRIT("cfg. parser: memory allocation"
										" failure while parsing host\n");
							YYABORT;
						}else{
							memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))]=*(yyvsp[-1].strval);
							memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
						}
						pkg_free((yyvsp[-2].strval)); pkg_free((yyvsp[0].strval));
					}
#line 2650 "cfg.tab.c"
    break;

  case 34: /* host: host DOT error  */
#line 591 "cfg.y"
                         { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
					yyerror("invalid hostname (use quotes if hostname "
						"has config keywords)"); }
#line 2658 "cfg.tab.c"
    break;

  case 35: /* proto: ID  */
#line 596 "cfg.y"
           { IFOR();
		if (parse_proto((unsigned char *)(yyvsp[0].strval), strlen((yyvsp[0].strval)), &i_tmp) < 0) {
			yyerrorf("cannot handle protocol <%s>\n", (yyvsp[0].strval));
			YYABORT;
		}
		pkg_free((yyvsp[0].strval));
		(yyval.intval) = i_tmp;
	 }
#line 2671 "cfg.tab.c"
    break;

  case 36: /* port: NUMBER  */
#line 606 "cfg.y"
                        { (yyval.intval)=(yyvsp[0].intval); }
#line 2677 "cfg.tab.c"
    break;

  case 37: /* port: ANY  */
#line 607 "cfg.y"
                                { (yyval.intval)=0; }
#line 2683 "cfg.tab.c"
    break;

  case 38: /* portrange: portrange COMMA NUMBER MINUS NUMBER  */
#line 610 "cfg.y"
                                               { IFOR();
				if ((yyvsp[-2].intval) > (yyvsp[0].intval)) {
					yyerrorf("invalid port range (%d > %d)\n", (yyvsp[-2].intval), (yyvsp[0].intval));
					YYABORT;
				}
				pr_tmp = mk_port_range((yyvsp[-2].intval), (yyvsp[0].intval));
				if (!pr_tmp) {
					yyerror("cannot allocate new portrange\n");
					YYABORT;
				}
				pr_tmp->next = (yyvsp[-4].portrange);
				(yyval.portrange) = pr_tmp;
			}
#line 2701 "cfg.tab.c"
    break;

  case 39: /* portrange: portrange COMMA NUMBER  */
#line 623 "cfg.y"
                                          { IFOR();
				pr_tmp = mk_port_range((yyvsp[0].intval), (yyvsp[0].intval));
				if (!pr_tmp) {
					yyerror("cannot allocate new portrange\n");
					YYABORT;
				}
				pr_tmp->next = (yyvsp[-2].portrange);
				(yyval.portrange) = pr_tmp;
			}
#line 2715 "cfg.tab.c"
    break;

  case 40: /* portrange: NUMBER MINUS NUMBER  */
#line 632 "cfg.y"
                                       { IFOR();
				if ((yyvsp[-2].intval) > (yyvsp[0].intval)) {
					yyerrorf("invalid port range (%d > %d)\n", (yyvsp[-2].intval), (yyvsp[0].intval));
					YYABORT;
				}
				(yyval.portrange)=mk_port_range((yyvsp[-2].intval), (yyvsp[0].intval));
			}
#line 2727 "cfg.tab.c"
    break;

  case 41: /* portrange: NUMBER  */
#line 639 "cfg.y"
                          { IFOR(); (yyval.portrange)=mk_port_range((yyvsp[0].intval), (yyvsp[0].intval)); }
#line 2733 "cfg.tab.c"
    break;

  case 42: /* snumber: NUMBER  */
#line 641 "cfg.y"
                        { (yyval.intval)=(yyvsp[0].intval); }
#line 2739 "cfg.tab.c"
    break;

  case 43: /* snumber: PLUS NUMBER  */
#line 642 "cfg.y"
                                { (yyval.intval)=(yyvsp[0].intval); }
#line 2745 "cfg.tab.c"
    break;

  case 44: /* snumber: MINUS NUMBER  */
#line 643 "cfg.y"
                                { (yyval.intval)=-(yyvsp[0].intval); }
#line 2751 "cfg.tab.c"
    break;

  case 45: /* phostport: proto COLON listen_id  */
#line 647 "cfg.y"
                                        { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 2758 "cfg.tab.c"
    break;

  case 46: /* phostport: proto COLON listen_id COLON port  */
#line 649 "cfg.y"
                                                                { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 2765 "cfg.tab.c"
    break;

  case 47: /* phostport: proto COLON listen_id COLON error  */
#line 651 "cfg.y"
                                                            {
				(yyval.sockid)=0;
				yyerror("port number expected");
				YYABORT;
				}
#line 2775 "cfg.tab.c"
    break;

  case 48: /* phostport: NUMBER error  */
#line 656 "cfg.y"
                                       { (yyval.sockid)=0;
				yyerror("protocol expected");
				YYABORT;
			}
#line 2784 "cfg.tab.c"
    break;

  case 49: /* phostportrange: proto COLON MULT  */
#line 664 "cfg.y"
                                                                { IFOR();
				(yyval.sockid)=mk_listen_id(0, (yyvsp[-2].intval), 0); }
#line 2791 "cfg.tab.c"
    break;

  case 50: /* phostportrange: proto COLON listen_id  */
#line 666 "cfg.y"
                                                { IFOR();
				(yyval.sockid)=mk_listen_id_range((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 2798 "cfg.tab.c"
    break;

  case 51: /* phostportrange: proto COLON MULT COLON portrange  */
#line 668 "cfg.y"
                                                                { IFOR();
				(yyval.sockid)=mk_listen_id_range(0, (yyvsp[-4].intval), (yyvsp[0].portrange)); }
#line 2805 "cfg.tab.c"
    break;

  case 52: /* phostportrange: proto COLON listen_id COLON portrange  */
#line 670 "cfg.y"
                                                                { IFOR();
				(yyval.sockid)=mk_listen_id_range((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].portrange)); }
#line 2812 "cfg.tab.c"
    break;

  case 53: /* phostportrange: proto COLON MULT COLON error  */
#line 672 "cfg.y"
                                                        { IFOR();
				(yyval.sockid)=0;
				yyerror("invalid port range");
				YYABORT;
			}
#line 2822 "cfg.tab.c"
    break;

  case 54: /* phostportrange: proto COLON listen_id COLON error  */
#line 677 "cfg.y"
                                                                { IFOR();
				(yyval.sockid)=0;
				yyerror("invalid port range");
				YYABORT;
			}
#line 2832 "cfg.tab.c"
    break;

  case 55: /* alias_def: listen_id  */
#line 684 "cfg.y"
                                                                        { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2839 "cfg.tab.c"
    break;

  case 56: /* alias_def: ANY COLON listen_id  */
#line 686 "cfg.y"
                                                                        { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2846 "cfg.tab.c"
    break;

  case 57: /* alias_def: ANY COLON listen_id COLON port  */
#line 688 "cfg.y"
                                                        { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 2853 "cfg.tab.c"
    break;

  case 58: /* alias_def: ANY COLON listen_id COLON error  */
#line 690 "cfg.y"
                                                        {
				(yyval.sockid)=0;
				yyerror(" port number expected");
				}
#line 2862 "cfg.tab.c"
    break;

  case 60: /* id_lst: alias_def  */
#line 697 "cfg.y"
                                        { IFOR();  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 2868 "cfg.tab.c"
    break;

  case 61: /* id_lst: alias_def id_lst  */
#line 698 "cfg.y"
                                        { IFOR(); (yyval.sockid)=(yyvsp[-1].sockid); (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 2874 "cfg.tab.c"
    break;

  case 62: /* listen_id_def: listen_id  */
#line 701 "cfg.y"
                                                                { IFOR();
					(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2881 "cfg.tab.c"
    break;

  case 63: /* listen_id_def: listen_id COLON portrange  */
#line 703 "cfg.y"
                                                                { IFOR();
					(yyval.sockid)=mk_listen_id_range((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].portrange)); }
#line 2888 "cfg.tab.c"
    break;

  case 64: /* listen_id_def: listen_id COLON error  */
#line 705 "cfg.y"
                                                      {
					(yyval.sockid)=0;
					yyerror(" port number expected");
					}
#line 2897 "cfg.tab.c"
    break;

  case 65: /* socket_def_param: ANYCAST  */
#line 711 "cfg.y"
                          { IFOR();
					p_tmp.flags |= SI_IS_ANYCAST;
					}
#line 2905 "cfg.tab.c"
    break;

  case 66: /* socket_def_param: FRAG  */
#line 714 "cfg.y"
                                       { IFOR();
					p_tmp.flags |= SI_FRAG;
					}
#line 2913 "cfg.tab.c"
    break;

  case 67: /* socket_def_param: REUSE_PORT  */
#line 717 "cfg.y"
                                             { IFOR();
					p_tmp.flags |= SI_REUSEPORT;
					}
#line 2921 "cfg.tab.c"
    break;

  case 68: /* socket_def_param: USE_WORKERS NUMBER  */
#line 720 "cfg.y"
                                                     { IFOR();
					p_tmp.workers=(yyvsp[0].intval);
					}
#line 2929 "cfg.tab.c"
    break;

  case 69: /* socket_def_param: AS listen_id_def  */
#line 723 "cfg.y"
                                                   { IFOR();
					p_tmp.socket = (yyvsp[0].sockid);
					}
#line 2937 "cfg.tab.c"
    break;

  case 70: /* socket_def_param: TAG ID  */
#line 726 "cfg.y"
                                         { IFOR();
					p_tmp.tag = (yyvsp[0].strval);
					}
#line 2945 "cfg.tab.c"
    break;

  case 71: /* socket_def_param: USE_AUTO_SCALING_PROFILE ID  */
#line 729 "cfg.y"
                                                              { IFOR();
					p_tmp.auto_scaling_profile=(yyvsp[0].strval);
					}
#line 2953 "cfg.tab.c"
    break;

  case 74: /* socket_def: phostportrange  */
#line 738 "cfg.y"
                                { (yyval.sockid)=(yyvsp[0].sockid); }
#line 2959 "cfg.tab.c"
    break;

  case 75: /* $@10: %empty  */
#line 739 "cfg.y"
                                         { IFOR();
					memset(&p_tmp, 0, sizeof(p_tmp));
				}
#line 2967 "cfg.tab.c"
    break;

  case 76: /* socket_def: phostportrange $@10 socket_def_params  */
#line 741 "cfg.y"
                                                        { IFOR();
					(yyval.sockid)=(yyvsp[-2].sockid); fill_socket_id(&p_tmp, (yyval.sockid));
				}
#line 2975 "cfg.tab.c"
    break;

  case 77: /* any_proto: ANY  */
#line 746 "cfg.y"
                        { (yyval.intval)=PROTO_NONE; }
#line 2981 "cfg.tab.c"
    break;

  case 78: /* any_proto: proto  */
#line 747 "cfg.y"
                                { (yyval.intval)=(yyvsp[0].intval); }
#line 2987 "cfg.tab.c"
    break;

  case 79: /* multi_string: STRING  */
#line 749 "cfg.y"
                       {  IFOR(); (yyval.multistr)=new_string((yyvsp[0].strval)); }
#line 2993 "cfg.tab.c"
    break;

  case 80: /* multi_string: STRING multi_string  */
#line 750 "cfg.y"
                                      { IFOR(); (yyval.multistr)=new_string((yyvsp[-1].strval)); (yyval.multistr)->next=(yyvsp[0].multistr); }
#line 2999 "cfg.tab.c"
    break;

  case 81: /* blst_elem: LPAREN any_proto COMMA ipnet COMMA port COMMA STRING RPAREN  */
#line 753 "cfg.y"
                                                                       {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,(yyvsp[-3].intval),(yyvsp[-7].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3012 "cfg.tab.c"
    break;

  case 82: /* blst_elem: NOT LPAREN any_proto COMMA ipnet COMMA port COMMA STRING RPAREN  */
#line 761 "cfg.y"
                                                                                  {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,
				(yyvsp[-3].intval),(yyvsp[-7].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3026 "cfg.tab.c"
    break;

  case 83: /* blst_elem: LPAREN any_proto COMMA ipnet COMMA port RPAREN  */
#line 770 "cfg.y"
                                                                 {
				IFOR(pkg_free((yyvsp[-3].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-3].ipnet),NULL,(yyvsp[-1].intval),(yyvsp[-5].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3037 "cfg.tab.c"
    break;

  case 84: /* blst_elem: NOT LPAREN any_proto COMMA ipnet COMMA port RPAREN  */
#line 776 "cfg.y"
                                                                     {
				IFOR(pkg_free((yyvsp[-3].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-3].ipnet),NULL,
				(yyvsp[-1].intval),(yyvsp[-5].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3049 "cfg.tab.c"
    break;

  case 85: /* blst_elem: LPAREN any_proto COMMA ipnet RPAREN  */
#line 783 "cfg.y"
                                                      {
				IFOR(pkg_free((yyvsp[-1].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-1].ipnet),NULL,0,(yyvsp[-3].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3060 "cfg.tab.c"
    break;

  case 86: /* blst_elem: NOT LPAREN any_proto COMMA ipnet RPAREN  */
#line 789 "cfg.y"
                                                          {
				IFOR(pkg_free((yyvsp[-1].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-1].ipnet),NULL,
				0,(yyvsp[-3].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3072 "cfg.tab.c"
    break;

  case 87: /* blst_elem: LPAREN ipnet COMMA port RPAREN  */
#line 796 "cfg.y"
                                                 {
				IFOR(pkg_free((yyvsp[-3].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-3].ipnet),NULL,(yyvsp[-1].intval),PROTO_NONE,0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3083 "cfg.tab.c"
    break;

  case 88: /* blst_elem: NOT LPAREN ipnet COMMA port RPAREN  */
#line 802 "cfg.y"
                                                     {
				IFOR(pkg_free((yyvsp[-3].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-3].ipnet),NULL,
				(yyvsp[-1].intval),PROTO_NONE,BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3095 "cfg.tab.c"
    break;

  case 89: /* blst_elem: LPAREN ipnet RPAREN  */
#line 809 "cfg.y"
                                      {
				IFOR(pkg_free((yyvsp[-1].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-1].ipnet),NULL,0,PROTO_NONE,0)) {
					yyerror("failed to add backlist element\n"); YYABORT;
				}
			}
#line 3106 "cfg.tab.c"
    break;

  case 90: /* blst_elem: NOT LPAREN ipnet RPAREN  */
#line 815 "cfg.y"
                                          {
				IFOR(pkg_free((yyvsp[-1].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-1].ipnet),NULL,
				0,PROTO_NONE,BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3118 "cfg.tab.c"
    break;

  case 91: /* blst_elem: ipnet  */
#line 822 "cfg.y"
                        {
				IFOR(pkg_free((yyvsp[0].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[0].ipnet),NULL,0,PROTO_NONE,0)) {
					yyerror("failed to add backlist element\n"); YYABORT;
				}
			}
#line 3129 "cfg.tab.c"
    break;

  case 92: /* blst_elem: NOT ipnet  */
#line 828 "cfg.y"
                            {
				IFOR(pkg_free((yyvsp[0].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[0].ipnet),NULL,
				0,PROTO_NONE,BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3141 "cfg.tab.c"
    break;

  case 96: /* blst_flag: READONLY  */
#line 842 "cfg.y"
                    { (yyval.intval) = BL_READONLY_LIST; }
#line 3147 "cfg.tab.c"
    break;

  case 97: /* blst_flag: EXPIRE  */
#line 843 "cfg.y"
                          { (yyval.intval) = BL_DO_EXPIRE; }
#line 3153 "cfg.tab.c"
    break;

  case 98: /* blst_flag: DEFAULT  */
#line 844 "cfg.y"
                           { (yyval.intval) = BL_BY_DEFAULT; }
#line 3159 "cfg.tab.c"
    break;

  case 99: /* blst_flags: blst_flags COMMA blst_flag  */
#line 847 "cfg.y"
                                       { (yyval.intval) = (yyvsp[-2].intval) | (yyvsp[0].intval); }
#line 3165 "cfg.tab.c"
    break;

  case 100: /* blst_flags: blst_flag  */
#line 848 "cfg.y"
                            {}
#line 3171 "cfg.tab.c"
    break;

  case 101: /* blst_elem_list: blst_elem_list COMMA blst_elem  */
#line 851 "cfg.y"
                                               {}
#line 3177 "cfg.tab.c"
    break;

  case 102: /* blst_elem_list: blst_elem  */
#line 852 "cfg.y"
                            {}
#line 3183 "cfg.tab.c"
    break;

  case 103: /* blst_elem_list: blst_elem_list error  */
#line 853 "cfg.y"
                                       { yyerror("bad black list element");}
#line 3189 "cfg.tab.c"
    break;

  case 104: /* auto_scale_profile_def: ID SCALE_UP_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES_WITHIN NUMBER SCALE_DOWN_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES  */
#line 860 "cfg.y"
                                              { IFOR();
			if (create_auto_scaling_profile((yyvsp[-17].strval),(yyvsp[-15].intval),(yyvsp[-13].intval),(yyvsp[-10].intval),(yyvsp[-8].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval),10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 3199 "cfg.tab.c"
    break;

  case 105: /* auto_scale_profile_def: ID SCALE_UP_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES SCALE_DOWN_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES  */
#line 868 "cfg.y"
                                              { IFOR();
			if (create_auto_scaling_profile((yyvsp[-16].strval),(yyvsp[-14].intval),(yyvsp[-12].intval),(yyvsp[-9].intval),(yyvsp[-9].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval), 10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 3209 "cfg.tab.c"
    break;

  case 106: /* auto_scale_profile_def: ID SCALE_UP_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES_WITHIN NUMBER  */
#line 874 "cfg.y"
                                                            { IFOR();
			if (create_auto_scaling_profile((yyvsp[-9].strval),(yyvsp[-7].intval),(yyvsp[-5].intval),(yyvsp[-2].intval),(yyvsp[0].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 3219 "cfg.tab.c"
    break;

  case 107: /* auto_scale_profile_def: ID SCALE_UP_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES  */
#line 880 "cfg.y"
                                              { IFOR();
			if (create_auto_scaling_profile((yyvsp[-8].strval),(yyvsp[-6].intval),(yyvsp[-4].intval),(yyvsp[-1].intval),(yyvsp[-1].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 3229 "cfg.tab.c"
    break;

  case 108: /* assign_stm: LOGLEVEL EQUAL snumber  */
#line 887 "cfg.y"
                                   { IFOR();
			/* in debug mode, force logging to DEBUG level*/
			*log_level = debug_mode?L_DBG:(yyvsp[0].intval);
			}
#line 3238 "cfg.tab.c"
    break;

  case 109: /* assign_stm: LOGPREFIX EQUAL STRING  */
#line 891 "cfg.y"
                                         { IFOR();
			if (*(yyvsp[0].strval)) {
				int len = strlen((yyvsp[0].strval));
				char *buf = pkg_malloc(len + 2);
				if (!buf)
					yyerror("oom");
				sprintf(buf, "%s:", (yyvsp[0].strval));
				log_prefix = buf;
			} else {
				log_prefix = (yyvsp[0].strval);
			}
			}
#line 3255 "cfg.tab.c"
    break;

  case 110: /* assign_stm: LOGPREFIX EQUAL error  */
#line 903 "cfg.y"
                                         { yyerror("string value expected"); }
#line 3261 "cfg.tab.c"
    break;

  case 111: /* assign_stm: ENABLE_ASSERTS EQUAL NUMBER  */
#line 904 "cfg.y"
                                               { IFOR(); enable_asserts=(yyvsp[0].intval); }
#line 3267 "cfg.tab.c"
    break;

  case 112: /* assign_stm: ENABLE_ASSERTS EQUAL error  */
#line 905 "cfg.y"
                                              { yyerror("boolean value expected"); }
#line 3273 "cfg.tab.c"
    break;

  case 113: /* assign_stm: ABORT_ON_ASSERT EQUAL NUMBER  */
#line 906 "cfg.y"
                                                { IFOR(); abort_on_assert=(yyvsp[0].intval); }
#line 3279 "cfg.tab.c"
    break;

  case 114: /* assign_stm: ABORT_ON_ASSERT EQUAL error  */
#line 907 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 3285 "cfg.tab.c"
    break;

  case 115: /* assign_stm: DEBUG_MODE EQUAL NUMBER  */
#line 908 "cfg.y"
                                           { IFOR();
			debug_mode=(yyvsp[0].intval);
			if (debug_mode) {
				*log_level = L_DBG;
				stderr_enabled=1;
				syslog_enabled=0;

				s_tmp.s=STDERR_CONSUMER_NAME;
				s_tmp.len=strlen(STDERR_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, 0);
				s_tmp.s=SYSLOG_CONSUMER_NAME;
				s_tmp.len=strlen(SYSLOG_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, 1);
			}
			}
#line 3305 "cfg.tab.c"
    break;

  case 116: /* assign_stm: DEBUG_MODE EQUAL error  */
#line 924 "cfg.y"
                        { yyerror("boolean value expected for debug_mode"); }
#line 3311 "cfg.tab.c"
    break;

  case 117: /* assign_stm: LOGSTDOUT EQUAL NUMBER  */
#line 927 "cfg.y"
                        { IFOR(); log_stdout=(yyvsp[0].intval); }
#line 3317 "cfg.tab.c"
    break;

  case 118: /* assign_stm: LOGSTDOUT EQUAL error  */
#line 928 "cfg.y"
                                        { yyerror("boolean value expected"); }
#line 3323 "cfg.tab.c"
    break;

  case 119: /* assign_stm: LOGSTDERROR EQUAL NUMBER  */
#line 929 "cfg.y"
                                           {
			IFOR();
			warn("'log_stderror' is deprecated, use 'stderror_enabled' and/or"
				"'syslog_enabled' instead");
			if (!config_check && !debug_mode) {
				if ((yyvsp[0].intval)) {
					stderr_enabled=1;
					syslog_enabled=0;
				} else {
					stderr_enabled=0;
					syslog_enabled=1;
				}

				s_tmp.s=STDERR_CONSUMER_NAME;
				s_tmp.len=strlen(STDERR_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, !(yyvsp[0].intval));
				s_tmp.s=SYSLOG_CONSUMER_NAME;
				s_tmp.len=strlen(SYSLOG_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, (yyvsp[0].intval));
			}
			}
#line 3349 "cfg.tab.c"
    break;

  case 120: /* assign_stm: LOGSTDERROR EQUAL error  */
#line 950 "cfg.y"
                                          { yyerror("boolean value expected"); }
#line 3355 "cfg.tab.c"
    break;

  case 121: /* assign_stm: STDERROR_ENABLED EQUAL NUMBER  */
#line 951 "cfg.y"
                                                {
			/* in config-check or debug mode we force logging
			 * to standard error */
			IFOR();
			if (!config_check && !debug_mode) {
				stderr_enabled=(yyvsp[0].intval);
				s_tmp.s=STDERR_CONSUMER_NAME;
				s_tmp.len=strlen(STDERR_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, !(yyvsp[0].intval));
			}
			}
#line 3371 "cfg.tab.c"
    break;

  case 122: /* assign_stm: STDERROR_ENABLED EQUAL error  */
#line 962 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 3377 "cfg.tab.c"
    break;

  case 123: /* assign_stm: SYSLOG_ENABLED EQUAL NUMBER  */
#line 963 "cfg.y"
                                              {
			IFOR();
			/* in config-check or debug mode we force logging
			 * to standard error */
			if (!config_check && !debug_mode) {
				syslog_enabled=(yyvsp[0].intval);
				s_tmp.s=SYSLOG_CONSUMER_NAME;
				s_tmp.len=strlen(SYSLOG_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, !(yyvsp[0].intval));
			}
			}
#line 3393 "cfg.tab.c"
    break;

  case 124: /* assign_stm: SYSLOG_ENABLED EQUAL error  */
#line 974 "cfg.y"
                                             { yyerror("boolean value expected"); }
#line 3399 "cfg.tab.c"
    break;

  case 125: /* assign_stm: LOG_EVENT_ENABLED EQUAL NUMBER  */
#line 975 "cfg.y"
                                                 {
			IFOR();
			if ((yyvsp[0].intval)) {
				if (init_log_msg_buf(0) < 0) {
					yyerror("failed to allocate msg log buffer");
					YYABORT;
				}
			}
			log_event_enabled=(yyvsp[0].intval); }
#line 3413 "cfg.tab.c"
    break;

  case 126: /* assign_stm: LOG_EVENT_ENABLED EQUAL error  */
#line 984 "cfg.y"
                                                { yyerror("boolean value expected"); }
#line 3419 "cfg.tab.c"
    break;

  case 127: /* assign_stm: STDERROR_LEVEL_FILTER EQUAL snumber  */
#line 985 "cfg.y"
                                                      {
			IFOR();
			s_tmp.s=STDERR_CONSUMER_NAME;
			s_tmp.len=strlen(STDERR_CONSUMER_NAME);
			set_log_consumer_level_filter(&s_tmp, (yyvsp[0].intval));
			}
#line 3430 "cfg.tab.c"
    break;

  case 128: /* assign_stm: STDERROR_LEVEL_FILTER EQUAL error  */
#line 991 "cfg.y"
                                                    { yyerror("number expected"); }
#line 3436 "cfg.tab.c"
    break;

  case 129: /* assign_stm: SYSLOG_LEVEL_FILTER EQUAL snumber  */
#line 992 "cfg.y"
                                                    {
			IFOR();
			s_tmp.s=SYSLOG_CONSUMER_NAME;
			s_tmp.len=strlen(SYSLOG_CONSUMER_NAME);
			set_log_consumer_level_filter(&s_tmp, (yyvsp[0].intval));
			}
#line 3447 "cfg.tab.c"
    break;

  case 130: /* assign_stm: SYSLOG_LEVEL_FILTER EQUAL error  */
#line 998 "cfg.y"
                                                  { yyerror("number expected"); }
#line 3453 "cfg.tab.c"
    break;

  case 131: /* assign_stm: LOG_EVENT_LEVEL_FILTER EQUAL snumber  */
#line 999 "cfg.y"
                                                       { IFOR();
							log_event_level_filter = (yyvsp[0].intval); }
#line 3460 "cfg.tab.c"
    break;

  case 132: /* assign_stm: LOG_EVENT_LEVEL_FILTER EQUAL error  */
#line 1001 "cfg.y"
                                                     { yyerror("number expected"); }
#line 3466 "cfg.tab.c"
    break;

  case 133: /* assign_stm: STDERROR_FORMAT EQUAL STRING  */
#line 1002 "cfg.y"
                                               { IFOR();
			s_tmp.s = (yyvsp[0].strval);
			s_tmp.len = strlen((yyvsp[0].strval));
			if ((i_tmp = parse_log_format(&s_tmp)) < 0) {
				yyerror("unknown log format");
			} else {
				if (i_tmp != LOG_FORMAT_PLAIN) {
					if (init_log_json_buf(0) < 0) {
						yyerror("failed to allocate json log buffer");
						YYABORT;
					}
					if (init_log_msg_buf(0) < 0) {
						yyerror("failed to allocate msg log buffer");
						YYABORT;
					}

					if (i_tmp == LOG_FORMAT_JSON_CEE && init_log_cee_hostname() < 0) {
						yyerror("failed to allocate hostname buffer");
						YYABORT;
					}
				}

				stderr_log_format = i_tmp;
			}
			}
#line 3496 "cfg.tab.c"
    break;

  case 134: /* assign_stm: SYSLOG_FORMAT EQUAL STRING  */
#line 1027 "cfg.y"
                                             { IFOR();
			s_tmp.s = (yyvsp[0].strval);
			s_tmp.len = strlen((yyvsp[0].strval));
			if ((i_tmp = parse_log_format(&s_tmp)) < 0) {
				yyerror("unknown log format");
			} else {
				if (i_tmp != LOG_FORMAT_PLAIN) {
					if (init_log_json_buf(0) < 0) {
						yyerror("failed to allocate json log buffer");
						YYABORT;
					}
					if (init_log_msg_buf(0) < 0) {
						yyerror("failed to allocate msg log buffer");
						YYABORT;
					}

					if (i_tmp == LOG_FORMAT_JSON_CEE && init_log_cee_hostname() < 0) {
						yyerror("failed to allocate hostname buffer");
						YYABORT;
					}
				}

				syslog_log_format = i_tmp;
			}
			}
#line 3526 "cfg.tab.c"
    break;

  case 135: /* assign_stm: LOG_JSON_BUF_SIZE EQUAL NUMBER  */
#line 1052 "cfg.y"
                                                 {
			IFOR();
			log_json_buf_size = (yyvsp[0].intval);
			if (init_log_json_buf(1) < 0) {
				yyerror("failed to realloc json log buffer");
				YYABORT;
			}
			}
#line 3539 "cfg.tab.c"
    break;

  case 136: /* assign_stm: LOG_JSON_BUF_SIZE EQUAL error  */
#line 1060 "cfg.y"
                                                { yyerror("number expected"); }
#line 3545 "cfg.tab.c"
    break;

  case 137: /* assign_stm: LOG_MSG_BUF_SIZE EQUAL NUMBER  */
#line 1061 "cfg.y"
                                                {
			IFOR();
			log_msg_buf_size = (yyvsp[0].intval);
			if (init_log_msg_buf(1) < 0) {
				yyerror("failed to realloc msg log buffer");
				YYABORT;
			}
			}
#line 3558 "cfg.tab.c"
    break;

  case 138: /* assign_stm: LOG_MSG_BUF_SIZE EQUAL error  */
#line 1069 "cfg.y"
                                               { yyerror("number expected"); }
#line 3564 "cfg.tab.c"
    break;

  case 139: /* assign_stm: LOGFACILITY EQUAL ID  */
#line 1070 "cfg.y"
                                       { IFOR();
			warn("'log_facility' is deprecated, use 'syslog_facility' instead");
			if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
				yyerror("bad facility (see syslog(3) man page)");
			if (!config_check)
				log_facility=i_tmp;
			}
#line 3576 "cfg.tab.c"
    break;

  case 140: /* assign_stm: LOGFACILITY EQUAL error  */
#line 1077 "cfg.y"
                                          { yyerror("ID expected"); }
#line 3582 "cfg.tab.c"
    break;

  case 141: /* assign_stm: SYSLOG_FACILITY EQUAL ID  */
#line 1078 "cfg.y"
                                           { IFOR();
			if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
				yyerror("bad facility (see syslog(3) man page)");
			if (!config_check)
				log_facility=i_tmp;
			}
#line 3593 "cfg.tab.c"
    break;

  case 142: /* assign_stm: SYSLOG_FACILITY EQUAL error  */
#line 1084 "cfg.y"
                                              { yyerror("ID expected"); }
#line 3599 "cfg.tab.c"
    break;

  case 143: /* assign_stm: LOGNAME EQUAL STRING  */
#line 1085 "cfg.y"
                                       { IFOR();
			warn("'log_name' is deprecated, use 'syslog_name' instead");
			log_name=(yyvsp[0].strval); }
#line 3607 "cfg.tab.c"
    break;

  case 144: /* assign_stm: LOGNAME EQUAL error  */
#line 1088 "cfg.y"
                                      { yyerror("string value expected"); }
#line 3613 "cfg.tab.c"
    break;

  case 145: /* assign_stm: SYSLOG_NAME EQUAL STRING  */
#line 1089 "cfg.y"
                                           { IFOR(); log_name=(yyvsp[0].strval); }
#line 3619 "cfg.tab.c"
    break;

  case 146: /* assign_stm: SYSLOG_NAME EQUAL error  */
#line 1090 "cfg.y"
                                          { yyerror("string value expected"); }
#line 3625 "cfg.tab.c"
    break;

  case 147: /* assign_stm: DNS EQUAL NUMBER  */
#line 1091 "cfg.y"
                                     { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 3631 "cfg.tab.c"
    break;

  case 148: /* assign_stm: DNS EQUAL error  */
#line 1092 "cfg.y"
                                  { yyerror("boolean value expected"); }
#line 3637 "cfg.tab.c"
    break;

  case 149: /* assign_stm: REV_DNS EQUAL NUMBER  */
#line 1093 "cfg.y"
                                       { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 3643 "cfg.tab.c"
    break;

  case 150: /* assign_stm: REV_DNS EQUAL error  */
#line 1094 "cfg.y"
                                      { yyerror("boolean value expected"); }
#line 3649 "cfg.tab.c"
    break;

  case 151: /* assign_stm: DNS_TRY_IPV6 EQUAL NUMBER  */
#line 1095 "cfg.y"
                                              { IFOR(); dns_try_ipv6=(yyvsp[0].intval); }
#line 3655 "cfg.tab.c"
    break;

  case 152: /* assign_stm: DNS_TRY_IPV6 error  */
#line 1096 "cfg.y"
                                     { yyerror("boolean value expected"); }
#line 3661 "cfg.tab.c"
    break;

  case 153: /* assign_stm: DNS_TRY_NAPTR EQUAL NUMBER  */
#line 1097 "cfg.y"
                                               { IFOR(); dns_try_naptr=(yyvsp[0].intval); }
#line 3667 "cfg.tab.c"
    break;

  case 154: /* assign_stm: DNS_TRY_NAPTR error  */
#line 1098 "cfg.y"
                                      { yyerror("boolean value expected"); }
#line 3673 "cfg.tab.c"
    break;

  case 155: /* assign_stm: DNS_RETR_TIME EQUAL NUMBER  */
#line 1099 "cfg.y"
                                               { IFOR(); dns_retr_time=(yyvsp[0].intval); }
#line 3679 "cfg.tab.c"
    break;

  case 156: /* assign_stm: DNS_RETR_TIME error  */
#line 1100 "cfg.y"
                                      { yyerror("number expected"); }
#line 3685 "cfg.tab.c"
    break;

  case 157: /* assign_stm: DNS_RETR_NO EQUAL NUMBER  */
#line 1101 "cfg.y"
                                             { IFOR(); dns_retr_no=(yyvsp[0].intval); }
#line 3691 "cfg.tab.c"
    break;

  case 158: /* assign_stm: DNS_RETR_NO error  */
#line 1102 "cfg.y"
                                    { yyerror("number expected"); }
#line 3697 "cfg.tab.c"
    break;

  case 159: /* assign_stm: DNS_SERVERS_NO EQUAL NUMBER  */
#line 1103 "cfg.y"
                                                { IFOR(); dns_servers_no=(yyvsp[0].intval); }
#line 3703 "cfg.tab.c"
    break;

  case 160: /* assign_stm: DNS_SERVERS_NO error  */
#line 1104 "cfg.y"
                                       { yyerror("number expected"); }
#line 3709 "cfg.tab.c"
    break;

  case 161: /* assign_stm: DNS_USE_SEARCH EQUAL NUMBER  */
#line 1105 "cfg.y"
                                                { IFOR(); dns_search_list=(yyvsp[0].intval); }
#line 3715 "cfg.tab.c"
    break;

  case 162: /* assign_stm: DNS_USE_SEARCH error  */
#line 1106 "cfg.y"
                                       { yyerror("boolean value expected"); }
#line 3721 "cfg.tab.c"
    break;

  case 163: /* assign_stm: MAX_WHILE_LOOPS EQUAL NUMBER  */
#line 1107 "cfg.y"
                                               { IFOR(); max_while_loops=(yyvsp[0].intval); }
#line 3727 "cfg.tab.c"
    break;

  case 164: /* assign_stm: MAX_WHILE_LOOPS EQUAL error  */
#line 1108 "cfg.y"
                                              { yyerror("number expected"); }
#line 3733 "cfg.tab.c"
    break;

  case 165: /* assign_stm: MAXBUFFER EQUAL NUMBER  */
#line 1109 "cfg.y"
                                         { IFOR(); maxbuffer=(yyvsp[0].intval); }
#line 3739 "cfg.tab.c"
    break;

  case 166: /* assign_stm: MAXBUFFER EQUAL error  */
#line 1110 "cfg.y"
                                        { yyerror("number expected"); }
#line 3745 "cfg.tab.c"
    break;

  case 167: /* assign_stm: UDP_WORKERS EQUAL NUMBER  */
#line 1111 "cfg.y"
                                           { IFOR(); udp_workers_no=(yyvsp[0].intval); }
#line 3751 "cfg.tab.c"
    break;

  case 168: /* assign_stm: UDP_WORKERS EQUAL NUMBER USE_AUTO_SCALING_PROFILE ID  */
#line 1112 "cfg.y"
                                                                       { IFOR();
				udp_workers_no=(yyvsp[-2].intval);
				udp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3760 "cfg.tab.c"
    break;

  case 169: /* assign_stm: UDP_WORKERS EQUAL error  */
#line 1116 "cfg.y"
                                          { yyerror("number expected"); }
#line 3766 "cfg.tab.c"
    break;

  case 170: /* assign_stm: TIMER_WORKERS EQUAL NUMBER  */
#line 1117 "cfg.y"
                                             { IFOR();
				timer_workers_no=(yyvsp[0].intval);
		}
#line 3774 "cfg.tab.c"
    break;

  case 171: /* assign_stm: TIMER_WORKERS EQUAL NUMBER USE_AUTO_SCALING_PROFILE ID  */
#line 1120 "cfg.y"
                                                                         { IFOR();
				timer_workers_no=(yyvsp[-2].intval);
				timer_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3783 "cfg.tab.c"
    break;

  case 172: /* assign_stm: CHECK_VIA EQUAL NUMBER  */
#line 1124 "cfg.y"
                                         { check_via=(yyvsp[0].intval); }
#line 3789 "cfg.tab.c"
    break;

  case 173: /* assign_stm: CHECK_VIA EQUAL error  */
#line 1125 "cfg.y"
                                        { yyerror("boolean value expected"); }
#line 3795 "cfg.tab.c"
    break;

  case 174: /* assign_stm: SHM_HASH_SPLIT_PERCENTAGE EQUAL NUMBER  */
#line 1126 "cfg.y"
                                                         { IFOR();
			#ifdef HP_MALLOC
			shm_hash_split_percentage=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3808 "cfg.tab.c"
    break;

  case 175: /* assign_stm: SHM_HASH_SPLIT_PERCENTAGE EQUAL error  */
#line 1134 "cfg.y"
                                                        {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
				}
#line 3821 "cfg.tab.c"
    break;

  case 176: /* assign_stm: SHM_SECONDARY_HASH_SIZE EQUAL NUMBER  */
#line 1142 "cfg.y"
                                                       { IFOR();
			#ifdef HP_MALLOC
			shm_secondary_hash_size=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3834 "cfg.tab.c"
    break;

  case 177: /* assign_stm: SHM_SECONDARY_HASH_SIZE EQUAL error  */
#line 1150 "cfg.y"
                                                      {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3847 "cfg.tab.c"
    break;

  case 178: /* assign_stm: MEM_WARMING_ENABLED EQUAL NUMBER  */
#line 1158 "cfg.y"
                                                   { IFOR();
			#ifdef HP_MALLOC
			mem_warming_enabled = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3860 "cfg.tab.c"
    break;

  case 179: /* assign_stm: MEM_WARMING_ENABLED EQUAL error  */
#line 1166 "cfg.y"
                                                  {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3873 "cfg.tab.c"
    break;

  case 180: /* assign_stm: MEM_WARMING_PATTERN_FILE EQUAL STRING  */
#line 1174 "cfg.y"
                                                        { IFOR();
			#ifdef HP_MALLOC
			mem_warming_pattern_file = (yyvsp[0].strval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3886 "cfg.tab.c"
    break;

  case 181: /* assign_stm: MEM_WARMING_PATTERN_FILE EQUAL error  */
#line 1182 "cfg.y"
                                                       {
			#ifdef HP_MALLOC
			yyerror("string expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3899 "cfg.tab.c"
    break;

  case 182: /* assign_stm: MEM_WARMING_PERCENTAGE EQUAL NUMBER  */
#line 1190 "cfg.y"
                                                      { IFOR();
			#ifdef HP_MALLOC
			mem_warming_percentage = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3912 "cfg.tab.c"
    break;

  case 183: /* assign_stm: MEM_WARMING_PERCENTAGE EQUAL error  */
#line 1198 "cfg.y"
                                                     {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3925 "cfg.tab.c"
    break;

  case 184: /* assign_stm: RPM_MEM_FILE EQUAL STRING  */
#line 1206 "cfg.y"
                                            { IFOR();
			rpm_mem_file = (yyvsp[0].strval);
			}
#line 3933 "cfg.tab.c"
    break;

  case 185: /* assign_stm: RPM_MEM_FILE EQUAL error  */
#line 1209 "cfg.y"
                                           { yyerror("string value expected"); }
#line 3939 "cfg.tab.c"
    break;

  case 186: /* assign_stm: RPM_MEM_SIZE EQUAL NUMBER  */
#line 1210 "cfg.y"
                                            { IFOR();
			rpm_mem_size = (yyvsp[0].intval) * 1024 * 1024;
			}
#line 3947 "cfg.tab.c"
    break;

  case 187: /* assign_stm: RPM_MEM_SIZE EQUAL error  */
#line 1213 "cfg.y"
                                           { yyerror("int value expected"); }
#line 3953 "cfg.tab.c"
    break;

  case 188: /* assign_stm: MEMLOG EQUAL snumber  */
#line 1214 "cfg.y"
                                       { IFOR(); memlog=(yyvsp[0].intval); memdump=(yyvsp[0].intval); }
#line 3959 "cfg.tab.c"
    break;

  case 189: /* assign_stm: MEMLOG EQUAL error  */
#line 1215 "cfg.y"
                                     { yyerror("int value expected"); }
#line 3965 "cfg.tab.c"
    break;

  case 190: /* assign_stm: SHM_MEMLOG_SIZE EQUAL snumber  */
#line 1216 "cfg.y"
                                                { IFOR(); shm_memlog_size=(yyvsp[0].intval);}
#line 3971 "cfg.tab.c"
    break;

  case 191: /* assign_stm: SHM_MEMLOG_SIZE EQUAL error  */
#line 1217 "cfg.y"
                                              { yyerror("int value expected"); }
#line 3977 "cfg.tab.c"
    break;

  case 192: /* assign_stm: MEMDUMP EQUAL snumber  */
#line 1218 "cfg.y"
                                        { IFOR(); memdump=(yyvsp[0].intval); }
#line 3983 "cfg.tab.c"
    break;

  case 193: /* assign_stm: MEMDUMP EQUAL error  */
#line 1219 "cfg.y"
                                      { yyerror("int value expected"); }
#line 3989 "cfg.tab.c"
    break;

  case 194: /* assign_stm: EXECMSGTHRESHOLD EQUAL NUMBER  */
#line 1220 "cfg.y"
                                                {  IFOR();execmsgthreshold=(yyvsp[0].intval); }
#line 3995 "cfg.tab.c"
    break;

  case 195: /* assign_stm: EXECMSGTHRESHOLD EQUAL error  */
#line 1221 "cfg.y"
                                               { yyerror("int value expected"); }
#line 4001 "cfg.tab.c"
    break;

  case 196: /* assign_stm: EXECDNSTHRESHOLD EQUAL NUMBER  */
#line 1222 "cfg.y"
                                                { IFOR(); execdnsthreshold=(yyvsp[0].intval); }
#line 4007 "cfg.tab.c"
    break;

  case 197: /* assign_stm: EXECDNSTHRESHOLD EQUAL error  */
#line 1223 "cfg.y"
                                               { yyerror("int value expected"); }
#line 4013 "cfg.tab.c"
    break;

  case 198: /* assign_stm: TCPTHRESHOLD EQUAL NUMBER  */
#line 1224 "cfg.y"
                                            { IFOR(); tcpthreshold=(yyvsp[0].intval); }
#line 4019 "cfg.tab.c"
    break;

  case 199: /* assign_stm: TCPTHRESHOLD EQUAL error  */
#line 1225 "cfg.y"
                                           { yyerror("int value expected"); }
#line 4025 "cfg.tab.c"
    break;

  case 200: /* assign_stm: EVENT_SHM_THRESHOLD EQUAL NUMBER  */
#line 1226 "cfg.y"
                                                   { IFOR();
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("SHM threshold has to be a percentage between"
					" 0 and 100");
			event_shm_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif /* STATISTICS */
			}
#line 4040 "cfg.tab.c"
    break;

  case 201: /* assign_stm: EVENT_SHM_THRESHOLD EQUAL error  */
#line 1236 "cfg.y"
                                                  { yyerror("int value expected"); }
#line 4046 "cfg.tab.c"
    break;

  case 202: /* assign_stm: EVENT_PKG_THRESHOLD EQUAL NUMBER  */
#line 1237 "cfg.y"
                                                   { IFOR();
			#ifdef PKG_MALLOC
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("PKG threshold has to be a percentage between "
					"0 and 100");
			event_pkg_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif
			#else
			yyerror("pkg_malloc support not compiled in");
			#endif
			}
#line 4065 "cfg.tab.c"
    break;

  case 203: /* assign_stm: EVENT_PKG_THRESHOLD EQUAL error  */
#line 1251 "cfg.y"
                                                  { yyerror("int value expected"); }
#line 4071 "cfg.tab.c"
    break;

  case 204: /* assign_stm: QUERYBUFFERSIZE EQUAL NUMBER  */
#line 1252 "cfg.y"
                                               { IFOR(); query_buffer_size=(yyvsp[0].intval); }
#line 4077 "cfg.tab.c"
    break;

  case 205: /* assign_stm: QUERYBUFFERSIZE EQUAL error  */
#line 1253 "cfg.y"
                                              { yyerror("int value expected"); }
#line 4083 "cfg.tab.c"
    break;

  case 206: /* assign_stm: QUERYFLUSHTIME EQUAL NUMBER  */
#line 1254 "cfg.y"
                                              { IFOR(); query_flush_time=(yyvsp[0].intval); }
#line 4089 "cfg.tab.c"
    break;

  case 207: /* assign_stm: QUERYFLUSHTIME EQUAL error  */
#line 1255 "cfg.y"
                                             { yyerror("int value expected"); }
#line 4095 "cfg.tab.c"
    break;

  case 208: /* assign_stm: SIP_WARNING EQUAL NUMBER  */
#line 1256 "cfg.y"
                                           { IFOR(); sip_warning=(yyvsp[0].intval); }
#line 4101 "cfg.tab.c"
    break;

  case 209: /* assign_stm: SIP_WARNING EQUAL error  */
#line 1257 "cfg.y"
                                          { yyerror("boolean value expected"); }
#line 4107 "cfg.tab.c"
    break;

  case 210: /* assign_stm: CHROOT EQUAL STRING  */
#line 1258 "cfg.y"
                                          { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 4113 "cfg.tab.c"
    break;

  case 211: /* assign_stm: CHROOT EQUAL ID  */
#line 1259 "cfg.y"
                                          { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 4119 "cfg.tab.c"
    break;

  case 212: /* assign_stm: CHROOT EQUAL error  */
#line 1260 "cfg.y"
                                          { yyerror("string value expected"); }
#line 4125 "cfg.tab.c"
    break;

  case 213: /* assign_stm: WDIR EQUAL STRING  */
#line 1261 "cfg.y"
                                        { IFOR(); working_dir=(yyvsp[0].strval); }
#line 4131 "cfg.tab.c"
    break;

  case 214: /* assign_stm: WDIR EQUAL ID  */
#line 1262 "cfg.y"
                                        { IFOR(); working_dir=(yyvsp[0].strval); }
#line 4137 "cfg.tab.c"
    break;

  case 215: /* assign_stm: WDIR EQUAL error  */
#line 1263 "cfg.y"
                                        { yyerror("string value expected"); }
#line 4143 "cfg.tab.c"
    break;

  case 216: /* assign_stm: MHOMED EQUAL NUMBER  */
#line 1264 "cfg.y"
                                      { IFOR(); mhomed=(yyvsp[0].intval); }
#line 4149 "cfg.tab.c"
    break;

  case 217: /* assign_stm: MHOMED EQUAL error  */
#line 1265 "cfg.y"
                                     { yyerror("boolean value expected"); }
#line 4155 "cfg.tab.c"
    break;

  case 218: /* assign_stm: POLL_METHOD EQUAL ID  */
#line 1266 "cfg.y"
                                       { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
								}
#line 4170 "cfg.tab.c"
    break;

  case 219: /* assign_stm: POLL_METHOD EQUAL STRING  */
#line 1276 "cfg.y"
                                           { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
									}
#line 4185 "cfg.tab.c"
    break;

  case 220: /* assign_stm: POLL_METHOD EQUAL error  */
#line 1286 "cfg.y"
                                          { yyerror("poll method name expected"); }
#line 4191 "cfg.tab.c"
    break;

  case 221: /* assign_stm: TCP_ACCEPT_ALIASES EQUAL NUMBER  */
#line 1287 "cfg.y"
                                                  { IFOR();
				if ((yyvsp[0].intval) < TCP_ALIAS_NEVER || (yyvsp[0].intval) > TCP_ALIAS_ALWAYS)
					yyerror("invalid 'tcp_accept_aliases' value");
				tcp_accept_aliases=(yyvsp[0].intval);
		}
#line 4201 "cfg.tab.c"
    break;

  case 222: /* assign_stm: TCP_ACCEPT_ALIASES EQUAL error  */
#line 1292 "cfg.y"
                                                 { yyerror("boolean value expected"); }
#line 4207 "cfg.tab.c"
    break;

  case 223: /* assign_stm: TCP_WORKERS EQUAL NUMBER  */
#line 1293 "cfg.y"
                                           { IFOR();
				tcp_workers_no=(yyvsp[0].intval);
		}
#line 4215 "cfg.tab.c"
    break;

  case 224: /* assign_stm: TCP_WORKERS EQUAL NUMBER USE_AUTO_SCALING_PROFILE ID  */
#line 1296 "cfg.y"
                                                                      { IFOR();
				tcp_workers_no=(yyvsp[-2].intval);
				tcp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 4224 "cfg.tab.c"
    break;

  case 225: /* assign_stm: TCP_WORKERS EQUAL error  */
#line 1300 "cfg.y"
                                          { yyerror("number expected"); }
#line 4230 "cfg.tab.c"
    break;

  case 226: /* assign_stm: TCP_CONNECT_TIMEOUT EQUAL NUMBER  */
#line 1301 "cfg.y"
                                                   { IFOR();
				if ((yyvsp[0].intval) <= 0)
					yyerror("invalid 'tcp_connect_timeout' (value too low!)");
				tcp_connect_timeout=(yyvsp[0].intval);
		}
#line 4240 "cfg.tab.c"
    break;

  case 227: /* assign_stm: TCP_CONNECT_TIMEOUT EQUAL error  */
#line 1306 "cfg.y"
                                                  { yyerror("number expected"); }
#line 4246 "cfg.tab.c"
    break;

  case 228: /* assign_stm: TCP_CON_LIFETIME EQUAL NUMBER  */
#line 1307 "cfg.y"
                                                { IFOR();
				tcp_con_lifetime=(yyvsp[0].intval);
		}
#line 4254 "cfg.tab.c"
    break;

  case 229: /* assign_stm: TCP_CON_LIFETIME EQUAL error  */
#line 1310 "cfg.y"
                                               { yyerror("number expected"); }
#line 4260 "cfg.tab.c"
    break;

  case 230: /* assign_stm: TCP_SOCKET_BACKLOG EQUAL NUMBER  */
#line 1311 "cfg.y"
                                                  { IFOR();
				tcp_socket_backlog=(yyvsp[0].intval);
		}
#line 4268 "cfg.tab.c"
    break;

  case 231: /* assign_stm: TCP_SOCKET_BACKLOG EQUAL error  */
#line 1314 "cfg.y"
                                                 { yyerror("number expected"); }
#line 4274 "cfg.tab.c"
    break;

  case 232: /* assign_stm: TCP_MAX_CONNECTIONS EQUAL NUMBER  */
#line 1315 "cfg.y"
                                                   { IFOR();
				tcp_max_connections=(yyvsp[0].intval);
		}
#line 4282 "cfg.tab.c"
    break;

  case 233: /* assign_stm: TCP_MAX_CONNECTIONS EQUAL error  */
#line 1318 "cfg.y"
                                                  { yyerror("number expected"); }
#line 4288 "cfg.tab.c"
    break;

  case 234: /* assign_stm: TCP_NO_NEW_CONN_BFLAG EQUAL ID  */
#line 1319 "cfg.y"
                                                 { IFOR();
				tcp_no_new_conn_bflag =
					get_flag_id_by_name(FLAG_TYPE_BRANCH, (yyvsp[0].strval), 0);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_bflag ) )
					yyerror("invalid TCP no_new_conn Branch Flag");
				flag_idx2mask( &tcp_no_new_conn_bflag );
		}
#line 4300 "cfg.tab.c"
    break;

  case 235: /* assign_stm: TCP_NO_NEW_CONN_BFLAG EQUAL error  */
#line 1326 "cfg.y"
                                                    { yyerror("number value expected"); }
#line 4306 "cfg.tab.c"
    break;

  case 236: /* assign_stm: TCP_NO_NEW_CONN_RPLFLAG EQUAL ID  */
#line 1327 "cfg.y"
                                                   { IFOR();
				tcp_no_new_conn_rplflag =
					get_flag_id_by_name(FLAG_TYPE_MSG, (yyvsp[0].strval), 0);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_rplflag ) )
					yyerror("invalid TCP no_new_conn RePLy Flag");
				flag_idx2mask( &tcp_no_new_conn_rplflag );
		}
#line 4318 "cfg.tab.c"
    break;

  case 237: /* assign_stm: TCP_NO_NEW_CONN_RPLFLAG EQUAL error  */
#line 1334 "cfg.y"
                                                      { yyerror("number value expected"); }
#line 4324 "cfg.tab.c"
    break;

  case 238: /* assign_stm: TCP_KEEPALIVE EQUAL NUMBER  */
#line 1336 "cfg.y"
                                             { IFOR();
				tcp_keepalive=!!(yyvsp[0].intval);
		}
#line 4332 "cfg.tab.c"
    break;

  case 239: /* assign_stm: TCP_KEEPALIVE EQUAL error  */
#line 1339 "cfg.y"
                                            { yyerror("boolean value expected"); }
#line 4338 "cfg.tab.c"
    break;

  case 240: /* assign_stm: TCP_MAX_MSG_TIME EQUAL NUMBER  */
#line 1340 "cfg.y"
                                                { IFOR();
				tcp_max_msg_time=(yyvsp[0].intval);
		}
#line 4346 "cfg.tab.c"
    break;

  case 241: /* assign_stm: TCP_MAX_MSG_TIME EQUAL error  */
#line 1343 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 4352 "cfg.tab.c"
    break;

  case 242: /* assign_stm: TCP_PARALLEL_READ_ON_WORKERS EQUAL NUMBER  */
#line 1344 "cfg.y"
                                                            { IFOR();
				tcp_parallel_read_on_workers=!!(yyvsp[0].intval);
		}
#line 4360 "cfg.tab.c"
    break;

  case 243: /* assign_stm: TCP_PARALLEL_READ_ON_WORKERS EQUAL error  */
#line 1347 "cfg.y"
                                                           {
			yyerror("boolean value expected");
		}
#line 4368 "cfg.tab.c"
    break;

  case 244: /* assign_stm: TCP_KEEPCOUNT EQUAL NUMBER  */
#line 1350 "cfg.y"
                                                        { IFOR();
			#ifndef HAVE_TCP_KEEPCNT
				warn("cannot be enabled TCP_KEEPCOUNT (no OS support)");
			#else
				tcp_keepcount=(yyvsp[0].intval);
			#endif
		}
#line 4380 "cfg.tab.c"
    break;

  case 245: /* assign_stm: TCP_KEEPCOUNT EQUAL error  */
#line 1357 "cfg.y"
                                            { yyerror("int value expected"); }
#line 4386 "cfg.tab.c"
    break;

  case 246: /* assign_stm: TCP_KEEPIDLE EQUAL NUMBER  */
#line 1358 "cfg.y"
                                                        { IFOR();
			#ifndef HAVE_TCP_KEEPIDLE
				warn("cannot be enabled TCP_KEEPIDLE (no OS support)");
			#else
				tcp_keepidle=(yyvsp[0].intval);
			#endif
		}
#line 4398 "cfg.tab.c"
    break;

  case 247: /* assign_stm: TCP_KEEPIDLE EQUAL error  */
#line 1365 "cfg.y"
                                           { yyerror("int value expected"); }
#line 4404 "cfg.tab.c"
    break;

  case 248: /* assign_stm: TCP_KEEPINTERVAL EQUAL NUMBER  */
#line 1366 "cfg.y"
                                                { IFOR();
			#ifndef HAVE_TCP_KEEPINTVL
				warn("cannot be enabled TCP_KEEPINTERVAL (no OS support)");
			#else
				tcp_keepinterval=(yyvsp[0].intval);
			 #endif
		}
#line 4416 "cfg.tab.c"
    break;

  case 249: /* assign_stm: TCP_KEEPINTERVAL EQUAL error  */
#line 1373 "cfg.y"
                                               { yyerror("int value expected"); }
#line 4422 "cfg.tab.c"
    break;

  case 250: /* assign_stm: SERVER_SIGNATURE EQUAL NUMBER  */
#line 1374 "cfg.y"
                                                { IFOR();
							server_signature=(yyvsp[0].intval); }
#line 4429 "cfg.tab.c"
    break;

  case 251: /* assign_stm: SERVER_SIGNATURE EQUAL error  */
#line 1376 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 4435 "cfg.tab.c"
    break;

  case 252: /* assign_stm: SERVER_HEADER EQUAL STRING  */
#line 1377 "cfg.y"
                                             { IFOR();
							server_header->s=(yyvsp[0].strval);
							server_header->len=strlen((yyvsp[0].strval));
							}
#line 4444 "cfg.tab.c"
    break;

  case 253: /* assign_stm: SERVER_HEADER EQUAL error  */
#line 1381 "cfg.y"
                                            { yyerror("string value expected"); }
#line 4450 "cfg.tab.c"
    break;

  case 254: /* assign_stm: USER_AGENT_HEADER EQUAL STRING  */
#line 1382 "cfg.y"
                                                 { user_agent_header->s=(yyvsp[0].strval);
			user_agent_header->len=strlen((yyvsp[0].strval));
									}
#line 4458 "cfg.tab.c"
    break;

  case 255: /* assign_stm: USER_AGENT_HEADER EQUAL error  */
#line 1385 "cfg.y"
                                                { yyerror("string value expected"); }
#line 4464 "cfg.tab.c"
    break;

  case 256: /* assign_stm: PV_PRINT_BUF_SIZE EQUAL NUMBER  */
#line 1386 "cfg.y"
                                                 { IFOR();
							pv_print_buf_size = (yyvsp[0].intval); }
#line 4471 "cfg.tab.c"
    break;

  case 257: /* assign_stm: PV_PRINT_BUF_SIZE EQUAL error  */
#line 1388 "cfg.y"
                                                { yyerror("number expected"); }
#line 4477 "cfg.tab.c"
    break;

  case 258: /* assign_stm: XLOG_BUF_SIZE EQUAL NUMBER  */
#line 1389 "cfg.y"
                                             { IFOR();
							xlog_buf_size = (yyvsp[0].intval); }
#line 4484 "cfg.tab.c"
    break;

  case 259: /* assign_stm: XLOG_FORCE_COLOR EQUAL NUMBER  */
#line 1391 "cfg.y"
                                                { IFOR();
							xlog_force_color = (yyvsp[0].intval); }
#line 4491 "cfg.tab.c"
    break;

  case 260: /* assign_stm: XLOG_PRINT_LEVEL EQUAL NUMBER  */
#line 1393 "cfg.y"
                                                { IFOR();
							xlog_print_level = (yyvsp[0].intval); }
#line 4498 "cfg.tab.c"
    break;

  case 261: /* assign_stm: XLOG_BUF_SIZE EQUAL error  */
#line 1395 "cfg.y"
                                            { yyerror("number expected"); }
#line 4504 "cfg.tab.c"
    break;

  case 262: /* assign_stm: XLOG_FORCE_COLOR EQUAL error  */
#line 1396 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 4510 "cfg.tab.c"
    break;

  case 263: /* assign_stm: XLOG_PRINT_LEVEL EQUAL error  */
#line 1397 "cfg.y"
                                               { yyerror("number expected"); }
#line 4516 "cfg.tab.c"
    break;

  case 264: /* assign_stm: XLOG_LEVEL EQUAL snumber  */
#line 1398 "cfg.y"
                                           { IFOR();
							*xlog_level = (yyvsp[0].intval); }
#line 4523 "cfg.tab.c"
    break;

  case 265: /* assign_stm: XLOG_LEVEL EQUAL error  */
#line 1400 "cfg.y"
                                         { yyerror("number expected"); }
#line 4529 "cfg.tab.c"
    break;

  case 266: /* assign_stm: SOCKET EQUAL socket_def  */
#line 1401 "cfg.y"
                                          { IFOR();
							for (lst_tmp = (yyvsp[0].sockid); lst_tmp; lst_tmp = lst_tmp->next) {
								if (add_listening_socket(lst_tmp)!=0){
									LM_CRIT("cfg. parser: failed"
											" to add listening socket\n");
									break;
								}
							}
						}
#line 4543 "cfg.tab.c"
    break;

  case 267: /* assign_stm: SOCKET EQUAL error  */
#line 1410 "cfg.y"
                                      { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 4551 "cfg.tab.c"
    break;

  case 268: /* assign_stm: LISTEN EQUAL socket_def  */
#line 1413 "cfg.y"
                                          { IFOR();
							warn("'listen' is deprecated, use 'socket' instead");
							for (lst_tmp = (yyvsp[0].sockid); lst_tmp; lst_tmp = lst_tmp->next) {
								if (add_listening_socket(lst_tmp)!=0){
									LM_CRIT("cfg. parser: failed"
											" to add listen address\n");
									break;
								}
							}
						}
#line 4566 "cfg.tab.c"
    break;

  case 269: /* assign_stm: LISTEN EQUAL error  */
#line 1423 "cfg.y"
                                      { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 4574 "cfg.tab.c"
    break;

  case 270: /* assign_stm: MEMGROUP EQUAL STRING COLON multi_string  */
#line 1426 "cfg.y"
                                                           { IFOR();
							/* convert STIRNG ($3) to an ID */
							/* update the memstats type for each module */
							#ifndef SHM_EXTRA_STATS
								LM_CRIT("SHM_EXTRA_STATS not defined");
								YYABORT;
							#else

							#ifdef SHM_SHOW_DEFAULT_GROUP
							if(strcmp((yyvsp[-2].strval), "default") == 0){
								LM_CRIT("default group  name is not allowed");
								YYABORT;
							}
							#endif

							for(tmp_mod = mod_names; tmp_mod; tmp_mod=tmp_mod->next){
								if(strcmp((yyvsp[-2].strval), tmp_mod->s) == 0){
									LM_CRIT("The same mem-group name is used twice: [%s] [%s]\n", (yyvsp[-2].strval), tmp_mod->s);
									YYABORT;
								}
							}

							tmp_mod = pkg_malloc(sizeof(struct multi_str));
							if(!tmp_mod){
								LM_CRIT("out of pkg memory");
								YYABORT;
							}

							tmp_mod->s = (yyvsp[-2].strval);
							tmp_mod->next = mod_names;
							mod_names = tmp_mod;
							for (tmp_mod = (yyvsp[0].multistr); tmp_mod; tmp_mod = tmp_mod->next){
								if(set_mem_idx(tmp_mod->s, mem_free_idx)){
									YYABORT;
								}
							}

							mem_free_idx++;

							if(alloc_group_stat()){
								YYABORT;
							}
							#endif
						}
#line 4623 "cfg.tab.c"
    break;

  case 271: /* assign_stm: MEMGROUP EQUAL STRING COLON error  */
#line 1470 "cfg.y"
                                                    { yyerror("invalid or no module specified"); }
#line 4629 "cfg.tab.c"
    break;

  case 272: /* assign_stm: ALIAS EQUAL id_lst  */
#line 1471 "cfg.y"
                                      { IFOR();
							for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next)
								add_alias(lst_tmp->name, strlen(lst_tmp->name),
											lst_tmp->port, lst_tmp->proto);
							  }
#line 4639 "cfg.tab.c"
    break;

  case 273: /* assign_stm: ALIAS EQUAL error  */
#line 1476 "cfg.y"
                                      { yyerror("hostname expected (use quotes"
							" if the hostname includes config keywords)"); }
#line 4646 "cfg.tab.c"
    break;

  case 274: /* assign_stm: AUTO_ALIASES EQUAL NUMBER  */
#line 1478 "cfg.y"
                                            { IFOR();
								auto_aliases=(yyvsp[0].intval); }
#line 4653 "cfg.tab.c"
    break;

  case 275: /* assign_stm: AUTO_ALIASES EQUAL error  */
#line 1480 "cfg.y"
                                            { yyerror("number  expected"); }
#line 4659 "cfg.tab.c"
    break;

  case 276: /* assign_stm: ADVERTISED_ADDRESS EQUAL listen_id  */
#line 1481 "cfg.y"
                                                     { IFOR();
								if ((yyvsp[0].strval)) {
									default_global_address->s=(yyvsp[0].strval);
									default_global_address->len=strlen((yyvsp[0].strval));
								}
								}
#line 4670 "cfg.tab.c"
    break;

  case 277: /* assign_stm: ADVERTISED_ADDRESS EQUAL error  */
#line 1487 "cfg.y"
                                                 {yyerror("ip address or hostname "
												"expected"); }
#line 4677 "cfg.tab.c"
    break;

  case 278: /* assign_stm: ADVERTISED_PORT EQUAL NUMBER  */
#line 1489 "cfg.y"
                                               { IFOR();
								tmp = int2str((yyvsp[0].intval), &i_tmp);
								if (i_tmp > default_global_port->len)
									default_global_port->s =
									pkg_realloc(default_global_port->s, i_tmp);
								if (!default_global_port->s) {
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								} else {
									default_global_port->len = i_tmp;
									memcpy(default_global_port->s, tmp,
											default_global_port->len);
								}
								}
#line 4696 "cfg.tab.c"
    break;

  case 279: /* assign_stm: ADVERTISED_PORT EQUAL error  */
#line 1503 "cfg.y"
                                             {yyerror("ip address or hostname "
												"expected"); }
#line 4703 "cfg.tab.c"
    break;

  case 280: /* assign_stm: DISABLE_CORE EQUAL NUMBER  */
#line 1505 "cfg.y"
                                            { IFOR();
										disable_core_dump=(yyvsp[0].intval);
									}
#line 4711 "cfg.tab.c"
    break;

  case 281: /* assign_stm: DISABLE_CORE EQUAL error  */
#line 1508 "cfg.y"
                                           { yyerror("boolean value expected"); }
#line 4717 "cfg.tab.c"
    break;

  case 282: /* assign_stm: OPEN_FD_LIMIT EQUAL NUMBER  */
#line 1509 "cfg.y"
                                             { IFOR();
										open_files_limit=(yyvsp[0].intval);
									}
#line 4725 "cfg.tab.c"
    break;

  case 283: /* assign_stm: OPEN_FD_LIMIT EQUAL error  */
#line 1512 "cfg.y"
                                            { yyerror("number expected"); }
#line 4731 "cfg.tab.c"
    break;

  case 284: /* assign_stm: MCAST_LOOPBACK EQUAL NUMBER  */
#line 1513 "cfg.y"
                                              { IFOR();
								#ifdef USE_MCAST
										mcast_loopback=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4743 "cfg.tab.c"
    break;

  case 285: /* assign_stm: MCAST_LOOPBACK EQUAL error  */
#line 1520 "cfg.y"
                                             { yyerror("boolean value expected"); }
#line 4749 "cfg.tab.c"
    break;

  case 286: /* assign_stm: MCAST_TTL EQUAL NUMBER  */
#line 1521 "cfg.y"
                                         { IFOR();
								#ifdef USE_MCAST
										mcast_ttl=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4761 "cfg.tab.c"
    break;

  case 287: /* assign_stm: MCAST_TTL EQUAL error  */
#line 1528 "cfg.y"
                                        { yyerror("number expected as tos"); }
#line 4767 "cfg.tab.c"
    break;

  case 288: /* assign_stm: TOS EQUAL NUMBER  */
#line 1529 "cfg.y"
                                   { IFOR(); tos = (yyvsp[0].intval);
							if (tos<=0)
								yyerror("invalid tos value");
		 }
#line 4776 "cfg.tab.c"
    break;

  case 289: /* assign_stm: TOS EQUAL ID  */
#line 1533 "cfg.y"
                               { IFOR();
							if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
								tos=IPTOS_LOWDELAY;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
								tos=IPTOS_THROUGHPUT;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
								tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
								tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
								tos=IPTOS_LOWCOST;
#endif
							} else {
								yyerror("invalid tos value - allowed: "
									"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
									"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
									",IPTOS_LOWCOST"
#endif
#if defined(IPTOS_MINCOST)
									",IPTOS_MINCOST"
#endif
									"\n");
							}
		 }
#line 4809 "cfg.tab.c"
    break;

  case 290: /* assign_stm: TOS EQUAL error  */
#line 1561 "cfg.y"
                                  { yyerror("number expected"); }
#line 4815 "cfg.tab.c"
    break;

  case 291: /* assign_stm: MPATH EQUAL STRING  */
#line 1562 "cfg.y"
                                     {IFOR();
				add_mpath((yyvsp[0].strval)); }
#line 4822 "cfg.tab.c"
    break;

  case 292: /* assign_stm: MPATH EQUAL error  */
#line 1564 "cfg.y"
                                     { yyerror("string value expected"); }
#line 4828 "cfg.tab.c"
    break;

  case 293: /* assign_stm: DISABLE_DNS_FAILOVER EQUAL NUMBER  */
#line 1565 "cfg.y"
                                                    { IFOR();
										disable_dns_failover=(yyvsp[0].intval);
									}
#line 4836 "cfg.tab.c"
    break;

  case 294: /* assign_stm: DISABLE_DNS_FAILOVER error  */
#line 1568 "cfg.y"
                                             { yyerror("boolean value expected"); }
#line 4842 "cfg.tab.c"
    break;

  case 295: /* assign_stm: DISABLE_DNS_BLACKLIST EQUAL NUMBER  */
#line 1569 "cfg.y"
                                                     { IFOR();
										disable_dns_blacklist=(yyvsp[0].intval);
									}
#line 4850 "cfg.tab.c"
    break;

  case 296: /* assign_stm: DISABLE_DNS_BLACKLIST error  */
#line 1572 "cfg.y"
                                              { yyerror("boolean value expected"); }
#line 4856 "cfg.tab.c"
    break;

  case 297: /* assign_stm: DST_BLACKLIST EQUAL ID SLASH blst_flags blst_def  */
#line 1573 "cfg.y"
                                                                   { IFOR();
				s_tmp.s = (yyvsp[-3].strval);
				s_tmp.len = strlen((yyvsp[-3].strval));
				if (create_bl_head(_str("script"), (yyvsp[-1].intval),
				    bl_head, bl_tail, &s_tmp)==0) {
					yyerror("failed to create blacklist\n");
					YYABORT;
				}
				bl_head = bl_tail = NULL;
				}
#line 4871 "cfg.tab.c"
    break;

  case 298: /* assign_stm: DST_BLACKLIST EQUAL ID blst_def  */
#line 1583 "cfg.y"
                                                  { IFOR();
				s_tmp.s = (yyvsp[-1].strval);
				s_tmp.len = strlen((yyvsp[-1].strval));
				if (create_bl_head(_str("script"), BL_READONLY_LIST,
				    bl_head, bl_tail, &s_tmp)==0) {
					yyerror("failed to create blacklist\n");
					YYABORT;
				}
				bl_head = bl_tail = NULL;
				}
#line 4886 "cfg.tab.c"
    break;

  case 299: /* assign_stm: DISABLE_STATELESS_FWD EQUAL NUMBER  */
#line 1593 "cfg.y"
                                                     { IFOR();
				sl_fwd_disabled=(yyvsp[0].intval); }
#line 4893 "cfg.tab.c"
    break;

  case 300: /* assign_stm: DB_VERSION_TABLE EQUAL STRING  */
#line 1595 "cfg.y"
                                                { IFOR();
				db_version_table=(yyvsp[0].strval); }
#line 4900 "cfg.tab.c"
    break;

  case 301: /* assign_stm: DB_VERSION_TABLE EQUAL error  */
#line 1597 "cfg.y"
                                               { yyerror("string value expected"); }
#line 4906 "cfg.tab.c"
    break;

  case 302: /* assign_stm: DB_DEFAULT_URL EQUAL STRING  */
#line 1598 "cfg.y"
                                              { IFOR();
				db_default_url=(yyvsp[0].strval); }
#line 4913 "cfg.tab.c"
    break;

  case 303: /* assign_stm: DB_DEFAULT_URL EQUAL error  */
#line 1600 "cfg.y"
                                             { yyerror("string value expected"); }
#line 4919 "cfg.tab.c"
    break;

  case 304: /* assign_stm: DB_MAX_ASYNC_CONNECTIONS EQUAL NUMBER  */
#line 1601 "cfg.y"
                                                        { IFOR();
				db_max_async_connections=(yyvsp[0].intval); }
#line 4926 "cfg.tab.c"
    break;

  case 305: /* assign_stm: DB_MAX_ASYNC_CONNECTIONS EQUAL error  */
#line 1603 "cfg.y"
                                                       {
				yyerror("integer value expected");
				}
#line 4934 "cfg.tab.c"
    break;

  case 306: /* assign_stm: DISABLE_503_TRANSLATION EQUAL NUMBER  */
#line 1606 "cfg.y"
                                                       { IFOR();
				disable_503_translation=(yyvsp[0].intval); }
#line 4941 "cfg.tab.c"
    break;

  case 307: /* assign_stm: DISABLE_503_TRANSLATION EQUAL error  */
#line 1608 "cfg.y"
                                                      {
				yyerror("integer value expected");
				}
#line 4949 "cfg.tab.c"
    break;

  case 308: /* assign_stm: AUTO_SCALING_PROFILE EQUAL auto_scale_profile_def  */
#line 1611 "cfg.y"
                                                                    {}
#line 4955 "cfg.tab.c"
    break;

  case 309: /* assign_stm: AUTO_SCALING_PROFILE EQUAL error  */
#line 1612 "cfg.y"
                                                   {
				yyerror("bad auto-scaling profile definition");
				}
#line 4963 "cfg.tab.c"
    break;

  case 310: /* assign_stm: AUTO_SCALING_CYCLE EQUAL NUMBER  */
#line 1615 "cfg.y"
                                                  { IFOR();
				auto_scaling_cycle=(yyvsp[0].intval); }
#line 4970 "cfg.tab.c"
    break;

  case 311: /* assign_stm: AUTO_SCALING_CYCLE EQUAL error  */
#line 1617 "cfg.y"
                                                 {
				yyerror("integer value expected");
				}
#line 4978 "cfg.tab.c"
    break;

  case 312: /* assign_stm: error EQUAL  */
#line 1620 "cfg.y"
                              { yyerror("unknown config variable"); }
#line 4984 "cfg.tab.c"
    break;

  case 313: /* module_stm: LOADMODULE STRING  */
#line 1623 "cfg.y"
                                        { IFOR();
			if (load_module((yyvsp[0].strval)) < 0)
				yyerrorf("failed to load module %s\n", (yyvsp[0].strval));
		}
#line 4993 "cfg.tab.c"
    break;

  case 314: /* module_stm: LOADMODULE error  */
#line 1627 "cfg.y"
                                        { yyerror("string expected");  }
#line 4999 "cfg.tab.c"
    break;

  case 315: /* module_stm: MODPARAM LPAREN STRING COMMA STRING COMMA STRING RPAREN  */
#line 1628 "cfg.y"
                                                                          { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), STR_PARAM, (yyvsp[-1].strval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 5010 "cfg.tab.c"
    break;

  case 316: /* module_stm: MODPARAM LPAREN STRING COMMA STRING COMMA folded_string RPAREN  */
#line 1634 "cfg.y"
                                                                                 { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), STR_PARAM, (yyvsp[-1].strval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 5021 "cfg.tab.c"
    break;

  case 317: /* module_stm: MODPARAM LPAREN STRING COMMA STRING COMMA snumber RPAREN  */
#line 1640 "cfg.y"
                                                                           { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), INT_PARAM, (void*)(yyvsp[-1].intval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 5032 "cfg.tab.c"
    break;

  case 318: /* module_stm: MODPARAM error  */
#line 1646 "cfg.y"
                                 { yyerror("Invalid arguments"); }
#line 5038 "cfg.tab.c"
    break;

  case 319: /* ip: ipv4  */
#line 1650 "cfg.y"
                       { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 5044 "cfg.tab.c"
    break;

  case 320: /* ip: ipv6  */
#line 1651 "cfg.y"
                       { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 5050 "cfg.tab.c"
    break;

  case 321: /* ipv4: IPV4ADDR  */
#line 1654 "cfg.y"
                 {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv4 address");
						}
					}
				}
#line 5069 "cfg.tab.c"
    break;

  case 322: /* ipv6addr: IPV6ADDR  */
#line 1670 "cfg.y"
                         {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET6;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv6 address");
						}
					}
				}
#line 5088 "cfg.tab.c"
    break;

  case 323: /* ipv6: ipv6addr  */
#line 1686 "cfg.y"
                 { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 5094 "cfg.tab.c"
    break;

  case 324: /* ipv6: LBRACK ipv6addr RBRACK  */
#line 1687 "cfg.y"
                                 {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 5100 "cfg.tab.c"
    break;

  case 325: /* ipnet: IPNET  */
#line 1690 "cfg.y"
                {
				if (parse_ipnet((yyvsp[0].strval), strlen((yyvsp[0].strval)), &net_tmp) < 0)
					yyerror("unable to parse ip and/or netmask\n");

				(yyval.ipnet) = net_tmp;
			}
#line 5111 "cfg.tab.c"
    break;

  case 326: /* ipnet: ip  */
#line 1696 "cfg.y"
                        {
				(yyval.ipnet)=mk_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8);
				pkg_free((yyvsp[0].ipaddr));
			}
#line 5120 "cfg.tab.c"
    break;

  case 327: /* folded_string: STRING STRING  */
#line 1706 "cfg.y"
                              {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					yyerror("cfg. parser: out of memory");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 5135 "cfg.tab.c"
    break;

  case 328: /* folded_string: folded_string STRING  */
#line 1716 "cfg.y"
                                       {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					LM_CRIT("ERROR: cfg. parser: out of memory.\n");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 5150 "cfg.tab.c"
    break;

  case 329: /* route_name: ID  */
#line 1727 "cfg.y"
                {
				(yyval.strval) = (yyvsp[0].strval);
				}
#line 5158 "cfg.tab.c"
    break;

  case 330: /* route_name: NUMBER  */
#line 1730 "cfg.y"
                         {
				tmp=int2str((yyvsp[0].intval), &i_tmp);
				if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
					yyerror("cfg. parser: out of memory.\n");
					YYABORT;
				}
				memcpy( (yyval.strval), tmp, i_tmp);
				(yyval.strval)[i_tmp] = 0;
				}
#line 5172 "cfg.tab.c"
    break;

  case 331: /* route_name: STRING  */
#line 1739 "cfg.y"
                        {
				(yyval.strval) = (yyvsp[0].strval);
		}
#line 5180 "cfg.tab.c"
    break;

  case 332: /* route_name_var: route_name  */
#line 1744 "cfg.y"
                           {
				/* check to see if there are any "$" in the string name */
				tmp = strchr((yyvsp[0].strval), '$');
				if (!tmp) {
					/* route name is a cosntant string - search for the route */
					rn_tmp.data = 0;
					rn_tmp.iname = get_script_route_idx((yyvsp[0].strval), sroutes->request,
							RT_NO, 0);
					if (rn_tmp.iname==-1)
						yyerror("too many script routes");
					(yyval.intval) = NUMBER_ST;
				} else {
					tstr.s = (yyvsp[0].strval);
					tstr.len = strlen(tstr.s);
					if (pv_parse_format(&tstr, &elem) < 0) {
						yyerror("cannot parse format");
						YYABORT;
					}
					/* the route name is a format, so we can't evaluate it now */
					rn_tmp.ename = elem;
					(yyval.intval) = SCRIPTVAR_ELEM_ST;
				}
			}
#line 5208 "cfg.tab.c"
    break;

  case 333: /* route_name_var: script_var  */
#line 1767 "cfg.y"
                             {
				rn_tmp.sname = (yyvsp[0].specval);
				(yyval.intval) = SCRIPTVAR_ST;
		}
#line 5217 "cfg.tab.c"
    break;

  case 334: /* route_stm: ROUTE LBRACE actions RBRACE  */
#line 1772 "cfg.y"
                                        {
						if (sroutes->request[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"request routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
					}
#line 5230 "cfg.tab.c"
    break;

  case 335: /* route_stm: ROUTE LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1780 "cfg.y"
                                                                       {
						if ( strtol((yyvsp[-4].strval),&tmp,10)==0 && *tmp==0) {
							/* route[0] detected */
							if (sroutes->request[DEFAULT_RT].a!=0) {
								yyerror("overwriting(2) default "
									"request routing table");
								YYABORT;
							}
							push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
						} else {
							i_tmp = get_script_route_idx( (yyvsp[-4].strval),
								sroutes->request, RT_NO,1);
							if (i_tmp==-1) YYABORT;
							push((yyvsp[-1].action), &sroutes->request[i_tmp].a);
						}
					}
#line 5251 "cfg.tab.c"
    break;

  case 336: /* route_stm: ROUTE error  */
#line 1796 "cfg.y"
                              { yyerror("invalid  route  statement"); }
#line 5257 "cfg.tab.c"
    break;

  case 337: /* failure_route_stm: ROUTE_FAILURE LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1799 "cfg.y"
                                                                                {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->failure,
							FAILURE_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->failure[i_tmp].a);
					}
#line 5268 "cfg.tab.c"
    break;

  case 338: /* failure_route_stm: ROUTE_FAILURE error  */
#line 1805 "cfg.y"
                                      { yyerror("invalid failure_route statement"); }
#line 5274 "cfg.tab.c"
    break;

  case 339: /* onreply_route_stm: ROUTE_ONREPLY LBRACE actions RBRACE  */
#line 1808 "cfg.y"
                                                       {
						if (sroutes->onreply[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"onreply routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->onreply[DEFAULT_RT].a);
					}
#line 5287 "cfg.tab.c"
    break;

  case 340: /* onreply_route_stm: ROUTE_ONREPLY LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1816 "cfg.y"
                                                                               {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->onreply,
							ONREPLY_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->onreply[i_tmp].a);
					}
#line 5298 "cfg.tab.c"
    break;

  case 341: /* onreply_route_stm: ROUTE_ONREPLY error  */
#line 1822 "cfg.y"
                                      { yyerror("invalid onreply_route statement"); }
#line 5304 "cfg.tab.c"
    break;

  case 342: /* branch_route_stm: ROUTE_BRANCH LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1825 "cfg.y"
                                                                              {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->branch,
							BRANCH_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->branch[i_tmp].a);
					}
#line 5315 "cfg.tab.c"
    break;

  case 343: /* branch_route_stm: ROUTE_BRANCH error  */
#line 1831 "cfg.y"
                                     { yyerror("invalid branch_route statement"); }
#line 5321 "cfg.tab.c"
    break;

  case 344: /* error_route_stm: ROUTE_ERROR LBRACE actions RBRACE  */
#line 1834 "cfg.y"
                                                    {
						if (sroutes->error.a!=0) {
							yyerror("overwriting default "
								"error routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->error.a);
					}
#line 5334 "cfg.tab.c"
    break;

  case 345: /* error_route_stm: ROUTE_ERROR error  */
#line 1842 "cfg.y"
                                    { yyerror("invalid error_route statement"); }
#line 5340 "cfg.tab.c"
    break;

  case 346: /* local_route_stm: ROUTE_LOCAL LBRACE actions RBRACE  */
#line 1845 "cfg.y"
                                                    {
						if (sroutes->local.a!=0) {
							yyerror("re-definition of local "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->local.a);
					}
#line 5353 "cfg.tab.c"
    break;

  case 347: /* local_route_stm: ROUTE_LOCAL error  */
#line 1853 "cfg.y"
                                    { yyerror("invalid local_route statement"); }
#line 5359 "cfg.tab.c"
    break;

  case 348: /* startup_route_stm: ROUTE_STARTUP LBRACE actions RBRACE  */
#line 1856 "cfg.y"
                                                        {
						if (sroutes->startup.a!=0) {
							yyerror("re-definition of startup "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->startup.a);
					}
#line 5372 "cfg.tab.c"
    break;

  case 349: /* startup_route_stm: ROUTE_STARTUP error  */
#line 1864 "cfg.y"
                                      { yyerror("invalid startup_route statement"); }
#line 5378 "cfg.tab.c"
    break;

  case 350: /* timer_route_stm: ROUTE_TIMER LBRACK route_name COMMA NUMBER RBRACK LBRACE actions RBRACE  */
#line 1867 "cfg.y"
                                                                                          {
						i_tmp = 0;
						while(i_tmp<TIMER_RT_NO && sroutes->timer[i_tmp].a!=0){
							i_tmp++;
						}
						if(i_tmp == TIMER_RT_NO) {
							yyerror("Too many timer routes defined\n");
							YYABORT;
						}
						sroutes->timer[i_tmp].name = (yyvsp[-6].strval);
						sroutes->timer[i_tmp].interval = (yyvsp[-4].intval);
						push((yyvsp[-1].action), &sroutes->timer[i_tmp].a);
					}
#line 5396 "cfg.tab.c"
    break;

  case 351: /* timer_route_stm: ROUTE_TIMER error  */
#line 1880 "cfg.y"
                                    { yyerror("invalid timer_route statement"); }
#line 5402 "cfg.tab.c"
    break;

  case 352: /* event_route_stm: ROUTE_EVENT LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1883 "cfg.y"
                                                                            {
						i_tmp = get_script_route_idx((yyvsp[-4].strval), sroutes->event,
								EVENT_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->event[i_tmp].a);
					}
#line 5413 "cfg.tab.c"
    break;

  case 353: /* event_route_stm: ROUTE_EVENT error  */
#line 1889 "cfg.y"
                                    { yyerror("invalid event_route statement"); }
#line 5419 "cfg.tab.c"
    break;

  case 354: /* exp: exp AND exp  */
#line 1894 "cfg.y"
                        { (yyval.expr)=mk_exp(AND_OP, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 5425 "cfg.tab.c"
    break;

  case 355: /* exp: exp OR exp  */
#line 1895 "cfg.y"
                                { (yyval.expr)=mk_exp(OR_OP, (yyvsp[-2].expr), (yyvsp[0].expr));  }
#line 5431 "cfg.tab.c"
    break;

  case 356: /* exp: NOT exp  */
#line 1896 "cfg.y"
                                        { (yyval.expr)=mk_exp(NOT_OP, (yyvsp[0].expr), 0);  }
#line 5437 "cfg.tab.c"
    break;

  case 357: /* exp: LPAREN exp RPAREN  */
#line 1897 "cfg.y"
                                { (yyval.expr)=mk_exp(EVAL_OP, (yyvsp[-1].expr), 0); }
#line 5443 "cfg.tab.c"
    break;

  case 358: /* exp: LBRACK assignexp RBRACK  */
#line 1898 "cfg.y"
                                  { (yyval.expr)=(yyvsp[-1].expr); }
#line 5449 "cfg.tab.c"
    break;

  case 359: /* exp: exp_elem  */
#line 1899 "cfg.y"
                                        { (yyval.expr)=(yyvsp[0].expr); }
#line 5455 "cfg.tab.c"
    break;

  case 360: /* equalop: EQUAL_T  */
#line 1902 "cfg.y"
                          {(yyval.intval)=EQUAL_OP; }
#line 5461 "cfg.tab.c"
    break;

  case 361: /* equalop: DIFF  */
#line 1903 "cfg.y"
                                {(yyval.intval)=DIFF_OP; }
#line 5467 "cfg.tab.c"
    break;

  case 362: /* compop: GT  */
#line 1906 "cfg.y"
                {(yyval.intval)=GT_OP; }
#line 5473 "cfg.tab.c"
    break;

  case 363: /* compop: LT  */
#line 1907 "cfg.y"
                        {(yyval.intval)=LT_OP; }
#line 5479 "cfg.tab.c"
    break;

  case 364: /* compop: GTE  */
#line 1908 "cfg.y"
                        {(yyval.intval)=GTE_OP; }
#line 5485 "cfg.tab.c"
    break;

  case 365: /* compop: LTE  */
#line 1909 "cfg.y"
                        {(yyval.intval)=LTE_OP; }
#line 5491 "cfg.tab.c"
    break;

  case 366: /* matchop: MATCH  */
#line 1911 "cfg.y"
                {(yyval.intval)=MATCH_OP; }
#line 5497 "cfg.tab.c"
    break;

  case 367: /* matchop: NOTMATCH  */
#line 1912 "cfg.y"
                                {(yyval.intval)=NOTMATCH_OP; }
#line 5503 "cfg.tab.c"
    break;

  case 368: /* intop: equalop  */
#line 1915 "cfg.y"
                {(yyval.intval)=(yyvsp[0].intval); }
#line 5509 "cfg.tab.c"
    break;

  case 369: /* intop: compop  */
#line 1916 "cfg.y"
                        {(yyval.intval)=(yyvsp[0].intval); }
#line 5515 "cfg.tab.c"
    break;

  case 370: /* strop: equalop  */
#line 1919 "cfg.y"
                {(yyval.intval)=(yyvsp[0].intval); }
#line 5521 "cfg.tab.c"
    break;

  case 371: /* strop: compop  */
#line 1920 "cfg.y"
                     {(yyval.intval)=(yyvsp[0].intval); }
#line 5527 "cfg.tab.c"
    break;

  case 372: /* strop: matchop  */
#line 1921 "cfg.y"
                                {(yyval.intval)=(yyvsp[0].intval); }
#line 5533 "cfg.tab.c"
    break;

  case 373: /* script_var: SCRIPTVAR  */
#line 1924 "cfg.y"
                                {
				spec = (pv_spec_t*)pkg_malloc(sizeof(pv_spec_t));
				if (spec==NULL){
					yyerror("no more pkg memory\n");
					YYABORT;
				}
				memset(spec, 0, sizeof(pv_spec_t));
				tstr.s = (yyvsp[0].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_spec(&tstr, spec)==NULL)
				{
					yyerror("unknown script variable");
				}

				(yyval.specval) = spec;
			}
#line 5554 "cfg.tab.c"
    break;

  case 374: /* script_var: SCRIPTVARERR  */
#line 1940 "cfg.y"
                               {
			(yyval.specval)=0; yyerror("invalid script variable name");
		}
#line 5562 "cfg.tab.c"
    break;

  case 375: /* exp_elem: exp_cond  */
#line 1945 "cfg.y"
                                {(yyval.expr)=(yyvsp[0].expr); }
#line 5568 "cfg.tab.c"
    break;

  case 376: /* exp_elem: exp_stm  */
#line 1946 "cfg.y"
                                        {(yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5574 "cfg.tab.c"
    break;

  case 377: /* exp_elem: snumber  */
#line 1947 "cfg.y"
                                        {(yyval.expr)=mk_elem( NO_OP, NUMBER_O, 0, NUMBER_ST,
											(void*)(yyvsp[0].intval) ); }
#line 5581 "cfg.tab.c"
    break;

  case 378: /* exp_elem: script_var  */
#line 1949 "cfg.y"
                                {
				(yyval.expr)=mk_elem(NO_OP, SCRIPTVAR_O,0,SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 5589 "cfg.tab.c"
    break;

  case 379: /* exp_cond: script_var strop script_var  */
#line 1954 "cfg.y"
                                      {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 5597 "cfg.tab.c"
    break;

  case 380: /* exp_cond: script_var strop STRING  */
#line 1957 "cfg.y"
                                          {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),STR_ST,(yyvsp[0].strval));
			}
#line 5605 "cfg.tab.c"
    break;

  case 381: /* exp_cond: script_var intop snumber  */
#line 1960 "cfg.y"
                                           {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),NUMBER_ST,(void *)(yyvsp[0].intval));
			}
#line 5613 "cfg.tab.c"
    break;

  case 382: /* exp_cond: script_var equalop NULLV  */
#line 1963 "cfg.y"
                                                {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval), NULLV_ST, 0);
			}
#line 5621 "cfg.tab.c"
    break;

  case 383: /* exp_cond: script_var equalop ipnet  */
#line 1966 "cfg.y"
                                           {
				(yyval.expr)=mk_elem((yyvsp[-1].intval), SCRIPTVAR_O, (void*)(yyvsp[-2].specval), NET_ST, (yyvsp[0].ipnet));
			}
#line 5629 "cfg.tab.c"
    break;

  case 384: /* assignop: EQUAL  */
#line 1972 "cfg.y"
              { (yyval.intval) = EQ_T; }
#line 5635 "cfg.tab.c"
    break;

  case 385: /* assignop: COLONEQ  */
#line 1973 "cfg.y"
                  { (yyval.intval) = COLONEQ_T; }
#line 5641 "cfg.tab.c"
    break;

  case 386: /* assignop: PLUSEQ  */
#line 1974 "cfg.y"
                 { (yyval.intval) = PLUSEQ_T; }
#line 5647 "cfg.tab.c"
    break;

  case 387: /* assignop: MINUSEQ  */
#line 1975 "cfg.y"
                  { (yyval.intval) = MINUSEQ_T;}
#line 5653 "cfg.tab.c"
    break;

  case 388: /* assignop: SLASHEQ  */
#line 1976 "cfg.y"
                  { (yyval.intval) = DIVEQ_T; }
#line 5659 "cfg.tab.c"
    break;

  case 389: /* assignop: MULTEQ  */
#line 1977 "cfg.y"
                 { (yyval.intval) = MULTEQ_T; }
#line 5665 "cfg.tab.c"
    break;

  case 390: /* assignop: MODULOEQ  */
#line 1978 "cfg.y"
                   { (yyval.intval) = MODULOEQ_T; }
#line 5671 "cfg.tab.c"
    break;

  case 391: /* assignop: BANDEQ  */
#line 1979 "cfg.y"
                 { (yyval.intval) = BANDEQ_T; }
#line 5677 "cfg.tab.c"
    break;

  case 392: /* assignop: BOREQ  */
#line 1980 "cfg.y"
                { (yyval.intval) = BOREQ_T; }
#line 5683 "cfg.tab.c"
    break;

  case 393: /* assignop: BXOREQ  */
#line 1981 "cfg.y"
                 { (yyval.intval) = BXOREQ_T; }
#line 5689 "cfg.tab.c"
    break;

  case 394: /* assignexp: snumber  */
#line 1985 "cfg.y"
                { (yyval.expr) = mk_elem(VALUE_OP, NUMBERV_O, (void*)(yyvsp[0].intval), 0, 0); }
#line 5695 "cfg.tab.c"
    break;

  case 395: /* assignexp: STRING  */
#line 1986 "cfg.y"
                 { (yyval.expr) = mk_elem(VALUE_OP, STRINGV_O, (yyvsp[0].strval), 0, 0); }
#line 5701 "cfg.tab.c"
    break;

  case 396: /* assignexp: script_var  */
#line 1987 "cfg.y"
                     { (yyval.expr) = mk_elem(VALUE_OP, SCRIPTVAR_O, (yyvsp[0].specval), 0, 0); }
#line 5707 "cfg.tab.c"
    break;

  case 397: /* assignexp: exp_cond  */
#line 1988 "cfg.y"
                   { (yyval.expr)= (yyvsp[0].expr); }
#line 5713 "cfg.tab.c"
    break;

  case 398: /* assignexp: cmd  */
#line 1989 "cfg.y"
              { (yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5719 "cfg.tab.c"
    break;

  case 399: /* assignexp: assignexp PLUS assignexp  */
#line 1990 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(PLUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5727 "cfg.tab.c"
    break;

  case 400: /* assignexp: assignexp MINUS assignexp  */
#line 1993 "cfg.y"
                                    {
				(yyval.expr) = mk_elem(MINUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5735 "cfg.tab.c"
    break;

  case 401: /* assignexp: assignexp MULT assignexp  */
#line 1996 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(MULT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5743 "cfg.tab.c"
    break;

  case 402: /* assignexp: assignexp SLASH assignexp  */
#line 1999 "cfg.y"
                                    {
				(yyval.expr) = mk_elem(DIV_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5751 "cfg.tab.c"
    break;

  case 403: /* assignexp: assignexp MODULO assignexp  */
#line 2002 "cfg.y"
                                     {
				(yyval.expr) = mk_elem(MODULO_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5759 "cfg.tab.c"
    break;

  case 404: /* assignexp: assignexp BAND assignexp  */
#line 2005 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(BAND_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5767 "cfg.tab.c"
    break;

  case 405: /* assignexp: assignexp BOR assignexp  */
#line 2008 "cfg.y"
                                  {
				(yyval.expr) = mk_elem(BOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5775 "cfg.tab.c"
    break;

  case 406: /* assignexp: assignexp BXOR assignexp  */
#line 2011 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(BXOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5783 "cfg.tab.c"
    break;

  case 407: /* assignexp: assignexp BLSHIFT assignexp  */
#line 2014 "cfg.y"
                                      {
				(yyval.expr) = mk_elem(BLSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5791 "cfg.tab.c"
    break;

  case 408: /* assignexp: assignexp BRSHIFT assignexp  */
#line 2017 "cfg.y"
                                      {
				(yyval.expr) = mk_elem(BRSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5799 "cfg.tab.c"
    break;

  case 409: /* assignexp: BNOT assignexp  */
#line 2020 "cfg.y"
                         {
				(yyval.expr) = mk_elem(BNOT_OP, EXPR_O, (yyvsp[0].expr), 0, 0);
			}
#line 5807 "cfg.tab.c"
    break;

  case 410: /* assignexp: LPAREN assignexp RPAREN  */
#line 2023 "cfg.y"
                                  { (yyval.expr) = (yyvsp[-1].expr); }
#line 5813 "cfg.tab.c"
    break;

  case 411: /* assign_cmd: script_var assignop assignexp  */
#line 2026 "cfg.y"
                                          {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), (yyvsp[-1].intval),
					SCRIPTVAR_ST,
					EXPR_ST,
					(yyvsp[-2].specval),
					(yyvsp[0].expr));
		}
#line 5831 "cfg.tab.c"
    break;

  case 412: /* assign_cmd: script_var EQUAL NULLV  */
#line 2039 "cfg.y"
                                  {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), EQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5849 "cfg.tab.c"
    break;

  case 413: /* assign_cmd: script_var COLONEQ NULLV  */
#line 2052 "cfg.y"
                                    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), COLONEQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5867 "cfg.tab.c"
    break;

  case 414: /* exp_stm: cmd  */
#line 2067 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5873 "cfg.tab.c"
    break;

  case 415: /* exp_stm: if_cmd  */
#line 2068 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5879 "cfg.tab.c"
    break;

  case 416: /* exp_stm: assign_cmd  */
#line 2069 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5885 "cfg.tab.c"
    break;

  case 417: /* exp_stm: LBRACE actions RBRACE  */
#line 2070 "cfg.y"
                                                { (yyval.action)=(yyvsp[-1].action); }
#line 5891 "cfg.tab.c"
    break;

  case 418: /* exp_stm: LBRACE RBRACE  */
#line 2071 "cfg.y"
                                                        { (yyval.action)=0; }
#line 5897 "cfg.tab.c"
    break;

  case 419: /* brk_stm: brk_action  */
#line 2074 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5903 "cfg.tab.c"
    break;

  case 420: /* brk_stm: LBRACE brk_actions RBRACE  */
#line 2075 "cfg.y"
                                                        { (yyval.action)=(yyvsp[-1].action); }
#line 5909 "cfg.tab.c"
    break;

  case 421: /* brk_stm: LBRACE RBRACE  */
#line 2076 "cfg.y"
                                                        { (yyval.action)=0; }
#line 5915 "cfg.tab.c"
    break;

  case 422: /* stm: action  */
#line 2079 "cfg.y"
                                                        { (yyval.action)=(yyvsp[0].action); }
#line 5921 "cfg.tab.c"
    break;

  case 423: /* stm: LBRACE actions RBRACE  */
#line 2080 "cfg.y"
                                                { (yyval.action)=(yyvsp[-1].action); }
#line 5927 "cfg.tab.c"
    break;

  case 424: /* stm: LBRACE RBRACE  */
#line 2081 "cfg.y"
                                                        { (yyval.action)=0; }
#line 5933 "cfg.tab.c"
    break;

  case 425: /* actions: actions action  */
#line 2084 "cfg.y"
                                {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5939 "cfg.tab.c"
    break;

  case 426: /* actions: action  */
#line 2085 "cfg.y"
                                                {(yyval.action)=(yyvsp[0].action);}
#line 5945 "cfg.tab.c"
    break;

  case 427: /* actions: actions error  */
#line 2086 "cfg.y"
                                { (yyval.action)=0; yyerror("bad command!)"); }
#line 5951 "cfg.tab.c"
    break;

  case 428: /* brk_actions: brk_actions brk_action  */
#line 2090 "cfg.y"
                                        {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5957 "cfg.tab.c"
    break;

  case 429: /* brk_actions: brk_action  */
#line 2091 "cfg.y"
                                                {(yyval.action)=(yyvsp[0].action);}
#line 5963 "cfg.tab.c"
    break;

  case 430: /* brk_actions: brk_actions error  */
#line 2092 "cfg.y"
                                    { (yyval.action)=0; yyerror("bad command!)"); }
#line 5969 "cfg.tab.c"
    break;

  case 431: /* action: cmd SEMICOLON  */
#line 2095 "cfg.y"
                              {(yyval.action)=(yyvsp[-1].action);}
#line 5975 "cfg.tab.c"
    break;

  case 432: /* action: if_cmd  */
#line 2096 "cfg.y"
                         {(yyval.action)=(yyvsp[0].action);}
#line 5981 "cfg.tab.c"
    break;

  case 433: /* action: while_cmd  */
#line 2097 "cfg.y"
                            {(yyval.action)=(yyvsp[0].action);}
#line 5987 "cfg.tab.c"
    break;

  case 434: /* action: foreach_cmd  */
#line 2098 "cfg.y"
                              {(yyval.action)=(yyvsp[0].action);}
#line 5993 "cfg.tab.c"
    break;

  case 435: /* action: switch_cmd  */
#line 2099 "cfg.y"
                             {(yyval.action)=(yyvsp[0].action);}
#line 5999 "cfg.tab.c"
    break;

  case 436: /* action: assign_cmd SEMICOLON  */
#line 2100 "cfg.y"
                                       {(yyval.action)=(yyvsp[-1].action);}
#line 6005 "cfg.tab.c"
    break;

  case 437: /* action: SEMICOLON  */
#line 2101 "cfg.y"
                                              {(yyval.action)=0;}
#line 6011 "cfg.tab.c"
    break;

  case 438: /* action: cmd error  */
#line 2102 "cfg.y"
                            { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 6017 "cfg.tab.c"
    break;

  case 439: /* brk_action: BREAK SEMICOLON  */
#line 2105 "cfg.y"
                            { mk_action0((yyval.action), BREAK_T);}
#line 6023 "cfg.tab.c"
    break;

  case 440: /* brk_action: cmd SEMICOLON  */
#line 2106 "cfg.y"
                                {(yyval.action)=(yyvsp[-1].action);}
#line 6029 "cfg.tab.c"
    break;

  case 441: /* brk_action: brk_if_cmd  */
#line 2107 "cfg.y"
                             {(yyval.action)=(yyvsp[0].action);}
#line 6035 "cfg.tab.c"
    break;

  case 442: /* brk_action: while_cmd  */
#line 2108 "cfg.y"
                            {(yyval.action)=(yyvsp[0].action);}
#line 6041 "cfg.tab.c"
    break;

  case 443: /* brk_action: foreach_cmd  */
#line 2109 "cfg.y"
                              {(yyval.action)=(yyvsp[0].action);}
#line 6047 "cfg.tab.c"
    break;

  case 444: /* brk_action: switch_cmd  */
#line 2110 "cfg.y"
                             {(yyval.action)=(yyvsp[0].action);}
#line 6053 "cfg.tab.c"
    break;

  case 445: /* brk_action: assign_cmd SEMICOLON  */
#line 2111 "cfg.y"
                                       {(yyval.action)=(yyvsp[-1].action);}
#line 6059 "cfg.tab.c"
    break;

  case 446: /* brk_action: SEMICOLON  */
#line 2112 "cfg.y"
                                              {(yyval.action)=0;}
#line 6065 "cfg.tab.c"
    break;

  case 447: /* brk_action: cmd error  */
#line 2113 "cfg.y"
                            { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 6071 "cfg.tab.c"
    break;

  case 448: /* brk_if_cmd: IF LPAREN exp RPAREN brk_stm  */
#line 2116 "cfg.y"
                                                                { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 6084 "cfg.tab.c"
    break;

  case 449: /* brk_if_cmd: IF LPAREN exp RPAREN brk_stm ELSE brk_stm  */
#line 2124 "cfg.y"
                                                                        { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-4].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 6097 "cfg.tab.c"
    break;

  case 450: /* if_cmd: IF LPAREN exp RPAREN stm  */
#line 2134 "cfg.y"
                                                                        { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 6110 "cfg.tab.c"
    break;

  case 451: /* if_cmd: IF LPAREN exp RPAREN stm ELSE stm  */
#line 2142 "cfg.y"
                                                                { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-4].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 6123 "cfg.tab.c"
    break;

  case 452: /* while_cmd: WHILE LPAREN exp RPAREN brk_stm  */
#line 2152 "cfg.y"
                                                        { mk_action2( (yyval.action), WHILE_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action));
									}
#line 6134 "cfg.tab.c"
    break;

  case 453: /* foreach_cmd: FOR LPAREN script_var IN script_var RPAREN brk_stm  */
#line 2160 "cfg.y"
                                                                   {
					if ((yyvsp[-4].specval)->type != PVT_SCRIPTVAR &&
					    (yyvsp[-4].specval)->type != PVT_AVP &&
						pv_type((yyvsp[-4].specval)->type) != PVT_JSON) {
						yyerror("\nfor-each statement: only \"var\", \"avp\" "
					            "and \"json\" iterators are supported!");
					}

					mk_action3( (yyval.action), FOR_EACH_T,
					            SCRIPTVAR_ST,
					            SCRIPTVAR_ST,
					            ACTIONS_ST,
					            (yyvsp[-4].specval),
					            (yyvsp[-2].specval),
					            (yyvsp[0].action));
					}
#line 6155 "cfg.tab.c"
    break;

  case 454: /* switch_cmd: SWITCH LPAREN script_var RPAREN LBRACE switch_stm RBRACE  */
#line 2178 "cfg.y"
                                                                                        {
											mk_action2( (yyval.action), SWITCH_T,
														SCRIPTVAR_ST,
														ACTIONS_ST,
														(yyvsp[-4].specval),
														(yyvsp[-1].action));
									}
#line 6167 "cfg.tab.c"
    break;

  case 455: /* switch_stm: case_stms default_stm  */
#line 2187 "cfg.y"
                                  { (yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 6173 "cfg.tab.c"
    break;

  case 456: /* switch_stm: case_stms  */
#line 2188 "cfg.y"
                                                { (yyval.action)=(yyvsp[0].action); }
#line 6179 "cfg.tab.c"
    break;

  case 457: /* case_stms: case_stms case_stm  */
#line 2190 "cfg.y"
                                        {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 6185 "cfg.tab.c"
    break;

  case 458: /* case_stms: case_stm  */
#line 2191 "cfg.y"
                                                {(yyval.action)=(yyvsp[0].action);}
#line 6191 "cfg.tab.c"
    break;

  case 459: /* case_stm: CASE snumber COLON brk_actions  */
#line 2194 "cfg.y"
                                         { mk_action2( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-2].intval),
													(yyvsp[0].action));
											}
#line 6202 "cfg.tab.c"
    break;

  case 460: /* case_stm: CASE snumber COLON  */
#line 2200 "cfg.y"
                                     { mk_action2( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-1].intval),
													NULL);
							}
#line 6213 "cfg.tab.c"
    break;

  case 461: /* case_stm: CASE STRING COLON brk_actions  */
#line 2206 "cfg.y"
                                                { mk_action2( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-2].strval),
													(yyvsp[0].action));
											}
#line 6224 "cfg.tab.c"
    break;

  case 462: /* case_stm: CASE STRING COLON  */
#line 2212 "cfg.y"
                                    { mk_action2( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-1].strval),
													NULL);
							}
#line 6235 "cfg.tab.c"
    break;

  case 463: /* default_stm: DEFAULT COLON brk_actions  */
#line 2220 "cfg.y"
                                       { mk_action1( (yyval.action), DEFAULT_T,
													ACTIONS_ST, (yyvsp[0].action));
									}
#line 6243 "cfg.tab.c"
    break;

  case 464: /* default_stm: DEFAULT COLON  */
#line 2223 "cfg.y"
                                { mk_action1( (yyval.action), DEFAULT_T, ACTIONS_ST, NULL); }
#line 6249 "cfg.tab.c"
    break;

  case 465: /* func_param: STRING  */
#line 2226 "cfg.y"
                   {
										elems[1].type = STR_ST;
										elems[1].u.data = (yyvsp[0].strval);
										(yyval.intval)=1;
										}
#line 6259 "cfg.tab.c"
    break;

  case 466: /* func_param: func_param COMMA STRING  */
#line 2231 "cfg.y"
                                          {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = STR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].strval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 6274 "cfg.tab.c"
    break;

  case 467: /* func_param: COMMA  */
#line 2241 "cfg.y"
                        {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NULLV_ST;
										elems[2].u.data = NULL;
										(yyval.intval)=2;
										}
#line 6286 "cfg.tab.c"
    break;

  case 468: /* func_param: COMMA STRING  */
#line 2248 "cfg.y"
                               {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = STR_ST;
										elems[2].u.data = (yyvsp[0].strval);
										(yyval.intval)=2;
										}
#line 6298 "cfg.tab.c"
    break;

  case 469: /* func_param: func_param COMMA  */
#line 2255 "cfg.y"
                                   {
										if ((yyvsp[-1].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-1].intval)+1].type = NULLV_ST;
										elems[(yyvsp[-1].intval)+1].u.data = NULL;
										(yyval.intval)=(yyvsp[-1].intval)+1;
										}
#line 6313 "cfg.tab.c"
    break;

  case 470: /* func_param: snumber  */
#line 2265 "cfg.y"
                          {
										elems[1].type = NUMBER_ST;
										elems[1].u.number = (yyvsp[0].intval);
										(yyval.intval)=1;
										}
#line 6323 "cfg.tab.c"
    break;

  case 471: /* func_param: COMMA snumber  */
#line 2270 "cfg.y"
                                {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NUMBER_ST;
										elems[2].u.number = (yyvsp[0].intval);
										(yyval.intval)=2;
										}
#line 6335 "cfg.tab.c"
    break;

  case 472: /* func_param: func_param COMMA snumber  */
#line 2277 "cfg.y"
                                           {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = NUMBER_ST;
										elems[(yyvsp[-2].intval)+1].u.number = (yyvsp[0].intval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 6350 "cfg.tab.c"
    break;

  case 473: /* func_param: script_var  */
#line 2287 "cfg.y"
                             {
										elems[1].type = SCRIPTVAR_ST;
										elems[1].u.data = (yyvsp[0].specval);
										(yyval.intval)=1;
										}
#line 6360 "cfg.tab.c"
    break;

  case 474: /* func_param: COMMA script_var  */
#line 2292 "cfg.y"
                                   {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = SCRIPTVAR_ST;
										elems[2].u.data = (yyvsp[0].specval);
										(yyval.intval)=2;
										}
#line 6372 "cfg.tab.c"
    break;

  case 475: /* func_param: func_param COMMA script_var  */
#line 2299 "cfg.y"
                                              {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = SCRIPTVAR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].specval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 6387 "cfg.tab.c"
    break;

  case 476: /* route_param: STRING  */
#line 2311 "cfg.y"
                    {
						route_elems[0].type = STRING_ST;
						route_elems[0].u.string = (yyvsp[0].strval);
						(yyval.intval)=1;
			}
#line 6397 "cfg.tab.c"
    break;

  case 477: /* route_param: snumber  */
#line 2316 "cfg.y"
                          {
						route_elems[0].type = NUMBER_ST;
						route_elems[0].u.number = (long)(yyvsp[0].intval);
						(yyval.intval)=1;
			}
#line 6407 "cfg.tab.c"
    break;

  case 478: /* route_param: NULLV  */
#line 2321 "cfg.y"
                        {
						route_elems[0].type = NULLV_ST;
						route_elems[0].u.data = 0;
						(yyval.intval)=1;
			}
#line 6417 "cfg.tab.c"
    break;

  case 479: /* route_param: script_var  */
#line 2326 "cfg.y"
                             {
						route_elems[0].type = SCRIPTVAR_ST;
						route_elems[0].u.data = (yyvsp[0].specval);
						(yyval.intval)=1;
			}
#line 6427 "cfg.tab.c"
    break;

  case 480: /* route_param: route_param COMMA STRING  */
#line 2331 "cfg.y"
                                           {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = STRING_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].strval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6442 "cfg.tab.c"
    break;

  case 481: /* route_param: route_param COMMA snumber  */
#line 2341 "cfg.y"
                                            {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NUMBER_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (void*)(long)(yyvsp[0].intval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6457 "cfg.tab.c"
    break;

  case 482: /* route_param: route_param COMMA script_var  */
#line 2351 "cfg.y"
                                               {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = SCRIPTVAR_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].specval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6472 "cfg.tab.c"
    break;

  case 483: /* route_param: route_param COMMA NULLV  */
#line 2361 "cfg.y"
                                          {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NULLV_ST;
							route_elems[(yyvsp[-2].intval)].u.data = 0;
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6487 "cfg.tab.c"
    break;

  case 484: /* async_func: ID LPAREN RPAREN  */
#line 2373 "cfg.y"
                             {
				const acmd_export_t* acmd_tmp=find_mod_acmd_export_t((yyvsp[-2].strval));
				if (acmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-2].strval));
					(yyval.action)=0;
				}else{
					if (check_acmd_call_params(acmd_tmp,elems,0)<0) {
						yyerrorf("too few parameters "
							"for command <%s>\n", (yyvsp[-2].strval));
						(yyval.action)=0;
					} else {
						elems[0].type = ACMD_ST;
						elems[0].u.data_const = acmd_tmp;
						mk_action_((yyval.action), AMODULE_T, 1, elems);
					}
				}
			}
#line 6510 "cfg.tab.c"
    break;

  case 485: /* async_func: ID LPAREN func_param RPAREN  */
#line 2391 "cfg.y"
                                                      {
				const acmd_export_t* acmd_tmp=find_mod_acmd_export_t((yyvsp[-3].strval));
				if (acmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-3].strval));
					(yyval.action)=0;
				}else{
					rc = check_acmd_call_params(acmd_tmp,elems,(yyvsp[-1].intval));
					switch (rc) {
					case -1:
						yyerrorf("too few parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -2:
						yyerrorf("too many parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -3:
						yyerrorf("mandatory parameter "
							" omitted for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					default:
						elems[0].type = ACMD_ST;
						elems[0].u.data_const = acmd_tmp;
						mk_action_((yyval.action), AMODULE_T, (yyvsp[-1].intval)+1, elems);
					}
				}
			}
#line 6546 "cfg.tab.c"
    break;

  case 486: /* async_func: ID LPAREN error RPAREN  */
#line 2422 "cfg.y"
                                                 {
				(yyval.action)=0;
				yyerrorf("bad arguments for command <%s>", (yyvsp[-3].strval));
			}
#line 6555 "cfg.tab.c"
    break;

  case 487: /* async_func: ID error  */
#line 2426 "cfg.y"
                                   {
				(yyval.action)=0;
				yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 6564 "cfg.tab.c"
    break;

  case 488: /* cmd: ASSERT LPAREN exp COMMA STRING RPAREN  */
#line 2432 "cfg.y"
                                                 {
			mk_action2( (yyval.action), ASSERT_T, EXPR_ST, STRING_ST, (yyvsp[-3].expr), (yyvsp[-1].strval));
			}
#line 6572 "cfg.tab.c"
    break;

  case 489: /* cmd: DROP  */
#line 2435 "cfg.y"
                                                 {mk_action0( (yyval.action), DROP_T); }
#line 6578 "cfg.tab.c"
    break;

  case 490: /* cmd: DROP LPAREN RPAREN  */
#line 2436 "cfg.y"
                                     {mk_action0( (yyval.action), DROP_T); }
#line 6584 "cfg.tab.c"
    break;

  case 491: /* cmd: EXIT  */
#line 2437 "cfg.y"
                                                 {mk_action0( (yyval.action), EXIT_T); }
#line 6590 "cfg.tab.c"
    break;

  case 492: /* cmd: EXIT LPAREN RPAREN  */
#line 2438 "cfg.y"
                                     {mk_action0( (yyval.action), EXIT_T); }
#line 6596 "cfg.tab.c"
    break;

  case 493: /* cmd: RETURN script_var  */
#line 2440 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, SCRIPTVAR_ST, (void*)(yyvsp[0].specval)); }
#line 6602 "cfg.tab.c"
    break;

  case 494: /* cmd: RETURN LPAREN script_var RPAREN  */
#line 2442 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, SCRIPTVAR_ST, (void*)(yyvsp[-1].specval)); }
#line 6608 "cfg.tab.c"
    break;

  case 495: /* cmd: RETURN snumber  */
#line 2444 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)(yyvsp[0].intval)); }
#line 6614 "cfg.tab.c"
    break;

  case 496: /* cmd: RETURN LPAREN snumber RPAREN  */
#line 2446 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)(yyvsp[-1].intval)); }
#line 6620 "cfg.tab.c"
    break;

  case 497: /* cmd: RETURN LPAREN RPAREN  */
#line 2448 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)1); }
#line 6626 "cfg.tab.c"
    break;

  case 498: /* cmd: RETURN  */
#line 2449 "cfg.y"
                                                 {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)1); }
#line 6632 "cfg.tab.c"
    break;

  case 499: /* cmd: LOG_TOK LPAREN STRING RPAREN  */
#line 2450 "cfg.y"
                                                {mk_action2( (yyval.action), LOG_T, NUMBER_ST,
													STRING_ST,(void*)4,(yyvsp[-1].strval));
									}
#line 6640 "cfg.tab.c"
    break;

  case 500: /* cmd: LOG_TOK LPAREN snumber COMMA STRING RPAREN  */
#line 2453 "cfg.y"
                                                                {mk_action2( (yyval.action), LOG_T,
																NUMBER_ST,
																STRING_ST,
																(void*)(yyvsp[-3].intval),
																(yyvsp[-1].strval));
												}
#line 6651 "cfg.tab.c"
    break;

  case 501: /* cmd: LOG_TOK error  */
#line 2459 "cfg.y"
                                { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6657 "cfg.tab.c"
    break;

  case 502: /* cmd: LOG_TOK LPAREN error RPAREN  */
#line 2460 "cfg.y"
                                              { (yyval.action)=0; yyerror("bad log"
									"argument"); }
#line 6664 "cfg.tab.c"
    break;

  case 503: /* cmd: ERROR LPAREN STRING COMMA STRING RPAREN  */
#line 2462 "cfg.y"
                                                          {mk_action2( (yyval.action), ERROR_T,
																STRING_ST,
																STRING_ST,
																(yyvsp[-3].strval),
																(yyvsp[-1].strval));
												  }
#line 6675 "cfg.tab.c"
    break;

  case 504: /* cmd: ERROR error  */
#line 2468 "cfg.y"
                              { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6681 "cfg.tab.c"
    break;

  case 505: /* cmd: ERROR LPAREN error RPAREN  */
#line 2469 "cfg.y"
                                            { (yyval.action)=0; yyerror("bad error"
														"argument"); }
#line 6688 "cfg.tab.c"
    break;

  case 506: /* cmd: ROUTE LPAREN route_name_var RPAREN  */
#line 2471 "cfg.y"
                                                        {
						mk_action2( (yyval.action), ROUTE_T, (yyvsp[-1].intval), 0, rn_tmp.data, 0);
					}
#line 6696 "cfg.tab.c"
    break;

  case 507: /* cmd: ROUTE LPAREN route_name_var COMMA route_param RPAREN  */
#line 2475 "cfg.y"
                                                                        {
						if ((yyvsp[-1].intval) <= 0) yyerror("too many route parameters");

						/* duplicate the list */
						a_tmp = pkg_malloc((yyvsp[-1].intval) * sizeof(action_elem_t));
						if (!a_tmp) {
							yyerror("no more pkg memory");
							YYABORT;
						}
						memcpy(a_tmp, route_elems, (yyvsp[-1].intval)*sizeof(action_elem_t));

						mk_action3( (yyval.action), ROUTE_T, (yyvsp[-3].intval),	/* route idx */
							NUMBER_ST,					/* number of params */
							SCRIPTVAR_ST,				/* parameters */
							rn_tmp.data,
							(void*)(long)(yyvsp[-1].intval),
							(void*)a_tmp);
					}
#line 6719 "cfg.tab.c"
    break;

  case 508: /* cmd: ROUTE error  */
#line 2494 "cfg.y"
                              { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6725 "cfg.tab.c"
    break;

  case 509: /* cmd: ROUTE LPAREN error RPAREN  */
#line 2495 "cfg.y"
                                            { (yyval.action)=0; yyerror("bad route"
						"argument"); }
#line 6732 "cfg.tab.c"
    break;

  case 510: /* cmd: ID LPAREN RPAREN  */
#line 2497 "cfg.y"
                                        {
								const cmd_export_t* cmd_tmp=find_cmd_export_t((yyvsp[-2].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-2].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-2].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-2].strval));
									}
									(yyval.action)=0;
								}else{
									if (check_cmd_call_params(cmd_tmp,elems,0)<0) {
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-2].strval));
										(yyval.action)=0;
									} else {
										elems[0].type = CMD_ST;
										elems[0].u.data_const = cmd_tmp;
										mk_action_((yyval.action), CMD_T, 1, elems);
									}
								}
							}
#line 6760 "cfg.tab.c"
    break;

  case 511: /* cmd: ID LPAREN func_param RPAREN  */
#line 2520 "cfg.y"
                                                {
								const cmd_export_t* cmd_tmp=find_cmd_export_t((yyvsp[-3].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-3].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-3].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-3].strval));
									}
									(yyval.action)=0;
								}else{
									rc = check_cmd_call_params(cmd_tmp,elems,(yyvsp[-1].intval));
									switch (rc) {
									case -1:
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -2:
										yyerrorf("too many parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -3:
										yyerrorf("mandatory parameter "
											"omitted for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									default:
										elems[0].type = CMD_ST;
										elems[0].u.data_const = cmd_tmp;
										mk_action_((yyval.action), CMD_T, (yyvsp[-1].intval)+1, elems);
									}
								}
							}
#line 6801 "cfg.tab.c"
    break;

  case 512: /* cmd: ID LPAREN error RPAREN  */
#line 2556 "cfg.y"
                                         { (yyval.action)=0; yyerrorf("bad arguments for "
												"command <%s>", (yyvsp[-3].strval)); }
#line 6808 "cfg.tab.c"
    break;

  case 513: /* cmd: ID error  */
#line 2558 "cfg.y"
                           { (yyval.action)=0;
			yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 6816 "cfg.tab.c"
    break;

  case 514: /* cmd: XDBG LPAREN STRING RPAREN  */
#line 2561 "cfg.y"
                                            {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 6823 "cfg.tab.c"
    break;

  case 515: /* cmd: XDBG LPAREN folded_string RPAREN  */
#line 2563 "cfg.y"
                                                   {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 6830 "cfg.tab.c"
    break;

  case 516: /* cmd: XLOG LPAREN STRING RPAREN  */
#line 2565 "cfg.y"
                                            {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 6837 "cfg.tab.c"
    break;

  case 517: /* cmd: XLOG LPAREN folded_string RPAREN  */
#line 2567 "cfg.y"
                                                   {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 6844 "cfg.tab.c"
    break;

  case 518: /* cmd: XLOG LPAREN STRING COMMA STRING RPAREN  */
#line 2569 "cfg.y"
                                                         {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 6851 "cfg.tab.c"
    break;

  case 519: /* cmd: XLOG LPAREN STRING COMMA folded_string RPAREN  */
#line 2571 "cfg.y"
                                                                {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 6858 "cfg.tab.c"
    break;

  case 520: /* cmd: ASYNC_TOKEN LPAREN async_func COMMA route_name RPAREN  */
#line 2573 "cfg.y"
                                                                        {
				rt_ref = ref_script_route_by_name( (yyvsp[-1].strval), sroutes->request,
					RT_NO, REQUEST_ROUTE, 0);
				if (rt_ref==NULL) yyerror("fail to create route reference");
				mk_action2((yyval.action), ASYNC_T, ACTIONS_ST, ROUTE_REF_ST,
						(yyvsp[-3].action), (void*)rt_ref);
				}
#line 6870 "cfg.tab.c"
    break;

  case 521: /* cmd: ASYNC_TOKEN LPAREN async_func COMMA route_name COMMA NUMBER RPAREN  */
#line 2580 "cfg.y"
                                                                                     {
				rt_ref = ref_script_route_by_name( (yyvsp[-3].strval), sroutes->request,
					RT_NO, REQUEST_ROUTE, 0);
				if (rt_ref==NULL) yyerror("fail to create route reference");
				mk_action3((yyval.action), ASYNC_T, ACTIONS_ST, ROUTE_REF_ST, NUMBER_ST,
						(yyvsp[-5].action), (void*)rt_ref, (void*)(long)(yyvsp[-1].intval));
				}
#line 6882 "cfg.tab.c"
    break;

  case 522: /* cmd: LAUNCH_TOKEN LPAREN async_func COMMA route_name COMMA STRING RPAREN  */
#line 2587 "cfg.y"
                                                                                      {
				rt_ref = ref_script_route_by_name( (yyvsp[-3].strval), sroutes->request,
					RT_NO, REQUEST_ROUTE, 0);
				if (rt_ref==NULL) yyerror("fail to create route reference");
				mk_action3((yyval.action), LAUNCH_T, ACTIONS_ST, ROUTE_REF_ST, STRING_ST,
						(yyvsp[-5].action), (void*)rt_ref, (yyvsp[-1].strval));
				}
#line 6894 "cfg.tab.c"
    break;

  case 523: /* cmd: LAUNCH_TOKEN LPAREN async_func COMMA route_name RPAREN  */
#line 2594 "cfg.y"
                                                                         {
				rt_ref = ref_script_route_by_name( (yyvsp[-1].strval), sroutes->request,
					RT_NO, REQUEST_ROUTE, 0);
				if (rt_ref==NULL) yyerror("fail to create route reference");
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, ROUTE_REF_ST,
						(yyvsp[-3].action), (void*)rt_ref);
				}
#line 6906 "cfg.tab.c"
    break;

  case 524: /* cmd: LAUNCH_TOKEN LPAREN async_func RPAREN  */
#line 2601 "cfg.y"
                                                        {
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, ROUTE_REF_ST,
						(yyvsp[-1].action), (void*)NULL);
				}
#line 6915 "cfg.tab.c"
    break;


#line 6919 "cfg.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 2608 "cfg.y"


static inline void ALLOW_UNUSED warn(char* s)
{
	LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
}

static void yyerror(char* s)
{
	cfg_dump_backtrace();
	LM_CRIT("parse error in %s:%d:%d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
	_cfg_dump_context(get_cfg_file_name, line, startcolumn, column, 1);
	cfg_errors++;
}

#define ERROR_MAXLEN 1024
static void yyerrorf(char *fmt, ...)
{
	char *tmp = pkg_malloc(ERROR_MAXLEN);
	va_list ap;
	va_start(ap, fmt);

	vsnprintf(tmp, ERROR_MAXLEN, fmt, ap);
	yyerror(tmp);

	pkg_free(tmp);
	va_end(ap);
}


static struct socket_id* mk_listen_id(char* host, enum sip_protos proto,
																	int port)
{
	struct socket_id* l;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0){
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		memset(l, 0, sizeof(*l));
		l->name     = host;
		l->proto    = proto;
		l->port     = port;
	}

	return l;
}

static struct socket_id* mk_listen_id_range(char* host, enum sip_protos proto, struct port_range *pr)
{
	int port;
	struct socket_id *sid, *first_sid = NULL;
	if (!pr)
		return mk_listen_id(host, proto, 0);
	while (pr) {
		for (port = pr->max; port >= pr->min; port--) {
			sid = mk_listen_id(host, proto, port);
			if (!sid)
				return first_sid;
			sid->next = first_sid;
			first_sid = sid;
		}
		pr = pr->next;
	}
	return first_sid;
}

static void fill_socket_id(struct listen_param *param, struct socket_id *s)
{
	int warn;
	struct socket_id *socket;
	while (s) {
		s->flags |= param->flags;
		s->workers = param->workers;
		s->auto_scaling_profile = param->auto_scaling_profile;
		s->tag = param->tag;
		if (param->socket) {
			socket = param->socket;
			param->socket = param->socket->next;
			set_listen_id_adv(s, socket->name, socket->port);
			pkg_free(socket);
		} else if (!warn) {
			LM_WARN("inconsistent port range with advertised ports - skipping advertised\n");
			warn = 1;
		}
		s = s->next;
	}
	/* free remaining sockets, if any */
	while (param->socket) {
		if (!warn) {
			LM_WARN("inconsistent port range with advertised ports - too many adverised\n");
			warn = 1;
		}
		socket = param->socket->next;
		param->socket = param->socket->next;
		pkg_free(socket);
	}
}

static struct multi_str *new_string(char *s)
{
	struct multi_str *ms = pkg_malloc(sizeof(struct multi_str));
	if (!ms) {
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		ms->s    = s;
		ms->next = NULL;
	}
	return ms;
}

static struct port_range* mk_port_range(int min, int max)
{
	struct port_range *pr = pkg_malloc(sizeof *pr);
	if (pr) {
		memset(pr, 0, sizeof *pr);
		pr->min = min;
		pr->max = max;
		pr->next = NULL;
	} else {
		LM_CRIT("cfg. parser: out of memory.\n");
	}
	return pr;
}

static struct socket_id* set_listen_id_adv(struct socket_id* sock,
											char *adv_name,
											int adv_port)
{
	sock->adv_name=adv_name;
	sock->adv_port=adv_port;
	return sock;
}

static int parse_ipnet(char *in, int len, struct net **ipnet)
{
	char *p = NULL;
	str ip_s, mask_s;
	struct ip_addr *ip = NULL, *mask = NULL, *ip_tmp;
	int af;
	unsigned int bitlen;

	p = q_memchr(in, '.', len);
	if (p)
		af = AF_INET;
	else if (q_memchr(in, ':', len)) {
		af = AF_INET6;
	} else {
		LM_ERR("Not an IP");
		return -1;
	}

	p = q_memchr(in, '/', len);
	if (!p) {
		LM_ERR("No netmask\n");
		return -1;
	}
	ip_s.s = in;
	ip_s.len = p - in;

	mask_s.s = p + 1;
	mask_s.len = len - ip_s.len - 1;
	if (!mask_s.s || mask_s.len == 0) {
		LM_ERR("Empty netmask\n");
		return -1;
	}

	ip_tmp = (af == AF_INET) ? str2ip(&ip_s) : str2ip6(&ip_s);
	if (!ip_tmp) {
		LM_ERR("Invalid IP\n");
		return -1;
	}
	ip = pkg_malloc(sizeof *ip);
	if (!ip) {
		LM_CRIT("No more pkg memory\n");
		return -1;
	}
	memcpy(ip, ip_tmp, sizeof *ip);

	p = (af == AF_INET) ? q_memchr(p, '.', len-(p-in)+1) : q_memchr(p, ':', len-(p-in)+1);
	if (p) {
		ip_tmp = (af == AF_INET) ? str2ip(&mask_s) : str2ip6(&mask_s);
		if (!ip_tmp) {
			LM_ERR("Invalid netmask\n");
			return -1;
		}
		mask = pkg_malloc(sizeof *mask);
		if (!mask) {
			LM_CRIT("No more pkg memory\n");
			return -1;
		}
		memcpy(mask, ip_tmp, sizeof *mask);

		*ipnet = mk_net(ip, mask);
	} else {
		if (str2int(&mask_s, &bitlen) < 0) {
			LM_ERR("Invalid netmask bitlen\n");
			return -1;
		}

		*ipnet = mk_net_bitlen(ip, bitlen);
	}

	pkg_free(ip);
	pkg_free(mask);

	if (*ipnet == NULL)
			return -1;

	return 0;
}
